' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' ComalOCR.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        with:  Microsoft Office Standard Edition 2003 (SP2) Trial (Genuine).
'        Date:  28th February 2006.

' This demo needs a file called test.tif in the C: (Hard Drive) folder.

struct OCRInfo, _
languageid as long, _
words as long, _
characters as long, _
fonts as long, _
images as long, _
bitsperpixel as long, _
pixelwidth as long, _
pixelheight as long, _
xdpi as long, _
ydpi as long, _
compression as long

struct PageInfo, _
reserved as long, _
lineid as long, _
regionid as long, _
fontid as long, _
id as long

struct RectangleInfo, _
left as long, _
top as long, _
right as long, _
bottom as long

global FALSE, TRUE
global ocrrtn,rtn

FALSE=0
TRUE=1

ocrrtn=FALSE

open "comalocr.dll" for dll as #comalocr

' Open a TIF (Picture and Text) file. It can be a normal picture or one scanned for OCR purposes.
ocrrtn=OCROpen("C:\\Test.TIF")
if ocrrtn=TRUE then
' Perform the actual OCR - Scan the TIF file for text and picture information.
rtn=OCRPerformOCR()
if rtn=TRUE then

' Get the Text from the first page.
rtn=OCRGetText(0)
print WinString(rtn)
print

' Get general OCR Information.
rtn=OCRGetOCRInfo(0)
print "Language ID: "+Str$(OCRInfo.languageid.struct)
print "Number of Words: "+Str$(OCRInfo.words.struct)
print "Number of Characters: "+Str$(OCRInfo.characters.struct)
print "Number of Fonts: "+Str$(OCRInfo.fonts.struct)
print "Number of Images: "+Str$(OCRInfo.images.struct)
print "Bits Per Pixel: "+Str$(OCRInfo.bitsperpixel.struct)
print "Pixel Width: "+Str$(OCRInfo.pixelwidth.struct)
print "Pixel Height: "+Str$(OCRInfo.pixelheight.struct)
print "XDPI: "+Str$(OCRInfo.xdpi.struct)
print "YDPI: "+Str$(OCRInfo.ydpi.struct)
print "Compression: "+Str$(OCRInfo.compression.struct)
print

' Get page Information.
for count=0 to 6
print
rtn=OCRGetPageInfo(0,count)
print "Word "+str$(count)+" - ID: "+Str$(PageInfo.id.struct)
print "Word "+str$(count)+" - Line ID: "+Str$(PageInfo.lineid.struct)
print "Word "+str$(count)+" - Region ID: "+Str$(PageInfo.regionid.struct)
print "Word "+str$(count)+" - Font ID: "+Str$(PageInfo.fontid.struct)
rtn=OCRGetWord(0,count)
print "Actual Word: "+WinString(rtn)
print
rtn=OCRGetRectangleInfo(0,count,0)
print "Rectangle - Left: "+Str$(RectangleInfo.left.struct)
print "Rectangle - Top: "+Str$(RectangleInfo.top.struct)
print "Rectangle - Right: "+Str$(RectangleInfo.right.struct)
print "Rectangle - Bottom: "+Str$(RectangleInfo.bottom.struct)
next count

rtn=OCRSaveAsMDI("C:\\Test.mdi")

end if
rtn=OCRClose()
ocrrtn=FALSE
end if

close #comalocr
end

function OCRClose()
calldll #comalocr,"OCR_Close",OCRClose as Long
end function

function OCRPerformOCR()
calldll #comalocr,"OCR_PerformOCR",OCRPerformOCR as Long
end function

function OCRGetText(pageNumber)
calldll #comalocr,"OCR_GetText",pageNumber as long,OCRGetText as Long
end function

function OCRGetWord(pageNumber,wordNumber)
calldll #comalocr,"OCR_GetWord",pageNumber as long,wordNumber as long,OCRGetWord as Long
end function

function OCRGetOCRInfo(pageNumber)
calldll #comalocr,"OCR_GetOCRInfo",pageNumber as long,OCRInfo as struct,OCRGetOCRInfo as Long
end function

function OCRGetPageInfo(pageNumber,wordNumber)
calldll #comalocr,"OCR_GetPageInfo",pageNumber as long,wordNumber as long,PageInfo as struct,OCRGetPageInfo as Long
end function

function OCRGetRectangleInfo(pageNumber,wordNumber,rectangleNumber)
calldll #comalocr,"OCR_GetRectangleInfo",pageNumber as long,wordNumber as long,RectangleNumber as long,RectangleInfo as struct,OCRGetRectangleInfo as Long
end function

function OCRSaveAsMDI(fileName$)
calldll #comalocr,"OCR_SaveAsMDI",fileName$ as ptr,OCRSaveAsMDI as long
end function

function OCROpen(fileName$)
calldll #comalocr,"OCR_Open",fileName$ as ptr,OCROpen as long
end function

