' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' ComalSpeech.dll is a Dynamic Linked Library written by me,
' John White, for myself and any programming language that
' can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   On:  Windows XP (SP2) Home Edition (Genuine).
'        Date:  10th November 2006.

nomainwin

global FALSE, TRUE, OFF, ONN, NO, YES
global sartn,sa2rtn,sa3rtn,sa4rtn,voices

global SPF.DEFAULT, SPF.ASYNC, SPF.PURGEBEFORESPEAK, SPF.IS.FILENAME, SPF.IS.XML, SPF.IS.NOT.XML
global winHandle
global WM.DESTROY,WM.QUIT

FALSE=0
TRUE=1
OFF=0
ONN=1
NO=0
YES=1

sartn=FALSE
sa2rtn=FALSE
sa3rtn=FALSE
sa4rtn=FALSE
voices=0

SPF.DEFAULT=0
SPF.ASYNC=1
SPF.PURGEBEFORESPEAK=2
SPF.IS.FILENAME=4
SPF.IS.XML=8
SPF.IS.NOT.XML=16

WindowWidth=710
WindowHeight=150
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

button #Form.B1, "Speak Async.", [BC1], ul, 6, 6, 120, 30
button #Form.B2, "Skip 2 Sentences", [BC2], ul, 146, 6, 120, 30
button #Form.B3, "Pause Speech", [BC3], ul, 286, 6, 120, 30
button #Form.B4, "Resume Speech", [BC4], ul, 426, 6, 120, 30
button #Form.B5, "Speak File", [BC5], ul, 566, 6, 120, 30
button #Form.B6, "Enum Voices", [BC6], ul, 6, 66, 120, 30
button #Form.B7, "Set/Get Volume/Rate", [BC7], ul, 146, 66, 120, 30
button #Form.B8, "Display UI", [BC8], ul, 286, 66, 120, 30
button #Form.B9, "Get Output Device", [BC9], ul, 426, 66, 120, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "COMAL - COM Access Library." for dialog as #Form
#Form "trapclose [quit.Form]"

open "comalspeech.dll" for dll as #comalspeech

' Must be called once, to initialize COM.
rtn=VOICE1Open()

wait

[BC1]
'rtn=VOICE1SetVolume(40)
'rtn=VOICE1SetRate(50)
'rtn=VOICE1SetVoice(2)
rtn=VOICE1Speak("Sentence 1. Sentence 2. Sentence 3. Sentence 4. Sentence 5. Sentence 6. Sentence 7. Sentence 8. Sentence 9. Sentence 10. Sentence 11. Sentence 12. Sentence 13. Sentence 14.",SPF.ASYNC)
'call LetSpeechComplete
wait

sub LetSpeechComplete
' WaitUntilDone(-1) waits for the Async speech to complete, which means all buttons will be disabled during the speech.
' Using a Positive value, in MilliSeconds (i.e. 1000 = 1 Second), means the Async speech will only be spoken for that
' amount of time - If the speech completes within that time then the speech was spoken of course, but if the speech wasn't
' spoken within that time it timed out (was cut short, so no chance to speak the rest of the string).
x=0
while x=0
rtn=VOICE1WaitUntilDone(-1)
if rtn=0 then x=1
wend
end sub

[BC2]
rtn=VOICE1SkipSentence(2)
wait

[BC3]
rtn=VOICE1Pause()
wait

[BC4]
rtn=VOICE1Resume()
wait

[BC5]
' Read a normal .txt file
rtn=VOICE1Speak("C:\\Test.txt",SPF.ASYNC OR SPF.IS.FILENAME OR SPF.IS.NOT.XML)
wait

[BC6]
' Enumerate each installed TTS Voice.
voices=SAPI5EnumVoices()
notice "#Voices: "+str$(voices)
for z=0 to voices-1
rtn=SAPI5GetVoiceName(z)
notice WinString(rtn)
next
wait

[BC7]
' Set/Get the Volume and Rate. -1 will be returned, by comalspeech, if the Volume (or Rate) could not be retreived.
'
'rtn=VOICE1SetVolume(40)
'rtn=VOICE1SetRate(50)
rtn=VOICE1GetVolume()
notice "#Volume: "+str$(rtn)
rtn=VOICE1GetRate()
notice "#Rate: "+str$(rtn)
wait

[BC8]
' Internally checks if the User Interface is supported (rtn = 0). If it is it gets displayed. At this time only AudioVolume
' is supported (due to the complexities of converting SAPI code into C code and then into DispHelper code).
hWnd=hwnd(#Form)
rtn=SAPI5DisplayUI(hWnd,"","AudioVolume")
wait

[BC9]
' Get the Output (names of the) Audio Device(s) installed on this computer.
rtn=SAPI5GetOutput(0)
notice WinString(rtn)

' Set the Output Audio Device. Note well: At this time I have not tested this function due to me not having a Test-Computer
' around me that has 2 Sound Cards inside it. It is here for further testing/debugging purposes only.
'
' SAPI5GetOutput() must be called before SAPI5SetOutput() as the info from SAPI5GetOutput() is indexed internally.
'rtn=SAPI5GetOutput(1)
wait

[quit.Form]
' Must accompany a VOICE1Open() command.
rtn=VOICE1Close()
close #Form
close #comalspeech
end

function VOICE1Close()
calldll #comalspeech,"VOICE1_Close",VOICE1Close as Long
end function

function VOICE1Open()
calldll #comalspeech,"VOICE1_Open",VOICE1Open as Long
end function

function VOICE1Speak(phrase$,flags)
calldll #comalspeech,"VOICE1_Speak",phrase$ as ptr,flags as long,VOICE1Speak as Long
end function

function VOICE1GetVolume()
calldll #comalspeech,"VOICE1_GetVolume",VOICE1GetVolume as Long
end function

function VOICE1SetVolume(volume)
calldll #comalspeech,"VOICE1_SetVolume",volume as long,VOICE1SetVolume as Long
end function

function VOICE1GetRate()
calldll #comalspeech,"VOICE1_GetRate",VOICE1GetRate as Long
end function

function VOICE1SetRate(rate)
calldll #comalspeech,"VOICE1_SetRate",rate as long,VOICE1SetRate as Long
end function

function VOICE1Pause()
calldll #comalspeech,"VOICE1_Pause",VOICE1Pause as Long
end function

function VOICE1Resume()
calldll #comalspeech,"VOICE1_Resume",VOICE1Resume as Long
end function

function VOICE1SkipSentence(skipValue)
calldll #comalspeech,"VOICE1_SkipSentence",skipValue as long,VOICE1SkipSentence as Long
end function

function VOICE1WaitUntilDone(milliSeconds)
calldll #comalspeech,"VOICE1_WaitUntilDone",milliSeconds as long,VOICE1WaitUntilDone as Long
end function

function VOICE1SetVoice(voiceNumber)
calldll #comalspeech,"VOICE1_SetVoice",voiceNumber as long,VOICE1SetVoice as Long
end function

function SAPI5DisplayUI(windowHandle,windowTitle$,userInterface$)
calldll #comalspeech,"SAPI5_DisplayUI",windowHandle as long,windowTitle$ as ptr,userInterface$ as ptr,SAPI5DisplayUI as Long
end function

function SAPI5CountVoices()
calldll #comalspeech,"SAPI5_CountVoices",SAPI5CountVoices as Long
end function

function SAPI5GetOutput(index)
calldll #comalspeech,"SAPI5_GetOutput",index as long,SAPI5GetOutput as Long
end function

function SAPI5EnumVoices()
calldll #comalspeech,"SAPI5_EnumVoices",SAPI5EnumVoices as Long
end function

function SAPI5GetVoiceName(voiceNumber)
calldll #comalspeech,"SAPI5_GetVoiceName",voiceNumber as long,SAPI5GetVoiceName as Long
end function

function SAPI5GetVoicePriority()
calldll #comalspeech,"SAPI5_GetVoicePriority",SAPI5GetVoicePriority as Long
end function

