' tts.dll (Text-To-Speech) and ttw.dll (Text-To-WAV) are
' Dynamic Linked Libraries written by me, John White, for
' myself and any programming language that can utilize them.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested   on:  Windows XP (SP2) Home Edition (Genuine).
'        with:  Microsoft SAPI4 and various Lernout & Hauspie TTS Engines.
'        Date:  19th December 2005.

' Constants
TEXT.BUFFER.SIZE=5000
USE.TEXT=0
CLEAR.TEXT.BUFFER=1
NEW.TTS.ALWAYS=1
USE.DEFAULT.VOLUME=0
USE.DEFAULT.PITCH=0
USE.DEFAULT.SPEED=0

' GLOBAL Variables
global rtn,voiceTotal,vdPtr,currentVoice,volume,pitch,speed

rtn=0
voiceTotal=0
vdPtr=0
currentVoice=0
volume=0
pitch=0
speed=0

' Open tts.dll
open "tts.dll" for DLL as #tts
ttsOpen=1

' Open ttw.dll
open "ttw.dll" for DLL as #ttw
ttwOpen=1

' Initialize Speech. THIS MUST BE CALLED (It only needs to be called here, once).
rtn=BeginSpeech(TEXT.BUFFER.SIZE)
if rtn=1 then

' Get the number of Voices (2 Per TTS Engine).
voiceTotal=CountVoices()
if voiceTotal>0 then

' Store the Voice Data (Name, Age, etc) from each Voice in a TTS Engine.
rtn=EnumVoiceData()

' Get Voice Data for the Current Voice.
vdPtr=GetVoiceData(currentVoice)
if vdPtr<>0 then call ShowData    ' Show the Voice Data information.

' Speak and then Save some text as a WAV file.
greeting$="Hello all you Liberty Basic users"
fname$="c:\test.wav"
rtn=SpeakString(USE.TEXT,greeting$,CLEAR.TEXTSPEECH.BUFFER,currentVoice,NEW.TTS.ALWAYS,USE.DEFAULT.VOLUME,volume,USE.DEFAULT.PITCH,pitch,USE.DEFAULT.SPEED,speed)
rtn=SaveWAVFile(fname$,currentVoice,greeting$)
end if

' Un-Initialize the internal memory buffers, etc. THIS MUST BE CALLED.
rtn=EndSpeech()
end if

if ttwOpen=1 then close #ttw
if ttsOpen=1 then close #tts

END

sub ShowData
print "Voices: "+str$(voiceTotal)
print "Manufacturer: "+winstring(vdPtr)
print "Product: "+winstring(vdPtr+256)
print "Mode: "+winstring(vdPtr+512)
print "Name Of Person: "+winstring(vdPtr+768)
print "Style Of Voice: "+winstring(vdPtr+1024)
print "Dialect: "+winstring(vdPtr+1280)
print "Gender: "+winstring(vdPtr+1344)
print "Age: "+winstring(vdPtr+1360)
end sub

function BeginSpeech(bufSize)
calldll #tts,"Begin_Speech",bufSize as long,BeginSpeech as long
end function

function CountVoices()
calldll #tts,"Count_Voices",CountVoices as long
end function

function EnumVoiceData()
calldll #tts,"Enum_VoiceData",EnumVoiceData as long
end function

function GetVoiceData(index)
calldll #tts,"Get_VoiceData",index as long,GetVoiceData as long
end function

function SpeakString(uvt,textAdr$,clearBuf,voiceNumber,delKeep,useV,Volume,useP,Pitch,useS,Speed)
calldll #tts,"Speak_String",uvt as long,textAdr$ as ptr,clearBuf as long,voiceNumber as long,delKeep as long,useV as long,Volume as long,useP as long,Pitch as long,useS as long,Speed as long,SpeakString as long
end function

function EndSpeech()
calldll #tts,"End_Speech",EndSpeech as long
end function

function SaveWAVFile(fnameAdr$,voiceNumber,textAdr$)
calldll #ttw,"Save_WAVFile",fnameAdr$ as ptr,voiceNumber as long,textAdr$ as ptr,SaveWAVFile as long
end function

