' WebCam.dll is a Dynamic Linked Library written by me, John White,
' for myself and any programming language that can utilize it.
'
' Website: http://www.yoingco.com/
'   Email: john@yoingco.com
'
' Tested      on:  Windows XP (SP2) Home Edition (Genuine).
'        WebCams:  Trust - 120 SPACE@CAM.
'                  VIMICRO USB PC Camera - Does not like a 1Gb capture file.
'                  AIPTEK (STMicroelectronics) Dual-mode camera
'                  Logitech QuickCam Chat #2
'
'           Date:  19th December 2005.

' Acknowledgements of Source Codes go to - Callum Lowcay for his VidCapLB
'                                          Brent Thorn for his WMLiberty
' Both of these codes were look at for Ideas and Source Code in general whilst writing WebCam.BAS.

' Read this source code's comments before even executing it, as it contain functions that
' might loop - If you do not know which functions loop you might not know how to stop them.
' Stopping them by pressing the ESC button or one of their Stop buttons will do the trick.

nomainwin

struct WCData, _
biSize as long, _
biWidth as long, _
biHeight as long, _
biPlanes as short, _
biBitCount as short, _
biCompression as long, _
biSizeImage as long, _
biXPelsPerMeter as long, _
biYPelsPerMeter as long, _
biClrUsed as long, _
biClrImportant as long, _
wFormatTag as short, _
nChannels as short, _
nSamplesPerSec as long, _
nAvgBytesPerSec as long, _
nBlockAlign as short, _
wBitsPerSample as short, _
cbSize as short

global winHandle,wcHandle,wcConnected,wcStatus
global WM.DESTROY,WM.QUIT
global WM.FRAMEDATA,WM.STATUSDATA,WM.ERRORDATA
global DIB.RGB.COLORS,DIB.PAL.COLORS,SOURCE.COPY,FALSE,TRUE

WM.FRAMEDATA=1100   ' Frame Message
WM.ERRORDATA=1101   ' Error Message
WM.STATUSDATA=1102  ' Status Message
WM.DESTROY=2
WM.QUIT=16

DIB.RGB.COLORS=0
DIB.PAL.COLORS=1

FALSE=0
TRUE=1

WindowWidth=800
WindowHeight=400
UpperLeftX=(DisplayWidth-WindowWidth)/2
UpperLeftY=(DisplayHeight-WindowHeight)/2

button #Form.B1, "Start Recording", [BC1], ul, 600, 6, 140, 30
button #Form.B2, "Stop Recording", [BC2], ul, 600, 46, 140, 30
button #Form.B3, "Abort Recording", [BC3], ul, 600, 86, 140, 30
button #Form.B4, "Video Dialogs", [BC4], ul, 600, 126, 140, 30
button #Form.B5, "Frame To Clipboard", [BC5], ul, 600, 166, 140, 30
button #Form.B6, "Video - SaveAs...", [BC6], ul, 600, 206, 140, 30
button #Form.B7, "BM Details", [BC7], ul, 600, 246, 140, 30

stylebits #Form,0,0,_WS_EX_TOPMOST,0

open "WebCam DLL Test" for window as #Form
#Form "trapclose [quit.Form]"

winHandle=HWND(#Form)
wcHandle=0
wcConnected=0
wcStatus=0

open "webcam.dll" for dll as #webcam
open "avicap32.dll" for dll as #vfw

rtn=SetupWebCam()

rtn=WCGetIDs()
rtn=WCGetIDCount()
'notice "Driver Count: "+str$(rtn)
rtn=WCGetIDName(0)
'notice "Driver Name: "+winstring(rtn)
rtn=WCGetIDDescription(0)
'notice "Driver Description: "+winstring(rtn)

rtn=StartCallback()
if rtn=FALSE then call CleanUp

[Wait]
Scan
GoTo [Wait]

[BC1]
rtn=WCSetOKMessage(TRUE)
rtn=WCSetYield(TRUE)
rtn=WCSetRecordTime(TRUE,3)
' Change the name and size of the default CAPTURE.AVI file.
'rtn=WCSetFileName("C:\\Test.avi")
'rtn=WCSetFileSize(1080000000/20)  ' 1Gb = 1,080,000,000

' Change the size of the default file and then create a new file, so that the new file ends up
' containing only the actual video (i.e. a video of size 1.??Mb).
rtn=WCSetFileSize(1080000000/20)  ' 1Gb = 1,080,000,000
rtn=WCSetFileName("C:\\Test.avi")

'rtn=WCCopySaveFileAs("C:\\TestCopy.avi")

' Start Capturing.
rtn=WCStartRecording(TRUE)

GoTo [Wait]

[BC2]
rtn=WCStopRecording()
GoTo [Wait]

[BC3]
rtn=WCAbortRecording()
GoTo [Wait]

[BC4]
rtn=WCVideoCompressionDialog()
rtn=WCVideoFormatDialog()
rtn=WCVideoDisplayDialog()
rtn=WCVideoSourceDialog()
GoTo [Wait]

[BC5]
rtn=WCGrabFrame(FALSE)
rtn=WCFrameToClipboard()
GoTo [Wait]

[BC6]
rtn=WCStartRecording(TRUE)
rtn=WCSaveFileAs("C:\John.avi")
GoTo [Wait]

[BC7]

GoTo [Wait]

[quit.Form]
call CleanUp
end

sub CleanUp

end sub

Function SetupWebCam()
if wcStatus=0 then
' Create the WebCam window and return the Handle (Address) of that window.
wcHandle=WCCreateWCWindow("WebCam Window",0,0,200,200,winHandle,0)
if wcHandle then
wcStatus=1
' Register the CallBack/s.
rtn=WCSetErrorCallback(TRUE)
rtn=WCSetStatusCallback(TRUE)
rtn=WCSetFrameCallback(TRUE)
' Connect the WebCam to the Driver.
wcConnected=WCConnectDriver(0)
if wcConnected=TRUE then
' These next two calls MUST be called, otherwise the WebCam will not work as it should.
rtn=WCGetHWCapabilities()
if rtn=TRUE then
rtn=WCGetCurrentSettings()
if rtn=TRUE then
' Check if the WebCam was initialized properly. The WebCam could of connected to the Driver
' regardless if the following returns FALSE or TRUE. However. A return of TRUE means the WebCam
' connected properly and thus initialized properly.
rtn=WCDidItInitialize()
if rtn=TRUE then
wcStatus=2
' Set the Preview Rate, in milliSeconds. You can lower this value if you have a slow system.
rtn=WCSetPreviewRate(66)
' Check if the WebCam supports Overlay (Direct Hardware) mode or just the standard
' (cheap "Off the Market" WebCam!) software (CPU Expensive) mode.
rtn=WCCheckForOverlay()
if rtn=TRUE then
rtn=WCSetOverlay(TRUE)
wcStatus=4
else
' Scale the webcam view to fit the whole window.
'rtn=WCScalePreview(TRUE)
' Let's see the actual view the WebCam is looking at.
' Note: You can record without the view - The webcam still sees. Preview is just for the human
' to be able to see what the webcam is seeing.
rtn=WCSetPreview(TRUE)
wcStatus=3
end if
end if
end if
end if
end if
end if
end if
End Function

' --------------------------------------- WebCam Functions -----------------------------------

' Create a Capture (Child) Window for the WebCam to use.
Function WCCreateWCWindow(title$,x,y,width,height,parentWindow,id)
if wcHandle=0 then
CallDLL #webcam,"CreateWCWindow",title$ as ptr,x as long,y as long,width as long,height as long,parentWindow as long,id as long,WCCreateWCWindow as long
end if
End Function

' Connect the WebCam Driver to the Capture Window, so they can communicate with each other.
Function WCConnectDriver(deviceNumber)
CallDLL #webcam,"ConnectDriver",deviceNumber as long,WCConnectDriver as long
End Function

' Disconnect the WebCam Driver from the Capture Window.
Function WCDisconnectDriver()
CallDLL #webcam,"DisconnectDriver",WCDisconnectDriver as long
End Function

' Get the Hardware Capabilities of the WebCam.
Function WCGetHWCapabilities()
if wcConnected=TRUE then
CallDLL #webcam,"GetHWCapabilities",WCGetHWCapabilities as long
end if
End Function

' Did the WebCam setup properly?
Function WCDidItInitialize()
if wcConnected=TRUE then
CallDLL #webcam,"DidItInitialize",WCDidItInitialize as long
end if
End Function

' Is Overlay Mode supported?
Function WCCheckForOverlay()
if wcConnected=TRUE then
CallDLL #webcam,"CheckForOverlay",WCCheckForOverlay as long
end if
End Function

' Get the WebCam Data.
Function WCGetWCData()
if wcConnected=TRUE then
CallDLL #webcam,"GetWCData",WCData as struct,WCGetWCData as long
end if
End Function

' Get the WebCam's IDs.
Function WCGetIDs()
CallDLL #webcam,"GetIDs",WCGetIDs as long
End Function

' Get the WebCam's Driver Count.
Function WCGetIDCount()
CallDLL #webcam,"GetIDCount",WCGetIDCount as long
End Function

' Get the WebCam's ID Name.
Function WCGetIDName(number)
CallDLL #webcam,"GetIDName",number as long,WCGetIDName as long
End Function

' Get the WebCam's ID Description.
Function WCGetIDDescription(number)
CallDLL #webcam,"GetIDDescription",number as long,WCGetIDDescription as long
End Function

' Get the Current Streaming Parameters.
Function WCGetCurrentSettings()
if wcConnected=TRUE then
CallDLL #webcam,"GetCurrentSettings",WCGetCurrentSettings as long
end if
End Function

' Sets the display's Frame Rate in Preview Mode.
Function WCSetPreviewRate(msRate)
if wcConnected=TRUE then
CallDLL #webcam,"SetPreviewRate",msRate as long,WCSetPreviewRate as long
end if
End Function

Function WCSetPreview(offOn)
if wcConnected=TRUE then
CallDLL #webcam,"SetPreview",offOn as long,WCSetPreview as long
end if
End Function

Function WCScalePreview(offOn)
if wcConnected=TRUE then
CallDLL #webcam,"ScalePreview",offOn as long,WCScalePreview as long
end if
End Function

' Enables/Disables Overlay Mode - With overlay mode video is displayed using hardware overlay.
Function WCSetOverlay(offOn)
if wcConnected=TRUE then
CallDLL #webcam,"SetOverlay",offOn as long,WCSetOverlay as long
end if
End Function

Function WCSetOKMessage(offOn)
if wcStatus>1 then
CallDLL #webcam,"SetOKMessage",offOn as long,WCSetOKMessage as long
end if
End Function

Function WCSetYield(offOn)
if wcStatus>1 then
CallDLL #webcam,"SetYield",offOn as long,WCSetYield as long
end if
End Function

Function WCSetRecordTime(offOn,seconds)
if wcStatus>1 then
CallDLL #webcam,"SetRecordTime",offOn as long,seconds as long,WCSetRecordTime as long
end if
End Function

Function WCSetFileSize(fileSize)
if wcStatus>1 then
CallDLL #webcam,"SetFileSize",fileSize as long,WCSetFileSize as long
end if
End Function

Function WCSetFileName(fileName$)
if wcStatus>1 then
CallDLL #webcam,"SetFileName",fileName$ as ptr,WCSetFileName as long
end if
End Function

Function WCStartRecording(withFile)
if wcStatus>1 then
CallDLL #webcam,"StartRecording",withFile as long,WCStartRecording as long
end if
End Function

Function WCStopRecording()
if wcStatus>1 then
CallDLL #webcam,"StopRecording",WCStopRecording as long
end if
End Function

Function WCAbortRecording()
if wcStatus>1 then
CallDLL #webcam,"AbortRecording",WCAbortRecording as long
end if
End Function

Function WCGrabFrame(freeze)
if wcStatus>1 then
CallDLL #webcam,"GrabFrame",freeze as long,WCGrabFrame as long
end if
End Function

Function WCFrameToClipboard()
if wcStatus>1 then
CallDLL #webcam,"FrameToClipboard",WCFrameToClipboard as long
end if
End Function

Function WCSaveFileAs(fileName$)
if wcStatus>1 then
CallDLL #webcam,"SaveFileAs",fileName$ as ptr,WCSaveFileAs as long
end if
End Function

' --------------------------------------- Video Dialogs -------------------------------------

Function WCVideoCompressionDialog()
if wcStatus>1 then
CallDLL #webcam,"VideoCompressionDialog",WCVideoCompressionDialog as long
end if
End Function

Function WCVideoFormatDialog()
if wcStatus>1 then
CallDLL #webcam,"VideoFormatDialog",WCVideoFormatDialog as long
end if
End Function

Function WCVideoDisplayDialog()
if wcStatus>1 then
CallDLL #webcam,"VideoDisplayDialog",WCVideoDisplayDialog as long
end if
End Function

Function WCVideoSourceDialog()
if wcStatus>1 then
CallDLL #webcam,"VideoSourceDialog",WCVideoSourceDialog as long
end if
End Function

' --------------------------------------- Callback Setup -------------------------------------

' Starts catching (reading) messages from the Callback Procedure.
Function StartCallback()
Callback cbAdr,OnMsgEvent(long,long,long,long),long
CallDLL #webcam,"CatchMessages",winHandle As long,cbAdr As long,StartCallback As long
End Function

' Stops catching (reading) messages from the Callback Procedure.
Function EndCallback()
CallDLL #webcam,"StopCatching",EndCallback As long
End Function

' The callback procedure for receiving webcam Frame messages.
Function WCSetFrameCallback(offOn)
CallDLL #webcam,"SetFrameCallback",offOn as long,WCData as struct,WCSetFrameCallback as long
End Function

' The callback procedure for receiving webcam Error messages.
Function WCSetErrorCallback(offOn)
CallDLL #webcam,"SetErrorCallback",offOn as long,WCSetErrorCallback as long
End Function

' The callback procedure for receiving webcam Status messages.
Function WCSetStatusCallback(offOn)
CallDLL #webcam,"SetStatusCallback",offOn as long,WCSetStatusCallback as long
End Function

' -------------------------------------- Callback Functions ----------------------------------

' The callback procedure sends any caught (wanted) messages to this function.
Function OnMsgEvent(hWnd,uMsg,wParam,lParam)

If uMsg=WM.ERRORDATA then
'notice "Error Code: "+str$(wParam)+" Error String: "+winstring(lParam)
end if

If uMsg=WM.STATUSDATA then
'notice "Error Code: "+str$(wParam)+" Status String: "+winstring(lParam)
end if

' The Frame Callback message - It returns Frame Data by inserting it into the WCData struct.
If uMsg=WM.FRAMEDATA then
rtn=WCGetWCData()

'notice str$(WCData.biSize.struct)
'notice str$(WCData.biWidth.struct)
'notice str$(WCData.biHeight.struct)
'notice str$(WCData.biPlanes.struct)
'notice str$(WCData.biBitCount.struct)
'notice str$(WCData.biCompression.struct)
'notice str$(WCData.biSizeImage.struct)
'notice str$(WCData.biXPelsPerMeter.struct)
'notice str$(WCData.biYPelsPerMeter.struct)
'notice str$(WCData.biClrUsed.struct)
'notice str$(WCData.biClrImportant.struct)
'notice str$(WCData.wFormatTag.struct)
'notice str$(WCData.nChannels.struct)
'notice str$(WCData.nSamplesPerSec.struct)
'notice str$(WCData.nAvgBytesPerSec.struct)
'notice str$(WCData.nBlockAlign.struct)
'notice str$(WCData.wBitsPerSample.struct)
'notice str$(WCData.cbSize.struct)

CallDLL #user32,"GetDC",winHandle as long,hdc as long
if hdc then

x=0
y=0
w=WCData.biWidth.struct
h=WCData.biHeight.struct
xoffset=250
CallDLL #gdi32,"StretchDIBits",hdc as long,xoffset as long,y as long,w as long,h as long,x as long,y as long,w as long,h as long,wParam as long,lParam as long,DIB.RGB.COLORS as long,_SRCCOPY as long,result as long

CallDLL #user32,"ReleaseDC",winHandle as long,hdc as long,result as long
end if
end if

' You want to handle the QUIT procedure yourself.
If uMsg=WM.QUIT then
notice "Quit"
if wcStatus=4 then rtn=WCSetOverlay(FALSE)
if wcStatus=3 then rtn=WCSetPreview(FALSE)
if wcStatus>1 then rtn=WCDisconnectDriver()
if wcStatus>0 then calldll #user32,"DestroyWindow",wcHandle as ulong,result as long
close #Form
close #webcam
close #vfw
end if

' You want to handle the DESTROY procedure yourself.
if uMsg=WM.DESTROY then
notice "Destroy"
'CallDLL #user32,"PostQuitMessage",0 As long,result As void
end if

OnMsgEvent=0
End Function

