#include <disphelper.c>
#include <wchar.h>

typedef struct stringInfo
{
char rtnStg[256];
} stringData;

stringData sd;
stringData * sdPtr;

extern int COMAL_Debug(BOOL);
extern stringData * COMAL_GetErrorCode(void);
extern stringData * COMAL_GetErrorMsg(void);

extern int XDOCUMENT_Close(void);
extern int XDOCUMENT_Save(void);
extern int XDOCUMENT_SaveAs(char *,int);
extern int XDOCUMENT_Open(BOOL,BOOL,char *);

extern BOOL XSHEET_SetName(char *);
extern stringData * XSHEET_GetName(void);
extern int XSHEET_Activate(char *,int);
extern int XSHEET_Add(void);
extern int XSHEET_Delete(char *);
extern int XSHEET_MoveBefore(char *,int,char *,int);
extern int XSHEET_MoveAfter(char *,int,char *,int);
extern int XSHEET_CopyBefore(char *,int,char *,int);
extern int XSHEET_CopyAfter(char *,int,char *,int);
extern int XSHEET_PrintSheet(char *,int);
extern int XSHEET_PrintSheetEx(char *,int,int,BOOL,char *,BOOL,BOOL,char *);
extern int XSHEET_PrintPreview(char *,int);
extern int XSHEET_SetPrintArea(char *,int,char *);
extern int XSHEET_SplitRows(int);
extern int XSHEET_SplitColumns(int);
extern int XSHEET_FreezePanes(BOOL);
extern int XSHEET_InsertHyperLink(char *,int,char *,char *,char *,char *);
extern int XSHEET_ActivateHyperLink(char *,int,char *,int);
extern int XSHEET_OpenHyperLink(char *,BOOL);
extern stringData * XSHEET_GetHyperLinkName(char *,int,char *,int);

extern int XPRINT_SetOrientation(char *,int,int);
extern int XPRINT_SetBW(char *,int,BOOL);
extern int XPRINT_SetDraft(char *,int,BOOL);
extern int XPRINT_SetFirstPageNumber(char *,int,int);
extern int XPRINT_SetPaperSize(char *,int,int);
extern int XPRINT_PrintHeadings(char *,int,BOOL);
extern int XPRINT_PrintNotes(char *,int,BOOL);

extern stringData * EXCEL_GetDefaultPrinter(void);
extern int EXCEL_FullScreen(BOOL);
extern int EXCEL_MoveTo(double,double);
extern int EXCEL_ReSize(double,double);
extern int EXCEL_SetWindowState(int);
extern int EXCEL_Visible(BOOL);
extern int EXCEL_Undo(void);
extern int EXCEL_ActivateMSApplication(int);
extern double EXCEL_CMsToPoints(double);
extern double EXCEL_InchesToPoints(double);
extern int EXCEL_PrintAll(int,BOOL,char *,BOOL,BOOL,char *);
extern int EXCEL_ArangeWindows(void);
extern int EXCEL_OpenFile(void);
extern int EXCEL_ScrollWindowView(int,int,int,int,BOOL);
extern int EXCEL_ScrollWindow(int,int,int,int);
extern int EXCEL_ScrollRowsColumns(int,int,int,int);
extern int EXCEL_ToolBar(char *,BOOL);
extern int EXCEL_RunMacro(char *);

extern int XSPELLING_CheckDictionary(char *,int,char *,int,int);
extern int XSPELLING_CheckSheet(char *,int);

extern int XCELL_WriteText(char *,int,int,int,char *);
extern int XCELL_SetColour(char *,int,char *,int);
extern int XCELL_SetPattern(char *,int,char *,int);
extern int XCELL_SetBorderColour(char *,int,char *,int);
extern int XCELL_SetBorderStyle(char *,int,char *,int);
extern int XCELL_SetBorderThickness(char *,int,char *,int);
extern int XCELL_SetFontSize(char *,int,char *,int);
extern int XCELL_SetFormat(char *,int,char *,char *);
extern int XCELL_WriteValue(char *,int,char *,int);
extern double XCELL_ReadValue(char *,int,char *);
extern stringData * XCELL_ReadText(char *,int,char *);
extern int XCELL_MergeCells(char*,int,char *);
extern int XCELL_WriteMergedText(char*,int,char *,char *);
extern int XCELL_AddBorder(char *,int,char *,int,int,int);
extern int XCELL_SetColumnWidth(char *,int,char *,double);
extern int XCELL_SetRowHeight(char *,int,char *,double);
extern int XCELL_SelectRange(char *,int,char *);
extern int XCELL_ClearRange(char *,int,char *);
extern int XCELL_CopyRangeToClipboard(char *,int,char *);
extern int XCELL_CutRangeToClipboard(char *,int,char *);
extern int XCELL_PasteRangeFromClipboard(char *,int,char *);
extern int XCELL_CopySourceToDest(char *,int,char *,char *,int,char *);
extern stringData * XCELL_Function(int,int,char *,char *,char *,char *,char *,char *,int,char *);
extern int XCELL_Formula(char *,int,char *,char *);
extern int XCELL_CopyAsPictureToClipboard(char *,int,char *,int,int);
extern int XCELL_AutoFill(char *,char *,int);
extern int XCELL_FillUp(char *,int,char *);
extern int XCELL_FillDown(char *,int,char *);
extern int XCELL_FillLeft(char *,int,char *);
extern int XCELL_FillRight(char *,int,char *);
extern int XCELL_AddComment(char *,int,char *,char *);
extern int XCELL_ClearComments(char *,int,char *);
extern int XCELL_AutoFitColumns(char *,int,char *);
extern int XCELL_AutoFitRange(char *,int,char *);
extern int XCELL_ClearContents(char *,int,char *);
extern int XCELL_ClearFormatting(char *,int,char *);
extern int XCELL_ClearOutline(char *,int,char *);
extern int XCELL_InsertCells(char *,int,char *);
extern int XCELL_CalendarDays(char *,int,char *,char *,char *,int);
extern int XCELL_FunctionWizard(void);
extern int XCELL_Speak(char *,int,char *);

extern int XVIEW_SetView(int);

extern stringData * COMALEXCEL_GetVersion(BYTE);

DISPATCH_OBJ(xlApp);

int rtn=0;
BOOL xlSts=FALSE;

char * UnicodeToAnsi(OLECHAR * szW)
{
static char szA[256];
szA[0]=0;
if (szW==NULL)
return "";
WideCharToMultiByte(CP_ACP,0,szW,-1,szA,256,NULL,NULL);
return szA;
}

int __declspec(dllexport) COMAL_Debug(BOOL onoff)
{
HRESULT result=FALSE;
result=dhToggleExceptions(onoff);
return result;
}

stringData * __declspec(dllexport) COMAL_GetErrorCode(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%lx",pException->swCode);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

stringData * __declspec(dllexport) COMAL_GetErrorMsg(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%ls",pException->szDescription);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

int __declspec(dllexport) XDOCUMENT_Close(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
result=dhCallMethod(xlApp,L".Quit");
SAFE_RELEASE(xlApp);
dhUninitialize(TRUE);
xlSts=FALSE;
}
return result;
}

int __declspec(dllexport) XDOCUMENT_Save(void)
{
HRESULT result=TRUE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Save");
return result;
}

int __declspec(dllexport) XDOCUMENT_SaveAs(char *fname,int ftype)
{
HRESULT result=TRUE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWorkbook.SaveAs(%s,%d)",fname,ftype);
return result;
}

int __declspec(dllexport) XDOCUMENT_Open(BOOL onoff,BOOL useFile,char *fname)
{
HRESULT result=FALSE;
if (xlSts==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Excel.Application",NULL,&xlApp);
if (SUCCEEDED(result))
{
dhPutValue(xlApp,L".DisplayFullScreen = %b",onoff);
dhPutValue(xlApp,L".Visible = %b",TRUE);
if (useFile==TRUE)
result=dhCallMethod(xlApp,L".Workbooks.Open(%s)",fname);
else
result=dhCallMethod(xlApp,L".Workbooks.Add");
if (SUCCEEDED(result))
{
xlSts=TRUE;
return TRUE;
}
else
{
dhPutValue(xlApp,L".ActiveWorkbook.Saved = %b",TRUE);
SAFE_RELEASE(xlApp);
dhUninitialize(TRUE);
}
}
}
return FALSE;
}

int __declspec(dllexport) XSHEET_SetName(char *name)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".ActiveSheet.Name = %s",name);
return result;
}

stringData * __declspec(dllexport) XSHEET_GetName(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
LPWSTR name=NULL;
char *namePtr=NULL;
result=dhGetValue(L"%S",&name,xlApp,L".ActiveSheet.Name");
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

int __declspec(dllexport) XSHEET_Activate(char *tsheet,int tnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Activate",tnum);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Activate",tsheet);
}
return result;
}

int __declspec(dllexport) XSHEET_Add(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".Sheets.Add");
return result;
}

int __declspec(dllexport) XSHEET_Delete(char *txtStg)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".Sheets(%s).Delete",txtStg);
return result;
}

int __declspec(dllexport) XSHEET_MoveBefore(char *sname,int snum,char *dname,int dnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (snum>0)
dhGetValue(L"%o",&target,xlApp,L".Sheets(%d)",dnum);
else
dhGetValue(L"%o",&target,xlApp,L".Sheets(%s)",dname);
if (snum>0)
result=dhCallMethod(xlApp,L".Sheets(%d).Move(%o)",snum,target);
else
result=dhCallMethod(xlApp,L".Sheets(%s).Move(%o)",sname,target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XSHEET_MoveAfter(char *sname,int snum,char *dname,int dnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (dnum>0)
dhGetValue(L"%o",&target,xlApp,L".Sheets(%d)",dnum);
else
dhGetValue(L"%o",&target,xlApp,L".Sheets(%s)",dname);
if (snum>0)
result=dhCallMethod(xlApp,L".Sheets(%d).Move(%m,%o)",snum,target);
else
result=dhCallMethod(xlApp,L".Sheets(%s).Move(%m,%o)",sname,target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XSHEET_CopyBefore(char *sname,int snum,char *dname,int dnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (dnum>0)
dhGetValue(L"%o",&target,xlApp,L".Sheets(%d)",dnum);
else
dhGetValue(L"%o",&target,xlApp,L".Sheets(%s)",dname);
if (snum>0)
result=dhCallMethod(xlApp,L".Sheets(%d).Copy(%o)",snum,target);
else
result=dhCallMethod(xlApp,L".Sheets(%s).Copy(%o)",sname,target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XSHEET_CopyAfter(char *sname,int snum,char *dname,int dnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (dnum>0)
dhGetValue(L"%o",&target,xlApp,L".Sheets(%d)",dnum);
else
dhGetValue(L"%o",&target,xlApp,L".Sheets(%s)",dname);
if (snum>0)
result=dhCallMethod(xlApp,L".Sheets(%d).Copy(%m,%o)",snum,target);
else
result=dhCallMethod(xlApp,L".Sheets(%s).Copy(%m,%o)",sname,target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XSHEET_PrintSheet(char *tsheet,int tnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).PrintOut",tnum);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).PrintOut",tsheet);
}
return result;
}

int __declspec(dllexport) XSHEET_PrintSheetEx(char *tsheet,int tnum,int copies,BOOL preview,char *printer,BOOL ptf,BOOL collate,char *ptfName)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).PrintOut(%m,%m,%d,%b,%s,%b,%b,%s)",tnum,copies,preview,printer,ptf,collate,ptfName);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).PrintOut(%m,%m,%d,%b,%s,%b,%b,%s)",tsheet,copies,preview,printer,ptf,collate,ptfName);
}
return result;
}

int __declspec(dllexport) XSHEET_PrintPreview(char *tsheet,int tnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).PrintPreview",tnum);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).PrintPreview",tsheet);
}
return result;
}

int __declspec(dllexport) XSHEET_SetPrintArea(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.PrintArea = %s",tnum,trange);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.PrintArea = %s",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XSHEET_SplitRows(int vle)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".ActiveWindow.SplitRow = %d",vle);
return result;
}

int __declspec(dllexport) XSHEET_SplitColumns(int vle)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".ActiveWindow.SplitHorizontal = %d",vle);
return result;
}

int __declspec(dllexport) XSHEET_FreezePanes(BOOL onoff)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".ActiveWindow.FreezePanes = %b",onoff);
return result;
}

int __declspec(dllexport) XSHEET_InsertHyperLink(char *tsheet,int tnum,char *trange,char *link,char *tip,char *title)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (tnum>0)
{
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s)",tnum,trange);
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Hyperlinks.Add(%o,%s,%m,%s,%s)",tnum,target,link,tip,title);
}
else
{
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s)",tsheet,trange);
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Hyperlinks.Add(%o,%s,%m,%s,%s)",tsheet,target,link,tip,title);
}
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XSHEET_ActivateHyperLink(char *tsheet,int tnum,char *trange,int number)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Hyperlinks(%d).Follow()",tnum,trange,number);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Hyperlinks(%d).Follow()",tsheet,trange,number);
}
return result;
}

int __declspec(dllexport) XSHEET_OpenHyperLink(char *link,BOOL newWin)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
result=dhCallMethod(xlApp,L".ActiveWorkbook.FollowHyperlink(%s,%m,%b)",link,newWin);
}
return result;
}

stringData * __declspec(dllexport) XSHEET_GetHyperLinkName(char *tsheet,int tnum,char *trange,int number)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
LPWSTR name=NULL;
char *namePtr=NULL;
if (tnum>0)
result=dhGetValue(L"%S",&name,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Hyperlinks(%d).Name",tnum,trange,number);
else
result=dhGetValue(L"%S",&name,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Hyperlinks(%d).Name",tsheet,trange,number);
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

int __declspec(dllexport) XPRINT_SetOrientation(char *tsheet,int tnum,int ori)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.Orientation = %d",tnum,ori);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.Orientation = %d",tsheet,ori);
}
return result;
}

int __declspec(dllexport) XPRINT_SetBW(char *tsheet,int tnum,BOOL bw)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.BlackAndWhite = %b",tnum,bw);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.BlackAndWhite = %b",tsheet,bw);
}
return result;
}

int __declspec(dllexport) XPRINT_SetDraft(char *tsheet,int tnum,BOOL draft)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.Draft = %b",tnum,draft);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.Draft = %b",tsheet,draft);
}
return result;
}

int __declspec(dllexport) XPRINT_SetFirstPageNumber(char *tsheet,int tnum,int fpn)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.FirstPageNumber = %d",tnum,fpn);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.FirstPageNumber = %d",tsheet,fpn);
}
return result;
}

int __declspec(dllexport) XPRINT_SetPaperSize(char *tsheet,int tnum,int paper)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.PaperSize = %d",tnum,paper);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.PaperSize = %d",tsheet,paper);
}
return result;
}

int __declspec(dllexport) XPRINT_PrintHeadings(char *tsheet,int tnum,BOOL hds)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.PrintHeadings = %b",tnum,hds);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.PrintHeadings = %b",tsheet,hds);
}
return result;
}

int __declspec(dllexport) XPRINT_PrintNotes(char *tsheet,int tnum,BOOL notes)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).PageSetup.PrintNotes = %b",tnum,notes);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).PageSetup.PrintNotes = %b",tsheet,notes);
}
return result;
}

stringData * __declspec(dllexport) EXCEL_GetDefaultPrinter(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
LPWSTR name=NULL;
char *namePtr=NULL;
result=dhGetValue(L"%S",&name,xlApp,L".ActivePrinter");
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

int __declspec(dllexport) EXCEL_FullScreen(BOOL onoff)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".DisplayFullScreen = %b",onoff);
return result;
}

int __declspec(dllexport) EXCEL_MoveTo(double left,double top)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
dhPutValue(xlApp,L".WindowState = %d",0xFFFFEFD1);
dhPutValue(xlApp,L".Left(%e)",left);
result=dhPutValue(xlApp,L".Top(%e)",top);
}
return result;
}

int __declspec(dllexport) EXCEL_ReSize(double width,double height)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
dhPutValue(xlApp,L".WindowState = %d",0xFFFFEFD1);
dhPutValue(xlApp,L".Width(%e)",width);
result=dhPutValue(xlApp,L".Height(%e)",height);
}
return result;
}

int __declspec(dllexport) EXCEL_SetWindowState(int state)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".WindowState = %d",state);
return result;
}

int __declspec(dllexport) EXCEL_Visible(BOOL onoff)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".Visible = %b",onoff);
return result;
}

int __declspec(dllexport) EXCEL_Undo(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".Undo");
return result;
}

int __declspec(dllexport) EXCEL_ActivateMSApplication(int msApp)
{
HRESULT result=FALSE;
if ((msApp<1) || (msApp>4))
msApp=1;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActivateMicrosoftApp(%d)",msApp);
return result;
}

double __declspec(dllexport) EXCEL_CMsToPoints(double cms)
{
double vle=0;
if (xlSts==TRUE)
{
HRESULT result=FALSE;
result=dhGetValue(L"%e",&vle,xlApp,L".CentimetersToPoints(%e)",cms);
if (FAILED(result))
return -1;
}
return vle;
}

double __declspec(dllexport) EXCEL_InchesToPoints(double inches)
{
double vle=0;
if (xlSts==TRUE)
{
HRESULT result=FALSE;
result=dhGetValue(L"%e",&vle,xlApp,L".InchesToPoints(%e)",inches);
if (FAILED(result))
return -1;
}
return vle;
}

int __declspec(dllexport) EXCEL_PrintAll(int copies,BOOL preview,char *printer,BOOL ptf,BOOL collate,char *ptfName)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets.PrintOut(%m,%m,%d,%b,%s,%b,%b,%s)",copies,preview,printer,ptf,collate,ptfName);
return result;
}

int __declspec(dllexport) EXCEL_ArangeWindows(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".Windows.Arrange");
return result;
}

int __declspec(dllexport) EXCEL_FindFile(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".FindFile");
return result;
}

int __declspec(dllexport) EXCEL_ScrollWindowView(int left,int top,int width,int height,BOOL pos)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWindow.ScrollIntoView(%d,%d,%d,%d,%b)",left,top,width,height,pos);
return result;
}

int __declspec(dllexport) EXCEL_ScrollWindow(int down,int up,int right,int left)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWindow.LargeScroll(%d,%d,%d,%d)",down,up,right,left);
return result;
}

int __declspec(dllexport) EXCEL_ScrollRowsColumns(int down,int up,int right,int left)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveWindow.SmallScroll(%d,%d,%d,%d)",down,up,right,left);
return result;
}

int __declspec(dllexport) EXCEL_ToolBar(char *cb,BOOL onoff)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".CommandBars(%s).Visible = %b",cb,onoff);
return result;
}

int __declspec(dllexport) EXCEL_RunMacro(char *macroName)
{
if (xlSts==TRUE)
{
HRESULT result=FALSE;
result=dhCallMethod(xlApp,L".Run(%s)",macroName);
return result;
}
return FALSE;
}

int __declspec(dllexport) XSPELLING_CheckDictionary(char *tsheet,int tnum,char *dictionary,int ignoreUpper,int suggestions)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".Worksheets(%d).CheckSpelling(%s,%b,%b)",tnum,dictionary,ignoreUpper,suggestions);
else
result=dhCallMethod(xlApp,L".Worksheets(%s).CheckSpelling(%s,%b,%b)",tsheet,dictionary,ignoreUpper,suggestions);
}
return result;
}

int __declspec(dllexport) XSPELLING_CheckSheet(char *tsheet,int tnum)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".Worksheets(%d).CheckSpelling()",tnum);
else
result=dhCallMethod(xlApp,L".Worksheets(%s).CheckSpelling()",tsheet);
}
return result;
}

int __declspec(dllexport) XCELL_WriteText(char *tsheet,int tnum,int x,int y,char *txtStg)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Cells(%d,%d) = %s",tnum,x,y,txtStg);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Cells(%d,%d) = %s",tsheet,x,y,txtStg);
}
return result;
}

int __declspec(dllexport) XCELL_SetColour(char *tsheet,int tnum,char *trange,int fgColour)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Interior.Color = %d",tnum,trange,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Interior.Color = %d",tsheet,trange,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
}
return result;
}

int __declspec(dllexport) XCELL_SetPattern(char *tsheet,int tnum,char *trange,int pattern)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Interior.Pattern = %d",tnum,trange,pattern);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Interior.Pattern = %d",tsheet,trange,pattern);
}
return result;
}

int __declspec(dllexport) XCELL_SetBorderColour(char *tsheet,int tnum,char *trange,int fgColour)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Borders.Color = %d",tnum,trange,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Borders.Color = %d",tsheet,trange,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
}
return result;
}

int __declspec(dllexport) XCELL_SetBorderStyle(char *tsheet,int tnum,char *trange,int style)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Borders.LineStyle = %d",tnum,trange,style);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Borders.LineStyle = %d",tsheet,trange,style);
}
return result;
}

int __declspec(dllexport) XCELL_SetBorderThickness(char *tsheet,int tnum,char *trange,int thickness)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Borders.Weight = %d",tnum,trange,thickness);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Borders.Weight = %d",tsheet,trange,thickness);
}
return result;
}

int __declspec(dllexport) XCELL_SetFontSize(char *tsheet,int tnum,char *trange,int fontSize)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Font.Size = %d",tnum,trange,fontSize);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Font.Size = %d",tsheet,trange,fontSize);
}
return result;
}

int __declspec(dllexport) XCELL_SetFormat(char *tsheet,int tnum,char *trange,char *nformat)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).NumberFormat = %s",tnum,trange,nformat);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).NumberFormat = %s",tsheet,trange,nformat);
}
return result;
}

int __declspec(dllexport) XCELL_WriteValue(char *tsheet,int tnum,char *trange,int vle)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Value = %d",tnum,trange,vle);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Value = %d",tsheet,trange,vle);
}
return result;
}

double __declspec(dllexport) XCELL_ReadValue(char *tsheet,int tnum,char *txtStg)
{
if (xlSts==TRUE)
{
HRESULT result=FALSE;
double vle=0;
if (tnum>0)
result=dhGetValue(L"%e",&vle,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Value",tnum,txtStg);
else
result=dhGetValue(L"%e",&vle,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Value",tsheet,txtStg);
if (FAILED(result))
return -1;
return vle;
}
return -1;
}

stringData * __declspec(dllexport) XCELL_ReadText(char *tsheet,int tnum,char *txtStg)
{
if (xlSts==TRUE)
{
HRESULT result=FALSE;
LPWSTR name=NULL;
char *namePtr=NULL;
if (tnum>0)
result=dhGetValue(L"%S",&name,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Text",tnum,txtStg);
else
result=dhGetValue(L"%S",&name,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Text",tsheet,txtStg);
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

int __declspec(dllexport) XCELL_MergeCells(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Merge",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Merge",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_WriteMergedText(char *tsheet,int tnum,char *trange,char *mergedText)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Value = %s",tnum,trange,mergedText);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Value = %s",tsheet,trange,mergedText);
}
return result;
}

int __declspec(dllexport) XCELL_AddBorder(char *tsheet,int tnum,char *trange,int style,int thickness,int fgColour)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).BorderAround(%d,%d,%m,%d)",tnum,trange,style,thickness,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).BorderAround(%d,%d,%m,%d)",tsheet,trange,style,thickness,RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
}
return result;
}

int __declspec(dllexport) XCELL_SetColumnWidth(char *tsheet,int tnum,char *trange,double colWidth)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Columns(%s).ColumnWidth = %e",tnum,trange,colWidth);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Columns(%s).ColumnWidth = %e",tsheet,trange,colWidth);
}
return result;
}

int __declspec(dllexport) XCELL_SetRowHeight(char *tsheet,int tnum,char *trange,double rowHeight)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Rows(%s).RowHeight = %e",tnum,trange,rowHeight);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Rows(%s).RowHeight = %e",tsheet,trange,rowHeight);
}
return result;
}

int __declspec(dllexport) XCELL_SelectRange(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Select",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Select",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_ClearRange(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Clear",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Clear",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_CopyRangeToClipboard(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Copy",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Copy",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_CutRangeToClipboard(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Cut",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Cut",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_PasteRangeFromClipboard(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (tnum>0)
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s)",tnum,trange);
else
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s)",tsheet,trange);
result=dhCallMethod(xlApp,L".ActiveSheet.Paste(%o)",target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XCELL_CopySourceToDest(char *ssheet,int snum,char *srange,char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
if (tnum>0)
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s)",tnum,trange);
else
dhGetValue(L"%o",&target,xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s)",tsheet,trange);
if (snum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Copy(%o)",snum,srange,target);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Copy(%o)",ssheet,srange,target);
SAFE_RELEASE(target);
}
return result;
}

stringData * __declspec(dllexport) XCELL_Function(int dr,int funcName,char *sname,char *srange,char *dname,char *drange,char *tname,char *trange,int number,char *txtStg)
{
if (xlSts==TRUE)
{
double answer=0;
BOOL tf=FALSE;
DISPATCH_OBJ(sourceRange);
DISPATCH_OBJ(destRange);
dhGetValue(L"%o",&sourceRange,xlApp,L".Worksheets(%s).Range(%s)",sname,srange);
dhGetValue(L"%o",&destRange,xlApp,L".Worksheets(%s).Range(%s)",dname,drange);
if (funcName==1)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Min(%o)",sourceRange);
else if (funcName==2)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Max(%o)",sourceRange);
else if (funcName==3)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Small(%o,%d)",sourceRange,number);
else if (funcName==4)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Average(%o)",sourceRange);

else if (funcName==9)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Sum(%o)",sourceRange);
else if (funcName==10)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Sum(%o,%o)",sourceRange,destRange);
else if (funcName==11)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Sum(%o,%o,%d)",sourceRange,destRange,number);
else if (funcName==12)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Sum(%o,%d)",sourceRange,number);
else if (funcName==15)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Subtotal(1,%o)",sourceRange);
else if (funcName==16)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Subtotal(9,%o)",sourceRange);
else if (funcName==20)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Search(%s,%o)",txtStg,destRange);
else if (funcName==21)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Search(%o,%o)",sourceRange,destRange);
else if (funcName==25)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Product(%o)",sourceRange);
else if (funcName==26)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Product(%o,%o)",sourceRange,destRange);
else if (funcName==27)
{
DISPATCH_OBJ(thirdRange);
dhGetValue(L"%o",&thirdRange,xlApp,L".Worksheets(%s).Range(%s)",tname,trange);
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Pmt(%o,%o,%o)",sourceRange,destRange,thirdRange);
SAFE_RELEASE(thirdRange);
}
else if (funcName==30)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsText(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==31)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsNumber(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==32)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsLogical(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==33)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsPmt(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==34)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsNonText(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==35)
{
dhGetValue(L"%b",&tf,xlApp,L".WorksheetFunction.IsError(%o)",sourceRange);
if (tf==FALSE)
strcpy(sd.rtnStg,"FALSE");
else
strcpy(sd.rtnStg,"TRUE");
dr=0;
}
else if (funcName==40)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Find(%s,%o)",txtStg,sourceRange);
else if (funcName==41)
dhGetValue(L"%e",&answer,xlApp,L".WorksheetFunction.Find(%s,%o,%d)",txtStg,sourceRange,number);

if ((dr<0) || (dr>4))
dr=1;
if (dr==1)
sprintf(sd.rtnStg,"%4.0lf",answer);
else if (dr==2)
sprintf(sd.rtnStg,"%4.1lf",answer);
else if (dr==3)
sprintf(sd.rtnStg,"%4.2lf",answer);
else if (dr==4)
sprintf(sd.rtnStg,"%4.3lf",answer);
SAFE_RELEASE(destRange);
SAFE_RELEASE(sourceRange);
return &sd;
}
return NULL;
}

int __declspec(dllexport) XCELL_Formula(char *tsheet,int tnum,char *trange,char *formula)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Formula = %s",tnum,trange,formula);
else
result=dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Formula = %s",tsheet,trange,formula);
}
return result;
}

int __declspec(dllexport) XCELL_CopyAsPictureToClipboard(char *tsheet,int tnum,char *trange,int appr,int format)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).CopyPicture(%d,%d)",tnum,trange,appr,format);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).CopyPicture(%d,%d)",tsheet,trange,appr,format);
}
return result;
}

int __declspec(dllexport) XCELL_AutoFill(char *srange,char *drange,int fill)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
DISPATCH_OBJ(target);
dhGetValue(L"%o",&target,xlApp,L".ActiveSheet.Range(%s)",drange);
result=dhCallMethod(xlApp,L".ActiveSheet.Range(%s).AutoFill(%o)",srange,target);
SAFE_RELEASE(target);
}
return result;
}

int __declspec(dllexport) XCELL_FillUp(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).FillUp",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).FillUp",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_FillDown(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).FillDown",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).FillDown",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_FillLeft(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).FillLeft",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).FillLeft",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_FillRight(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).FillRight",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).FillRight",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_AddComment(char *tsheet,int tnum,char *trange,char *comment)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).AddComment(%s)",tnum,trange,comment);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).AddComment(%s)",tsheet,trange,comment);
}
return result;
}

int __declspec(dllexport) XCELL_ClearComments(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).ClearComments",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).ClearComments",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_AutoFitColumns(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Columns(%s).AutoFit",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Columns(%s).AutoFit",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_AutoFitRange(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Columns.AutoFit",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Columns.AutoFit",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_ClearContents(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).ClearContents",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).ClearContents",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_ClearFormatting(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).ClearFormats",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).ClearFormats",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_ClearOutline(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).ClearOutline",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).ClearOutline",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_InsertCells(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Insert",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Insert",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XCELL_CalendarDays(char *tsheet,int tnum,char *trange,char *srange,char *formula,int steps)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
{
dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Formula(%s)",tnum,srange,formula);
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).DataSeries(%m,%m,%d,%d)",tnum,trange,1,steps);
}
else
{
dhPutValue(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Formula(%s)",tsheet,srange,formula);
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).DataSeries(%m,%m,%d,%d)",tsheet,trange,1,steps);
}
}
return result;
}

int __declspec(dllexport) XCELL_FunctionWizard(void)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhCallMethod(xlApp,L".ActiveCell.FunctionWizard");
return result;
}

int __declspec(dllexport) XCELL_Speak(char *tsheet,int tnum,char *trange)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
{
if (tnum>0)
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%d).Range(%s).Speak",tnum,trange);
else
result=dhCallMethod(xlApp,L".ActiveWorkbook.Worksheets(%s).Range(%s).Speak",tsheet,trange);
}
return result;
}

int __declspec(dllexport) XVIEW_SetView(int vle)
{
HRESULT result=FALSE;
if (xlSts==TRUE)
result=dhPutValue(xlApp,L".ActiveWindow.View = %d",vle);
return result;
}

stringData * __declspec(dllexport) COMALEXCEL_GetVersion(BYTE verstg)
{
if (verstg==1)
strcpy(sd.rtnStg,"http://www.yoingco.com/");
else if (verstg==2)
strcpy(sd.rtnStg,"john@yoingco.com");
else
strcpy(sd.rtnStg,"ComalExcel.dll V1.04 - (c) John White, 2006. All Rights Reserved.");
return &sd;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:

break;
case DLL_PROCESS_DETACH:

break;
case DLL_THREAD_ATTACH:

break;
case DLL_THREAD_DETACH:

break;
}
return TRUE;
}
