#include <disphelper.c>
#include <wchar.h>

typedef struct stringInfo
{
char rtnStg[256];
} stringData;

stringData sd;
stringData * sdPtr;

typedef struct voiceInfo
{
char voiceName[256];
} voiceData;

voiceData vd[100];
voiceData * vdPtr;

extern BOOL COMAL_Debug(BOOL);
extern stringData * COMAL_GetErrorCode(void);
extern stringData * COMAL_GetErrorMsg(void);

extern void VOICE1_Close(void);
extern void VOICE1_Open(void);
extern int SAPI5_CountVoices(void);
extern HRESULT SAPI5_DisplayUI(int,char *,char *);
extern stringData * SAPI5_GetOutput(int);
extern HRESULT SAPI5_SetOutput(int);
extern int SAPI5_EnumVoices(void);
extern stringData * SAPI5_GetVoiceName(int);
extern HRESULT VOICE1_Speak(char *,int);
extern int VOICE1_GetVolume(void);
extern HRESULT VOICE1_SetVolume(int);
extern int VOICE1_GetRate(void);
extern HRESULT VOICE1_SetRate(int);
extern HRESULT VOICE1_Pause(void);
extern HRESULT VOICE1_Resume(void);
extern HRESULT VOICE1_SkipSentence(int);
extern HRESULT VOICE1_WaitUntilDone(int);
extern void VOICE1_SetVoice(int);

extern int SPEECH_CountVoices(void);
extern BOOL SPEECH_Close(void);
extern BOOL SPEECH_Open(char *);
extern BOOL SPEECH_Speak(char *);
extern BOOL SPEECH_SpeakEx(BYTE,char *);
extern BOOL SPEECH_OpenAgent(char *,char *);
extern BOOL SPEECH_SoundEffects(BOOL);
extern BOOL SPEECH_StopAnimation(void);
extern BOOL AGENT_Hide(BOOL,BOOL);
extern BOOL AGENT_Speak(char *,BOOL);
extern BOOL AGENT_Animate(int);
extern BOOL AGENT_MoveTo(int,int);
extern BOOL AGENT_GestureAt(int,int);
extern BOOL AGENT_ShowPopupMenu(int,int);
extern BOOL AGENT_Think(char *,BOOL);
extern BOOL AGENT_AnimateWhenIdle(BOOL);
extern BOOL AGENT_ChangeSize(int,int,int,int);

extern BOOL SPEECH2_Close(void);
extern BOOL SPEECH2_Open(char *);
extern BOOL SPEECH2_Speak(char *);
extern BOOL SPEECH2_SpeakEx(BYTE,char *);
extern BOOL SPEECH2_OpenAgent(char *,char *);
extern BOOL SPEECH2_SoundEffects(BOOL);
extern BOOL SPEECH2_StopAnimation(void);
extern BOOL AGENT2_Hide(BOOL,BOOL);
extern BOOL AGENT2_Speak(char *,BOOL);
extern BOOL AGENT2_Animate(int);
extern BOOL AGENT2_MoveTo(int,int);
extern BOOL AGENT2_GestureAt(int,int);
extern BOOL AGENT2_ShowPopupMenu(int,int);
extern BOOL AGENT2_Think(char *,BOOL);
extern BOOL AGENT2_AnimateWhenIdle(BOOL);
extern BOOL AGENT2_ChangeSize(int,int,int,int);

extern BOOL SPEECH3_Close(void);
extern BOOL SPEECH3_Open(char *);
extern BOOL SPEECH3_Speak(char *);
extern BOOL SPEECH3_SpeakEx(BYTE,char *);
extern BOOL SPEECH3_OpenAgent(char *,char *);
extern BOOL SPEECH3_SoundEffects(BOOL);
extern BOOL SPEECH3_StopAnimation(void);
extern BOOL AGENT3_Hide(BOOL,BOOL);
extern BOOL AGENT3_Speak(char *,BOOL);
extern BOOL AGENT3_Animate(int);
extern BOOL AGENT3_MoveTo(int,int);
extern BOOL AGENT3_GestureAt(int,int);
extern BOOL AGENT3_ShowPopupMenu(int,int);
extern BOOL AGENT3_Think(char *,BOOL);
extern BOOL AGENT3_AnimateWhenIdle(BOOL);
extern BOOL AGENT3_ChangeSize(int,int,int,int);

extern BOOL SPEECH4_Close(void);
extern BOOL SPEECH4_Open(char *);
extern BOOL SPEECH4_Speak(char *);
extern BOOL SPEECH4_SpeakEx(BYTE,char *);
extern BOOL SPEECH4_OpenAgent(char *,char *);
extern BOOL SPEECH4_SoundEffects(BOOL);
extern BOOL SPEECH4_StopAnimation(void);
extern BOOL AGENT4_Hide(BOOL,BOOL);
extern BOOL AGENT4_Speak(char *,BOOL);
extern BOOL AGENT4_Animate(int);
extern BOOL AGENT4_MoveTo(int,int);
extern BOOL AGENT4_GestureAt(int,int);
extern BOOL AGENT4_ShowPopupMenu(int,int);
extern BOOL AGENT4_Think(char *,BOOL);
extern BOOL AGENT4_AnimateWhenIdle(BOOL);
extern BOOL AGENT4_ChangeSize(int,int,int,int);

extern stringData * COMALSPEECH_GetVersion(BYTE);

DISPATCH_OBJ(agent);
DISPATCH_OBJ(agent2);
DISPATCH_OBJ(agent3);
DISPATCH_OBJ(agent4);
DISPATCH_OBJ(tts);
DISPATCH_OBJ(aoObj0);
DISPATCH_OBJ(aoObj1);

int rtn=0,voices=0;
BOOL spchSts=FALSE,spchSts2=FALSE,spchSts3=FALSE,spchSts4=FALSE,voice1=FALSE,aoo0=FALSE,aoo1=FALSE;
char agentString[256];
char agentString2[256];
char agentString3[256];
char agentString4[256];

char * UnicodeToAnsi(OLECHAR * szW)
{
static char szA[256];
szA[0]=0;
if (szW==NULL)
return "";
WideCharToMultiByte(CP_ACP,0,szW,-1,szA,256,NULL,NULL);
return szA;
}

BOOL __declspec(dllexport) COMAL_Debug(BOOL onoff)
{
HRESULT result;
result=dhToggleExceptions(onoff);
return result;
}

stringData * __declspec(dllexport) COMAL_GetErrorCode(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%lx",pException->swCode);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

stringData * __declspec(dllexport) COMAL_GetErrorMsg(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%ls",pException->szDescription);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

void __declspec(dllexport) VOICE1_Close(void)
{
if (voice1==TRUE)
{
SAFE_RELEASE(tts);
SAFE_RELEASE(aoObj1);
SAFE_RELEASE(aoObj0);
dhUninitialize(TRUE);
voice1=FALSE;
}
}

void __declspec(dllexport) VOICE1_Open(void)
{
HRESULT result=FALSE;
if (spchSts==FALSE && spchSts2==FALSE && spchSts3==FALSE && spchSts4==FALSE)
{
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
voice1=TRUE;
}
}

int __declspec(dllexport) SAPI5_CountVoices(void)
{
int count=-1;
if (voice1==TRUE)
dhGetValue(L"%d",&count,tts,L".GetVoices().Count");
return count;
}

HRESULT __declspec(dllexport) SAPI5_DisplayUI(int hWindow,char *title,char *ui)
{
HRESULT result=FALSE;
if (voice1==TRUE)
{
result=dhCallMethod(tts,L".IsUISupported = %s",ui);
if (SUCCEEDED(result))
dhCallMethod(tts,L".DisplayUI(%d,%s,%s)",hWindow,title,ui);
}
return result;
}

stringData * __declspec(dllexport) SAPI5_GetOutput(int index)
{
if (voice1==TRUE)
{
if ((aoo0==FALSE && index==0) || (aoo1==FALSE && index==1))
{
HRESULT result=FALSE;
strcpy(sd.rtnStg,"");
if (index==1)
result=dhGetValue(L"%o",&aoObj1,tts,L".GetAudioOutputs().Item(%d)",1);
else
result=dhGetValue(L"%o",&aoObj0,tts,L".GetAudioOutputs().Item(%d)",0);
if (SUCCEEDED(result))
{
if (index==1)
aoo1=TRUE;
else
aoo0=TRUE;
LPSTR szDescription;
if (index==1)
result=dhGetValue(L"%s",&szDescription,aoObj1,L".GetDescription");
else
result=dhGetValue(L"%s",&szDescription,aoObj0,L".GetDescription");
if (SUCCEEDED(result))
strcpy(sd.rtnStg,szDescription);
dhFreeString(szDescription);
}
}
}
return &sd;
}

HRESULT __declspec(dllexport) SAPI5_SetOutput(int index)
{
HRESULT result=FALSE;
if (voice1==TRUE)
{
if ((aoo0==TRUE && index==0) || (aoo1==TRUE && index==1))
{
if (index==1)
result=dhPutValue(tts,L".AudioOutput = %o",aoObj1);
else
result=dhPutValue(tts,L".AudioOutput = %o",aoObj0);
}
}
return result;
}

int __declspec(dllexport) SAPI5_EnumVoices(void)
{
voices=0;
if (voice1==TRUE)
{
HRESULT result=FALSE;
FOR_EACH(spVoice,tts,L".GetVoices")
{
LPSTR szDescription;
dhPutRef(tts,L".Voice = %o",spVoice);
result=dhGetValue(L"%s",&szDescription,spVoice,L".GetDescription");
if (SUCCEEDED(result))
{
strcpy(vd[voices].voiceName,szDescription);
voices+=1;
dhFreeString(szDescription);
}
} NEXT(spVoice);
strcpy(vd[voices].voiceName,"LAST ITEM");
}
return voices;
}

stringData * __declspec(dllexport) SAPI5_GetVoiceName(int voiceNumber)
{
if (voice1==TRUE)
{
//if (voiceNumber>=0 && voiceNumber<=(voices-1))
//{
strcpy(sd.rtnStg,vd[voiceNumber].voiceName);
return &sd;
//}
}
return NULL;
}

HRESULT __declspec(dllexport) VOICE1_Speak(char *phrase,int flags)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhCallMethod(tts,L".Speak(%s,%d)",phrase,flags);
return result;
}

int __declspec(dllexport) VOICE1_GetVolume(void)
{
int volume=-1;
if (voice1==TRUE)
dhGetValue(L"%d",&volume,tts,L".Volume");
return volume;
}

HRESULT __declspec(dllexport) VOICE1_SetVolume(int volume)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhPutValue(tts,L".Volume = %d",volume);
return result;
}

int __declspec(dllexport) VOICE1_GetRate(void)
{
int rate=-1;
if (voice1==TRUE)
dhGetValue(L"%d",&rate,tts,L".Rate");
return rate;
}

HRESULT __declspec(dllexport) VOICE1_SetRate(int rate)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhPutValue(tts,L".Rate = %d",rate);
return result;
}

HRESULT __declspec(dllexport) VOICE1_Pause(void)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhCallMethod(tts,L".Pause()");
return result;
}

HRESULT __declspec(dllexport) VOICE1_Resume(void)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhCallMethod(tts,L".Resume");
return result;
}

HRESULT __declspec(dllexport) VOICE1_SkipSentence(int skip)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhCallMethod(tts,L".Skip(%s,%d)","sentence",skip);
return result;
}

HRESULT __declspec(dllexport) VOICE1_WaitUntilDone(int ms)
{
HRESULT result=FALSE;
if (voice1==TRUE)
result=dhCallMethod(tts,L".WaitUntilDone(%d)",ms);
return result;
}

void __declspec(dllexport) VOICE1_SetVoice(int voiceNumber)
{
//if (voices>0 && (voiceNumber>=0 && voiceNumber<(voices-1)))
//{
DISPATCH_OBJ(spVoice);
dhGetValue(L"%o",&spVoice,tts,L".GetVoices().Item(%d)",voiceNumber);
dhPutRef(tts,L".Voice = %o",spVoice);
SAFE_RELEASE(spVoice);
//}
}

int __declspec(dllexport) SPEECH_CountVoices(void)
{
int count=-1;
if (spchSts==TRUE || spchSts2==TRUE || spchSts3==TRUE || spchSts4==TRUE)
{
HRESULT result;
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
dhGetValue(L"%d",&count,tts,L".GetVoices().Count");
SAFE_RELEASE(tts);
}
return count;
}

BOOL __declspec(dllexport) SPEECH_Close(void)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
result=dhCallMethod(agent,L".Characters.Unload(%s)",agentString);
SAFE_RELEASE(agent);
dhUninitialize(TRUE);
spchSts=FALSE;
}
return result;
}

BOOL __declspec(dllexport) SPEECH_Open(char *name)
{
HRESULT result;
if (spchSts==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent);
if (SUCCEEDED(result))
{
dhPutValue(agent,L".Connected = %b",TRUE);
strcpy(agentString,name);
dhCallMethod(agent,L".Characters.Load(%s)",agentString);
spchSts=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH_Speak(char *phrase)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH_SpeakEx(BYTE voiceNumber,char *phrase)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
{
DISPATCH_OBJ(spVoice);
result=dhGetValue(L"%o",&spVoice,tts,L".GetVoices().Item(%d)",voiceNumber);
if (SUCCEEDED(result))
result=dhPutRef(tts,L".Voice = %o",spVoice);
SAFE_RELEASE(spVoice);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
}
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH_OpenAgent(char *name,char *pathName)
{
HRESULT result;
if (spchSts==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent);
if (SUCCEEDED(result))
{
dhPutValue(agent,L".Connected = %b",TRUE);
strcpy(agentString,name);
dhCallMethod(agent,L".Characters.Load(%s,%s)",name,pathName);
spchSts=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH_SoundEffects(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhPutValue(genie,L".SoundEffectsOn = %d",offon);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) SPEECH_StopAnimation(void)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhCallMethod(genie,L".Stop");
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_Hide(BOOL show,BOOL offon)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
if (show==TRUE)
result=dhCallMethod(genie,L".Hide(%b)",offon);
else
result=dhCallMethod(genie,L".Show");
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_Speak(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
if (show==TRUE)
dhCallMethod(genie,L".Show");
else
dhCallMethod(genie,L".Hide");
result=dhCallMethod(genie,L".Speak(%s)",textString);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_Animate(int movement)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
if (movement==1)
result=dhCallMethod(genie,L".Play(%S)",L"Alert");
else if (movement==2)
result=dhCallMethod(genie,L".Play(%S)",L"Announce");
else if (movement==3)
result=dhCallMethod(genie,L".Play(%S)",L"Blink");
else if (movement==4)
result=dhCallMethod(genie,L".Play(%S)",L"Confused");
else if (movement==5)
result=dhCallMethod(genie,L".Play(%S)",L"Congratulate");
else if (movement==6)
result=dhCallMethod(genie,L".Play(%S)",L"Congratulate_2");
else if (movement==7)
result=dhCallMethod(genie,L".Play(%S)",L"Decline");
else if (movement==8)
result=dhCallMethod(genie,L".Play(%S)",L"DoMagic1");
else if (movement==9)
result=dhCallMethod(genie,L".Play(%S)",L"DoMagic2");
else if (movement==10)
result=dhCallMethod(genie,L".Play(%S)",L"DontRecognize");
else if (movement==11)
result=dhCallMethod(genie,L".Play(%S)",L"Explain");
else if (movement==12)
result=dhCallMethod(genie,L".Play(%S)",L"GestureDown");
else if (movement==13)
result=dhCallMethod(genie,L".Play(%S)",L"GestureUp");
else if (movement==14)
result=dhCallMethod(genie,L".Play(%S)",L"GestureLeft");
else if (movement==15)
result=dhCallMethod(genie,L".Play(%S)",L"GestureRight");
else if (movement==16)
result=dhCallMethod(genie,L".Play(%S)",L"GetAttention");
else if (movement==17)
result=dhCallMethod(genie,L".Play(%S)",L"Idle1_4");
else if (movement==18)
result=dhCallMethod(genie,L".Play(%S)",L"LookDown");
else if (movement==19)
result=dhCallMethod(genie,L".Play(%S)",L"LookUp");
else if (movement==20)
result=dhCallMethod(genie,L".Play(%S)",L"LookLeft");
else if (movement==21)
result=dhCallMethod(genie,L".Play(%S)",L"LookRight");
else if (movement==22)
result=dhCallMethod(genie,L".Play(%S)",L"MoveDown");
else if (movement==23)
result=dhCallMethod(genie,L".Play(%S)",L"MoveUp");
else if (movement==24)
result=dhCallMethod(genie,L".Play(%S)",L"MoveLeft");
else if (movement==25)
result=dhCallMethod(genie,L".Play(%S)",L"MoveRight");
else if (movement==26)
result=dhCallMethod(genie,L".Play(%S)",L"Pleased");
else if (movement==27)
result=dhCallMethod(genie,L".Play(%S)",L"Process");
else if (movement==28)
result=dhCallMethod(genie,L".Play(%S)",L"Read");
else if (movement==29)
result=dhCallMethod(genie,L".Play(%S)",L"RestPose");
else if (movement==30)
result=dhCallMethod(genie,L".Play(%S)",L"Sad");
else if (movement==31)
result=dhCallMethod(genie,L".Play(%S)",L"Search");
else if (movement==32)
result=dhCallMethod(genie,L".Play(%S)",L"StartListening");
else if (movement==33)
result=dhCallMethod(genie,L".Play(%S)",L"StopListening");
else if (movement==34)
result=dhCallMethod(genie,L".Play(%S)",L"Suggest");
else if (movement==35)
result=dhCallMethod(genie,L".Play(%S)",L"Surprised");
else if (movement==36)
result=dhCallMethod(genie,L".Play(%S)",L"Think");
else if (movement==37)
result=dhCallMethod(genie,L".Play(%S)",L"Uncertain");
else if (movement==38)
result=dhCallMethod(genie,L".Play(%S)",L"Wave");
else if (movement==39)
result=dhCallMethod(genie,L".Play(%S)",L"Write");
else if (movement==40)
result=dhCallMethod(genie,L".Play(%S)",L"Processing");
else if (movement==41)
result=dhCallMethod(genie,L".Play(%S)",L"Reading");
else if (movement==42)
result=dhCallMethod(genie,L".Play(%S)",L"Searching");
else if (movement==43)
result=dhCallMethod(genie,L".Play(%S)",L"Thinking");
else if (movement==44)
result=dhCallMethod(genie,L".Play(%S)",L"Writing");
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_MoveTo(int x,int y)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhCallMethod(genie,L".MoveTo(%d,%d)",x,y);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_GestureAt(int x,int y)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhCallMethod(genie,L".GestureAt(%d,%d)",x,y);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_ShowPopupMenu(int x,int y)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhCallMethod(genie,L".ShowPopupMenu(%d,%d)",x,y);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_Think(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
if (show==TRUE)
dhCallMethod(genie,L".Show");
else
dhCallMethod(genie,L".Hide");
result=dhCallMethod(genie,L".Think(%s)",textString);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_AnimateWhenIdle(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
result=dhPutValue(genie,L".IdleOn = %d",offon);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) AGENT_ChangeSize(int left,int top,int width,int height)
{
HRESULT result=FALSE;
if (spchSts==TRUE)
{
DISPATCH_OBJ(genie);
dhGetValue(L"%o",&genie,agent,L".Characters(%s)",agentString);
dhPutValue(genie,L".Left = %d",left);
dhPutValue(genie,L".Top = %d",top);
dhPutValue(genie,L".Width = %d",width);
result=dhPutValue(genie,L".Height = %d",height);
SAFE_RELEASE(genie);
}
return result;
}

BOOL __declspec(dllexport) SPEECH2_Close(void)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
result=dhCallMethod(agent2,L".Characters.Unload(%s)",agentString2);
SAFE_RELEASE(agent2);
dhUninitialize(TRUE);
spchSts2=FALSE;
}
return result;
}

BOOL __declspec(dllexport) SPEECH2_Open(char *name)
{
HRESULT result;
if (spchSts2==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent2);
if (SUCCEEDED(result))
{
dhPutValue(agent2,L".Connected = %b",TRUE);
strcpy(agentString2,name);
dhCallMethod(agent2,L".Characters.Load(%s)",agentString2);
spchSts2=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH2_Speak(char *phrase)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH2_SpeakEx(BYTE voiceNumber,char *phrase)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
{
DISPATCH_OBJ(spVoice);
result=dhGetValue(L"%o",&spVoice,tts,L".GetVoices().Item(%d)",voiceNumber);
if (SUCCEEDED(result))
result=dhPutRef(tts,L".Voice = %o",spVoice);
SAFE_RELEASE(spVoice);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
}
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH2_OpenAgent(char *name,char *pathName)
{
HRESULT result;
if (spchSts2==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent2);
if (SUCCEEDED(result))
{
dhPutValue(agent2,L".Connected = %b",TRUE);
strcpy(agentString2,name);
dhCallMethod(agent2,L".Characters.Load(%s,%s)",name,pathName);
spchSts2=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH2_SoundEffects(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhPutValue(genie2,L".SoundEffectsOn = %d",offon);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) SPEECH2_StopAnimation(void)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhCallMethod(genie2,L".Stop");
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_Hide(BOOL show,BOOL offon)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
if (show==TRUE)
result=dhCallMethod(genie2,L".Hide(%b)",offon);
else
result=dhCallMethod(genie2,L".Show");
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_Speak(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
if (show==TRUE)
dhCallMethod(genie2,L".Show");
else
dhCallMethod(genie2,L".Hide");
result=dhCallMethod(genie2,L".Speak(%s)",textString);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_Animate(int movement)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
if (movement==1)
result=dhCallMethod(genie2,L".Play(%S)",L"Alert");
else if (movement==2)
result=dhCallMethod(genie2,L".Play(%S)",L"Announce");
else if (movement==3)
result=dhCallMethod(genie2,L".Play(%S)",L"Blink");
else if (movement==4)
result=dhCallMethod(genie2,L".Play(%S)",L"Confused");
else if (movement==5)
result=dhCallMethod(genie2,L".Play(%S)",L"Congratulate");
else if (movement==6)
result=dhCallMethod(genie2,L".Play(%S)",L"Congratulate_2");
else if (movement==7)
result=dhCallMethod(genie2,L".Play(%S)",L"Decline");
else if (movement==8)
result=dhCallMethod(genie2,L".Play(%S)",L"DoMagic1");
else if (movement==9)
result=dhCallMethod(genie2,L".Play(%S)",L"DoMagic2");
else if (movement==10)
result=dhCallMethod(genie2,L".Play(%S)",L"DontRecognize");
else if (movement==11)
result=dhCallMethod(genie2,L".Play(%S)",L"Explain");
else if (movement==12)
result=dhCallMethod(genie2,L".Play(%S)",L"GestureDown");
else if (movement==13)
result=dhCallMethod(genie2,L".Play(%S)",L"GestureUp");
else if (movement==14)
result=dhCallMethod(genie2,L".Play(%S)",L"GestureLeft");
else if (movement==15)
result=dhCallMethod(genie2,L".Play(%S)",L"GestureRight");
else if (movement==16)
result=dhCallMethod(genie2,L".Play(%S)",L"GetAttention");
else if (movement==17)
result=dhCallMethod(genie2,L".Play(%S)",L"Idle1_4");
else if (movement==18)
result=dhCallMethod(genie2,L".Play(%S)",L"LookDown");
else if (movement==19)
result=dhCallMethod(genie2,L".Play(%S)",L"LookUp");
else if (movement==20)
result=dhCallMethod(genie2,L".Play(%S)",L"LookLeft");
else if (movement==21)
result=dhCallMethod(genie2,L".Play(%S)",L"LookRight");
else if (movement==22)
result=dhCallMethod(genie2,L".Play(%S)",L"MoveDown");
else if (movement==23)
result=dhCallMethod(genie2,L".Play(%S)",L"MoveUp");
else if (movement==24)
result=dhCallMethod(genie2,L".Play(%S)",L"MoveLeft");
else if (movement==25)
result=dhCallMethod(genie2,L".Play(%S)",L"MoveRight");
else if (movement==26)
result=dhCallMethod(genie2,L".Play(%S)",L"Pleased");
else if (movement==27)
result=dhCallMethod(genie2,L".Play(%S)",L"Process");
else if (movement==28)
result=dhCallMethod(genie2,L".Play(%S)",L"Read");
else if (movement==29)
result=dhCallMethod(genie2,L".Play(%S)",L"RestPose");
else if (movement==30)
result=dhCallMethod(genie2,L".Play(%S)",L"Sad");
else if (movement==31)
result=dhCallMethod(genie2,L".Play(%S)",L"Search");
else if (movement==32)
result=dhCallMethod(genie2,L".Play(%S)",L"StartListening");
else if (movement==33)
result=dhCallMethod(genie2,L".Play(%S)",L"StopListening");
else if (movement==34)
result=dhCallMethod(genie2,L".Play(%S)",L"Suggest");
else if (movement==35)
result=dhCallMethod(genie2,L".Play(%S)",L"Surprised");
else if (movement==36)
result=dhCallMethod(genie2,L".Play(%S)",L"Think");
else if (movement==37)
result=dhCallMethod(genie2,L".Play(%S)",L"Uncertain");
else if (movement==38)
result=dhCallMethod(genie2,L".Play(%S)",L"Wave");
else if (movement==39)
result=dhCallMethod(genie2,L".Play(%S)",L"Write");
else if (movement==40)
result=dhCallMethod(genie2,L".Play(%S)",L"Processing");
else if (movement==41)
result=dhCallMethod(genie2,L".Play(%S)",L"Reading");
else if (movement==42)
result=dhCallMethod(genie2,L".Play(%S)",L"Searching");
else if (movement==43)
result=dhCallMethod(genie2,L".Play(%S)",L"Thinking");
else if (movement==44)
result=dhCallMethod(genie2,L".Play(%S)",L"Writing");
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_MoveTo(int x,int y)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhCallMethod(genie2,L".MoveTo(%d,%d)",x,y);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_GestureAt(int x,int y)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhCallMethod(genie2,L".GestureAt(%d,%d)",x,y);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_ShowPopupMenu(int x,int y)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhCallMethod(genie2,L".ShowPopupMenu(%d,%d)",x,y);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_Think(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
if (show==TRUE)
dhCallMethod(genie2,L".Show");
else
dhCallMethod(genie2,L".Hide");
result=dhCallMethod(genie2,L".Think(%s)",textString);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_AnimateWhenIdle(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
result=dhPutValue(genie2,L".IdleOn = %d",offon);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) AGENT2_ChangeSize(int left,int top,int width,int height)
{
HRESULT result=FALSE;
if (spchSts2==TRUE)
{
DISPATCH_OBJ(genie2);
dhGetValue(L"%o",&genie2,agent2,L".Characters(%s)",agentString2);
dhPutValue(genie2,L".Left = %d",left);
dhPutValue(genie2,L".Top = %d",top);
dhPutValue(genie2,L".Width = %d",width);
result=dhPutValue(genie2,L".Height = %d",height);
SAFE_RELEASE(genie2);
}
return result;
}

BOOL __declspec(dllexport) SPEECH3_Close(void)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
result=dhCallMethod(agent3,L".Characters.Unload(%s)",agentString3);
SAFE_RELEASE(agent3);
dhUninitialize(TRUE);
spchSts3=FALSE;
}
return result;
}

BOOL __declspec(dllexport) SPEECH3_Open(char *name)
{
HRESULT result;
if (spchSts3==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent3);
if (SUCCEEDED(result))
{
dhPutValue(agent3,L".Connected = %b",TRUE);
strcpy(agentString3,name);
dhCallMethod(agent3,L".Characters.Load(%s)",agentString3);
spchSts3=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH3_Speak(char *phrase)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH3_SpeakEx(BYTE voiceNumber,char *phrase)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
{
DISPATCH_OBJ(spVoice);
result=dhGetValue(L"%o",&spVoice,tts,L".GetVoices().Item(%d)",voiceNumber);
if (SUCCEEDED(result))
result=dhPutRef(tts,L".Voice = %o",spVoice);
SAFE_RELEASE(spVoice);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
}
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH3_OpenAgent(char *name,char *pathName)
{
HRESULT result;
if (spchSts3==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent3);
if (SUCCEEDED(result))
{
dhPutValue(agent3,L".Connected = %b",TRUE);
strcpy(agentString3,name);
dhCallMethod(agent3,L".Characters.Load(%s,%s)",name,pathName);
spchSts3=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH3_SoundEffects(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhPutValue(genie3,L".SoundEffectsOn = %d",offon);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) SPEECH3_StopAnimation(void)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhCallMethod(genie3,L".Stop");
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_Hide(BOOL show,BOOL offon)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
if (show==TRUE)
result=dhCallMethod(genie3,L".Hide(%b)",offon);
else
result=dhCallMethod(genie3,L".Show");
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_Speak(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
if (show==TRUE)
dhCallMethod(genie3,L".Show");
else
dhCallMethod(genie3,L".Hide");
result=dhCallMethod(genie3,L".Speak(%s)",textString);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_Animate(int movement)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
if (movement==1)
result=dhCallMethod(genie3,L".Play(%S)",L"Alert");
else if (movement==2)
result=dhCallMethod(genie3,L".Play(%S)",L"Announce");
else if (movement==3)
result=dhCallMethod(genie3,L".Play(%S)",L"Blink");
else if (movement==4)
result=dhCallMethod(genie3,L".Play(%S)",L"Confused");
else if (movement==5)
result=dhCallMethod(genie3,L".Play(%S)",L"Congratulate");
else if (movement==6)
result=dhCallMethod(genie3,L".Play(%S)",L"Congratulate_2");
else if (movement==7)
result=dhCallMethod(genie3,L".Play(%S)",L"Decline");
else if (movement==8)
result=dhCallMethod(genie3,L".Play(%S)",L"DoMagic1");
else if (movement==9)
result=dhCallMethod(genie3,L".Play(%S)",L"DoMagic2");
else if (movement==10)
result=dhCallMethod(genie3,L".Play(%S)",L"DontRecognize");
else if (movement==11)
result=dhCallMethod(genie3,L".Play(%S)",L"Explain");
else if (movement==12)
result=dhCallMethod(genie3,L".Play(%S)",L"GestureDown");
else if (movement==13)
result=dhCallMethod(genie3,L".Play(%S)",L"GestureUp");
else if (movement==14)
result=dhCallMethod(genie3,L".Play(%S)",L"GestureLeft");
else if (movement==15)
result=dhCallMethod(genie3,L".Play(%S)",L"GestureRight");
else if (movement==16)
result=dhCallMethod(genie3,L".Play(%S)",L"GetAttention");
else if (movement==17)
result=dhCallMethod(genie3,L".Play(%S)",L"Idle1_4");
else if (movement==18)
result=dhCallMethod(genie3,L".Play(%S)",L"LookDown");
else if (movement==19)
result=dhCallMethod(genie3,L".Play(%S)",L"LookUp");
else if (movement==20)
result=dhCallMethod(genie3,L".Play(%S)",L"LookLeft");
else if (movement==21)
result=dhCallMethod(genie3,L".Play(%S)",L"LookRight");
else if (movement==22)
result=dhCallMethod(genie3,L".Play(%S)",L"MoveDown");
else if (movement==23)
result=dhCallMethod(genie3,L".Play(%S)",L"MoveUp");
else if (movement==24)
result=dhCallMethod(genie3,L".Play(%S)",L"MoveLeft");
else if (movement==25)
result=dhCallMethod(genie3,L".Play(%S)",L"MoveRight");
else if (movement==26)
result=dhCallMethod(genie3,L".Play(%S)",L"Pleased");
else if (movement==27)
result=dhCallMethod(genie3,L".Play(%S)",L"Process");
else if (movement==28)
result=dhCallMethod(genie3,L".Play(%S)",L"Read");
else if (movement==29)
result=dhCallMethod(genie3,L".Play(%S)",L"RestPose");
else if (movement==30)
result=dhCallMethod(genie3,L".Play(%S)",L"Sad");
else if (movement==31)
result=dhCallMethod(genie3,L".Play(%S)",L"Search");
else if (movement==32)
result=dhCallMethod(genie3,L".Play(%S)",L"StartListening");
else if (movement==33)
result=dhCallMethod(genie3,L".Play(%S)",L"StopListening");
else if (movement==34)
result=dhCallMethod(genie3,L".Play(%S)",L"Suggest");
else if (movement==35)
result=dhCallMethod(genie3,L".Play(%S)",L"Surprised");
else if (movement==36)
result=dhCallMethod(genie3,L".Play(%S)",L"Think");
else if (movement==37)
result=dhCallMethod(genie3,L".Play(%S)",L"Uncertain");
else if (movement==38)
result=dhCallMethod(genie3,L".Play(%S)",L"Wave");
else if (movement==39)
result=dhCallMethod(genie3,L".Play(%S)",L"Write");
else if (movement==40)
result=dhCallMethod(genie3,L".Play(%S)",L"Processing");
else if (movement==41)
result=dhCallMethod(genie3,L".Play(%S)",L"Reading");
else if (movement==42)
result=dhCallMethod(genie3,L".Play(%S)",L"Searching");
else if (movement==43)
result=dhCallMethod(genie3,L".Play(%S)",L"Thinking");
else if (movement==44)
result=dhCallMethod(genie3,L".Play(%S)",L"Writing");
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_MoveTo(int x,int y)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhCallMethod(genie3,L".MoveTo(%d,%d)",x,y);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_GestureAt(int x,int y)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhCallMethod(genie3,L".GestureAt(%d,%d)",x,y);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_ShowPopupMenu(int x,int y)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhCallMethod(genie3,L".ShowPopupMenu(%d,%d)",x,y);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_Think(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
if (show==TRUE)
dhCallMethod(genie3,L".Show");
else
dhCallMethod(genie3,L".Hide");
result=dhCallMethod(genie3,L".Think(%s)",textString);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_AnimateWhenIdle(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
result=dhPutValue(genie3,L".IdleOn = %d",offon);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) AGENT3_ChangeSize(int left,int top,int width,int height)
{
HRESULT result=FALSE;
if (spchSts3==TRUE)
{
DISPATCH_OBJ(genie3);
dhGetValue(L"%o",&genie3,agent3,L".Characters(%s)",agentString3);
dhPutValue(genie3,L".Left = %d",left);
dhPutValue(genie3,L".Top = %d",top);
dhPutValue(genie3,L".Width = %d",width);
result=dhPutValue(genie3,L".Height = %d",height);
SAFE_RELEASE(genie3);
}
return result;
}

BOOL __declspec(dllexport) SPEECH4_Close(void)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
result=dhCallMethod(agent4,L".Characters.Unload(%s)",agentString4);
SAFE_RELEASE(agent4);
dhUninitialize(TRUE);
spchSts4=FALSE;
}
return result;
}

BOOL __declspec(dllexport) SPEECH4_Open(char *name)
{
HRESULT result;
if (spchSts4==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent4);
if (SUCCEEDED(result))
{
dhPutValue(agent4,L".Connected = %b",TRUE);
strcpy(agentString4,name);
dhCallMethod(agent4,L".Characters.Load(%s)",agentString4);
spchSts4=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH4_Speak(char *phrase)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH4_SpeakEx(BYTE voiceNumber,char *phrase)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(tts);
result=dhCreateObject(L"Sapi.SpVoice",NULL,&tts);
if (SUCCEEDED(result))
{
DISPATCH_OBJ(spVoice);
result=dhGetValue(L"%o",&spVoice,tts,L".GetVoices().Item(%d)",voiceNumber);
if (SUCCEEDED(result))
result=dhPutRef(tts,L".Voice = %o",spVoice);
SAFE_RELEASE(spVoice);
if (SUCCEEDED(result))
result=dhCallMethod(tts,L".Speak(%s)",phrase);
}
SAFE_RELEASE(tts);
}
return result;
}

BOOL __declspec(dllexport) SPEECH4_OpenAgent(char *name,char *pathName)
{
HRESULT result;
if (spchSts4==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Agent.Control.1",NULL,&agent4);
if (SUCCEEDED(result))
{
dhPutValue(agent4,L".Connected = %b",TRUE);
strcpy(agentString4,name);
dhCallMethod(agent4,L".Characters.Load(%s,%s)",name,pathName);
spchSts4=TRUE;
return TRUE;
}
}
return FALSE;
}

BOOL __declspec(dllexport) SPEECH4_SoundEffects(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhPutValue(genie4,L".SoundEffectsOn = %d",offon);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) SPEECH4_StopAnimation(void)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhCallMethod(genie4,L".Stop");
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_Hide(BOOL show,BOOL offon)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
if (show==TRUE)
result=dhCallMethod(genie4,L".Hide(%b)",offon);
else
result=dhCallMethod(genie4,L".Show");
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_Speak(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
if (show==TRUE)
dhCallMethod(genie4,L".Show");
else
dhCallMethod(genie4,L".Hide");
result=dhCallMethod(genie4,L".Speak(%s)",textString);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_Animate(int movement)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
if (movement==1)
result=dhCallMethod(genie4,L".Play(%S)",L"Alert");
else if (movement==2)
result=dhCallMethod(genie4,L".Play(%S)",L"Announce");
else if (movement==3)
result=dhCallMethod(genie4,L".Play(%S)",L"Blink");
else if (movement==4)
result=dhCallMethod(genie4,L".Play(%S)",L"Confused");
else if (movement==5)
result=dhCallMethod(genie4,L".Play(%S)",L"Congratulate");
else if (movement==6)
result=dhCallMethod(genie4,L".Play(%S)",L"Congratulate_2");
else if (movement==7)
result=dhCallMethod(genie4,L".Play(%S)",L"Decline");
else if (movement==8)
result=dhCallMethod(genie4,L".Play(%S)",L"DoMagic1");
else if (movement==9)
result=dhCallMethod(genie4,L".Play(%S)",L"DoMagic2");
else if (movement==10)
result=dhCallMethod(genie4,L".Play(%S)",L"DontRecognize");
else if (movement==11)
result=dhCallMethod(genie4,L".Play(%S)",L"Explain");
else if (movement==12)
result=dhCallMethod(genie4,L".Play(%S)",L"GestureDown");
else if (movement==13)
result=dhCallMethod(genie4,L".Play(%S)",L"GestureUp");
else if (movement==14)
result=dhCallMethod(genie4,L".Play(%S)",L"GestureLeft");
else if (movement==15)
result=dhCallMethod(genie4,L".Play(%S)",L"GestureRight");
else if (movement==16)
result=dhCallMethod(genie4,L".Play(%S)",L"GetAttention");
else if (movement==17)
result=dhCallMethod(genie4,L".Play(%S)",L"Idle1_4");
else if (movement==18)
result=dhCallMethod(genie4,L".Play(%S)",L"LookDown");
else if (movement==19)
result=dhCallMethod(genie4,L".Play(%S)",L"LookUp");
else if (movement==20)
result=dhCallMethod(genie4,L".Play(%S)",L"LookLeft");
else if (movement==21)
result=dhCallMethod(genie4,L".Play(%S)",L"LookRight");
else if (movement==22)
result=dhCallMethod(genie4,L".Play(%S)",L"MoveDown");
else if (movement==23)
result=dhCallMethod(genie4,L".Play(%S)",L"MoveUp");
else if (movement==24)
result=dhCallMethod(genie4,L".Play(%S)",L"MoveLeft");
else if (movement==25)
result=dhCallMethod(genie4,L".Play(%S)",L"MoveRight");
else if (movement==26)
result=dhCallMethod(genie4,L".Play(%S)",L"Pleased");
else if (movement==27)
result=dhCallMethod(genie4,L".Play(%S)",L"Process");
else if (movement==28)
result=dhCallMethod(genie4,L".Play(%S)",L"Read");
else if (movement==29)
result=dhCallMethod(genie4,L".Play(%S)",L"RestPose");
else if (movement==30)
result=dhCallMethod(genie4,L".Play(%S)",L"Sad");
else if (movement==31)
result=dhCallMethod(genie4,L".Play(%S)",L"Search");
else if (movement==32)
result=dhCallMethod(genie4,L".Play(%S)",L"StartListening");
else if (movement==33)
result=dhCallMethod(genie4,L".Play(%S)",L"StopListening");
else if (movement==34)
result=dhCallMethod(genie4,L".Play(%S)",L"Suggest");
else if (movement==35)
result=dhCallMethod(genie4,L".Play(%S)",L"Surprised");
else if (movement==36)
result=dhCallMethod(genie4,L".Play(%S)",L"Think");
else if (movement==37)
result=dhCallMethod(genie4,L".Play(%S)",L"Uncertain");
else if (movement==38)
result=dhCallMethod(genie4,L".Play(%S)",L"Wave");
else if (movement==39)
result=dhCallMethod(genie4,L".Play(%S)",L"Write");
else if (movement==40)
result=dhCallMethod(genie4,L".Play(%S)",L"Processing");
else if (movement==41)
result=dhCallMethod(genie4,L".Play(%S)",L"Reading");
else if (movement==42)
result=dhCallMethod(genie4,L".Play(%S)",L"Searching");
else if (movement==43)
result=dhCallMethod(genie4,L".Play(%S)",L"Thinking");
else if (movement==44)
result=dhCallMethod(genie4,L".Play(%S)",L"Writing");
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_MoveTo(int x,int y)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhCallMethod(genie4,L".MoveTo(%d,%d)",x,y);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_GestureAt(int x,int y)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhCallMethod(genie4,L".GestureAt(%d,%d)",x,y);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_ShowPopupMenu(int x,int y)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhCallMethod(genie4,L".ShowPopupMenu(%d,%d)",x,y);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_Think(char *textString,BOOL show)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
if (show==TRUE)
dhCallMethod(genie4,L".Show");
else
dhCallMethod(genie4,L".Hide");
result=dhCallMethod(genie4,L".Think(%s)",textString);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_AnimateWhenIdle(BOOL offon)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
result=dhPutValue(genie4,L".IdleOn = %d",offon);
SAFE_RELEASE(genie4);
}
return result;
}

BOOL __declspec(dllexport) AGENT4_ChangeSize(int left,int top,int width,int height)
{
HRESULT result=FALSE;
if (spchSts4==TRUE)
{
DISPATCH_OBJ(genie4);
dhGetValue(L"%o",&genie4,agent4,L".Characters(%s)",agentString4);
dhPutValue(genie4,L".Left = %d",left);
dhPutValue(genie4,L".Top = %d",top);
dhPutValue(genie4,L".Width = %d",width);
result=dhPutValue(genie4,L".Height = %d",height);
SAFE_RELEASE(genie4);
}
return result;
}

stringData * __declspec(dllexport) COMALSPEECH_GetVersion(BYTE verstg)
{
if (verstg==1)
strcpy(sd.rtnStg,"http://www.yoingco.com/");
else if (verstg==2)
strcpy(sd.rtnStg,"john@yoingco.com");
else
strcpy(sd.rtnStg,"ComalSpeech.dll V1.06 - (c) John White, 2006. All Rights Reserved.");
return &sd;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:

break;
case DLL_PROCESS_DETACH:

break;
case DLL_THREAD_ATTACH:

break;
case DLL_THREAD_DETACH:

break;
}
return TRUE;
}

