#include <disphelper.c>
#include <wchar.h>

typedef struct stringInfo
{
char rtnStg[256];
} stringData;

stringData sd;
stringData * sdPtr;

extern BOOL COMAL_Debug(BOOL);
extern stringData * COMAL_GetErrorCode(void);
extern stringData * COMAL_GetErrorMsg(void);

extern BOOL WDOCUMENT_Close(void);
extern BOOL WDOCUMENT_Save(void);
extern BOOL WDOCUMENT_SaveAs(char *,int);
extern BOOL WDOCUMENT_Open(BOOL,BOOL,char *);
extern stringData * WDOCUMENT_GetName(void);
extern BOOL WDOCUMENT_ChangeView(int);
extern BOOL WDOCUMENT_PrintAll(void);
extern BOOL WDOCUMENT_PrintCurrentPage(void);
extern BOOL WDOCUMENT_PrintToFile(char *);
extern BOOL WDOCUMENT_PrintSelectedPages(char *);
extern BOOL WDOCUMENT_PrintPreview(void);
extern BOOL WDOCUMENT_CheckGrammar(void);
extern BOOL WDOCUMENT_CheckSpelling(char *,int,int,char *);
extern BOOL WDOCUMENT_Undo(int);
extern BOOL WDOCUMENT_Redo(int);
extern BOOL WDOCUMENT_DeleteAllComments(void);
extern BOOL WDOCUMENT_DeleteAllSmartTags(void);
extern BOOL WDOCUMENT_RunLetterWizard(void);
extern BOOL WDOCUMENT_RunFaxWizard(void);
extern BOOL WDOCUMENT_SendAsFax(char *,char *);
extern stringData * WORD_GetDefaultPrinter(void);
extern BOOL WORD_SetDefaultPrinter(char *);
extern BOOL WORD_FullScreen(BOOL);
extern BOOL WORD_MoveTo(int,int);
extern BOOL WORD_ReSize(int,int);
extern BOOL WORD_SetWindowState(int);
extern BOOL WORD_Visible(BOOL);
extern BOOL WFONT_SetOnOff(BYTE,BOOL);
extern BOOL WFONT_SetName(char *);
extern BOOL WFONT_SetColourIndex(int);
extern BOOL WFONT_SetColour(int);
extern BOOL WFONT_SetSize(int);
extern BOOL WFONT_SetFont(char *,int,BOOL,int,BOOL,BOOL,BOOL,BOOL,BOOL);
extern BOOL WFONT_SetRangeFont(char *,int,BOOL,int,BOOL,BOOL,BOOL,BOOL,BOOL);
extern BOOL WPARAGRAPH_InsertAtTop(char *);
extern BOOL WPARAGRAPH_InsertAt(int,int,char *);
extern BOOL WPARAGRAPH_InsertAtBottom(char *);
extern BOOL WPARAGRAPH_Insert(void);
extern BOOL WPARAGRAPH_Add(void);
extern BOOL WPARAGRAPH_Align(int);
extern BOOL WPARAGRAPH_AddShape(int,int,int,int,int,int,int,int,int,BOOL);
extern BOOL WPARAGRAPH_AddPicture(char *,BOOL,BOOL,int,int,int,int,int,int);
extern BOOL WCURSOR_MoveCharacterLeft(int,BOOL);
extern BOOL WCURSOR_MoveCharacterRight(int,BOOL);
extern BOOL WCURSOR_MoveWordLeft(int,BOOL);
extern BOOL WCURSOR_MoveWordRight(int,BOOL);
extern BOOL WCURSOR_MoveLineUp(int,BOOL);
extern BOOL WCURSOR_MoveLineDown(int,BOOL);
extern BOOL WCURSOR_MoveSentenceLeft(int,BOOL);
extern BOOL WCURSOR_MoveSentenceRight(int,BOOL);
extern BOOL WCURSOR_MoveSentenceUp(int,BOOL);
extern BOOL WCURSOR_MoveSentenceDown(int,BOOL);
extern BOOL WCURSOR_MoveParagraphUp(int,BOOL);
extern BOOL WCURSOR_MoveParagraphDown(int,BOOL);
extern BOOL WCURSOR_MovePageUp(int,BOOL);
extern BOOL WCURSOR_MovePageDown(int,BOOL);
extern BOOL WCURSOR_BackSpace(void);
extern BOOL WTEXT_SelectAll(void);
extern BOOL WTEXT_SelectWord(int,int);
extern BOOL WTEXT_SelectSentence(int,int);
extern BOOL WTEXT_CutSelection(void);
extern BOOL WTEXT_CopySelection(void);
extern BOOL WTEXT_PasteSelection(void);
extern BOOL WTEXT_DeleteSelection(void);
extern BOOL WTEXT_CollapseSelection(BOOL);
extern BOOL WTEXT_CutSentence(int);
extern BOOL WTEXT_CopyParagraph(int);
extern BOOL WTEXT_CutParagraph(int);
extern BOOL WTEXT_WriteText(char *);
extern BOOL WTEXT_WriteBorderedText(char *,int,int,int,int,int,BOOL,int,int,int);
extern BOOL WCANVAS_CreateCanvas(BYTE,int,int,int,int);
extern BOOL WCANVAS_DrawTextBox(BYTE,int,int,int,int,int,char *);
extern BOOL WCANVAS_DrawLine(BYTE,int,int,int,int,int,BYTE,BYTE,BYTE,BYTE,BYTE,BYTE,int,int);
extern BOOL WCANVAS_DrawShape(BYTE,BYTE,int,int,int,int,int,int,BOOL);
extern BOOL WCANVAS_DrawLabel(BYTE,BYTE,int,int,int,int,char *,int,int,BOOL,BYTE,BYTE,char *,int,BOOL,BOOL,BOOL,BOOL,BOOL,BOOL);
extern BOOL WCANVAS_WordArt(int,int,char *,char *,int,BOOL,BOOL,char *,char *,char *);
extern BOOL WMACRO_Run(char *);
extern BOOL WINSERT_Picture(BYTE,char *,BOOL,BOOL,int,int,int,int);
extern BOOL WINSERT_SystemDateTime(void);
extern BOOL WINSERT_DateTime(char *,BOOL,BOOL);
extern BOOL WINSERT_Symbol(int,char *,BOOL,int);
extern BOOL WINSERT_HyperLink(char *,char *,char *);
extern BOOL WINSERT_AutoText(char *);
extern BOOL WINSERT_Break(int);
extern BOOL WINSERT_File(char *,char *,BOOL);
extern BOOL WSETTING_SetOnOff(BYTE,BOOL,int);
extern UINT WAGENT_SetUp(char *,int,int,char *,char *,char *,char *,char *,int,int);
extern BOOL WAGENT_Change(BOOL,char *,int,BOOL,BOOL,BOOL,BOOL,BOOL,int,int,BOOL);

extern stringData * COMALWORD_GetVersion(BYTE);

DISPATCH_OBJ(wdApp);
DISPATCH_OBJ(wdDoc);
DISPATCH_OBJ(canvas1);
DISPATCH_OBJ(canvas2);
DISPATCH_OBJ(canvas3);
DISPATCH_OBJ(canvas4);

int rtn=0;
BOOL wSts=FALSE;

char * UnicodeToAnsi(OLECHAR * szW)
{
static char szA[256];
szA[0]=0;
if (szW==NULL)
return "";
WideCharToMultiByte(CP_ACP,0,szW,-1,szA,256,NULL,NULL);
return szA;
}

BOOL __declspec(dllexport) COMAL_Debug(BOOL onoff)
{
HRESULT result;
result=dhToggleExceptions(onoff);
return result;
}

stringData * __declspec(dllexport) COMAL_GetErrorCode(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%lx",pException->swCode);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

stringData * __declspec(dllexport) COMAL_GetErrorMsg(void)
{
PDH_EXCEPTION pException=NULL;
dhGetLastException(&pException);
if (pException)
sprintf(sd.rtnStg,"%ls",pException->szDescription);
else
sprintf(sd.rtnStg,"NO ERROR");
return &sd;
}

BOOL __declspec(dllexport) WDOCUMENT_Close(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
result=dhCallMethod(wdApp,L".Quit");
SAFE_RELEASE(canvas4);
SAFE_RELEASE(canvas3);
SAFE_RELEASE(canvas2);
SAFE_RELEASE(canvas1);
SAFE_RELEASE(wdDoc);
SAFE_RELEASE(wdApp);
dhUninitialize(TRUE);
wSts=FALSE;
}
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_Save(void)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".Save");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_SaveAs(char *fname,int ftype)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".SaveAs(%s,%d)",fname,ftype);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_Open(BOOL onoff,BOOL useFile,char *fname)
{
HRESULT result;
if (wSts==FALSE)
{
dhInitialize(TRUE);
result=dhCreateObject(L"Word.Application",NULL,&wdApp);
if (SUCCEEDED(result))
{
dhPutValue(wdApp,L".Visible = %b",TRUE);
if (useFile==TRUE)
result=dhCallMethod(wdApp,L".Documents.Open(%s)",fname);
else
result=dhGetValue(L"%o",&wdDoc,wdApp,L".Documents.Add");
if (SUCCEEDED(result))
{
if (onoff==TRUE)
{
dhPutValue(wdApp,L".WindowState = %d",0);
dhPutValue(wdApp,L".ActiveWindow.View.FullScreen = %b",onoff);
}
wSts=TRUE;
return TRUE;
}
}
else
{
SAFE_RELEASE(wdApp);
dhUninitialize(TRUE);
}
}
return FALSE;
}

stringData * __declspec(dllexport) WDOCUMENT_GetName(void)
{
if (wSts==TRUE)
{
HRESULT result;
LPWSTR name=NULL;
char *namePtr=NULL;
result=dhGetValue(L"%S",&name,wdApp,L".ActiveDocument.Name");
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

BOOL __declspec(dllexport) WDOCUMENT_ChangeView(int view)
{
if (wSts==TRUE)
{
HRESULT result;
if ((view<1) || (view>6))
view=3;
result=dhPutValue(wdApp,L".ActiveWindow.View.Type = %d",view);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WDOCUMENT_PrintAll(void)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".PrintOut");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_PrintCurrentPage(void)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".PrintOut(%m,%m,%d)",2);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_PrintToFile(char *outFile)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".PrintOut(%m,%m,%m,%s,%m,%m,%m,%m,%m,%m,%b)",outFile,TRUE);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_PrintSelectedPages(char *pages)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".PrintOut(%m,%m,%d,%m,%m,%m,%m,%m,%s)",4,pages);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_PrintPreview(void)
{
HRESULT result=TRUE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".ActiveDocument.PrintPreview");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_CheckGrammar(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.CheckGrammar");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_CheckSpelling(char *dictionary,int ignoreUpper,int suggestions,char *fdictionary)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.CheckSpelling(%s,%b,%b,%s)",dictionary,ignoreUpper,suggestions,fdictionary);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_Undo(int number)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Undo = %d",number);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_Redo(int number)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Redo = %d",number);
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_DeleteAllComments(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.DeleteAllComments");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_DeleteAllSmartTags(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.RemoveSmartTags");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_RunLetterWizard(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.RunLetterWizard");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_RunFaxWizard(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".SendFax");
return result;
}

BOOL __declspec(dllexport) WDOCUMENT_SendAsFax(char *faxNumber,char *faxMsg)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.SendFax(%s,%s)",faxNumber,faxMsg);
return result;
}

stringData * __declspec(dllexport) WORD_GetDefaultPrinter(void)
{
if (wSts==TRUE)
{
HRESULT result;
LPWSTR name=NULL;
char *namePtr=NULL;
result=dhGetValue(L"%S",&name,wdApp,L".ActivePrinter");
namePtr=UnicodeToAnsi(name);
strcpy(sd.rtnStg,namePtr);
if (FAILED(result))
return NULL;
if (strcmp(sd.rtnStg,"")==0)
return NULL;
return &sd;
}
return NULL;
}

BOOL __declspec(dllexport) WORD_SetDefaultPrinter(char *prtName)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".ActivePrinter = %s",prtName);
return result;
}

BOOL __declspec(dllexport) WORD_FullScreen(BOOL onoff)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
if (onoff==TRUE)
{
dhPutValue(wdApp,L".WindowState = %d",0);
result=dhPutValue(wdApp,L".ActiveWindow.View.FullScreen = %b",onoff);
}
}
return result;
}

BOOL __declspec(dllexport) WORD_MoveTo(int x,int y)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Move(%d,%d)",x,y);
return result;
}

BOOL __declspec(dllexport) WORD_ReSize(int width,int height)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhPutValue(wdApp,L".WindowState = %d",0);
result=dhCallMethod(wdApp,L".Resize(%d,%d)",width,height);
}
return result;
}

BOOL __declspec(dllexport) WORD_SetWindowState(int state)
{
HRESULT result=FALSE;
if ((state<0) || (state>2))
state=0;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".WindowState = %d",state);
return result;
}

BOOL __declspec(dllexport) WORD_Visible(BOOL onoff)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Visible = %b",onoff);
return result;
}

BOOL __declspec(dllexport) WFONT_SetOnOff(BYTE command,BOOL onoff)
{
if (wSts==TRUE)
{
HRESULT result;
if (command==1)
result=dhPutValue(wdApp,L".Selection.Font.Bold = %b",onoff);
else if (command==2)
result=dhPutValue(wdApp,L".Selection.Font.Italic = %b",onoff);
else if (command==3)
result=dhPutValue(wdApp,L".Selection.Font.Underline = %b",onoff);
else if (command==4)
result=dhPutValue(wdApp,L".Selection.Font.StrikeThrough = %b",onoff);
else if (command==5)
result=dhPutValue(wdApp,L".Selection.Font.SmallCaps = %b",onoff);
else if (command==6)
result=dhPutValue(wdApp,L".Selection.Font.Shadow = %b",onoff);
else if (command==7)
{
dhPutValue(wdApp,L".Selection.Font.Bold = %b",FALSE);
dhPutValue(wdApp,L".Selection.Font.Italic = %b",FALSE);
result=dhPutValue(wdApp,L".Selection.Font.Underline = %b",FALSE);
}
else if (command==8)
{
dhPutValue(wdApp,L".Selection.Font.Bold = %b",TRUE);
dhPutValue(wdApp,L".Selection.Font.Italic = %b",TRUE);
result=dhPutValue(wdApp,L".Selection.Font.Underline = %b",TRUE);
}
else if (command==9)
{
dhPutValue(wdApp,L".Selection.Font.Bold = %b",FALSE);
dhPutValue(wdApp,L".Selection.Font.Italic = %b",FALSE);
dhPutValue(wdApp,L".Selection.Font.Underline = %b",FALSE);
dhPutValue(wdApp,L".Selection.Font.StrikeThrough = %b",FALSE);
dhPutValue(wdApp,L".Selection.Font.SmallCaps = %b",FALSE);
result=dhPutValue(wdApp,L".Selection.Font.Shadow = %b",FALSE);
}
else if (command==10)
{
dhPutValue(wdApp,L".Selection.Font.Bold = %b",TRUE);
dhPutValue(wdApp,L".Selection.Font.Italic = %b",TRUE);
dhPutValue(wdApp,L".Selection.Font.Underline = %b",TRUE);
dhPutValue(wdApp,L".Selection.Font.StrikeThrough = %b",TRUE);
dhPutValue(wdApp,L".Selection.Font.SmallCaps = %b",TRUE);
result=dhPutValue(wdApp,L".Selection.Font.Shadow = %b",TRUE);
}
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WFONT_SetName(char *fontName)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Selection.Font.Name = %s",fontName);
return result;
}

BOOL __declspec(dllexport) WFONT_SetColourIndex(int index)
{
HRESULT result=FALSE;
if ((index<1) || (index>16))
index=1;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Selection.Font.ColorIndex = %d",index);
return result;
}

BOOL __declspec(dllexport) WFONT_SetColour(int fgColour)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Selection.Font.Color = %d",fgColour);
return result;
}

BOOL __declspec(dllexport) WFONT_SetSize(int fontSize)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Selection.Font.Size = %d",fontSize);
return result;
}

BOOL __declspec(dllexport) WFONT_SetFont(char *fontName,int fontSize,BOOL scaps,int fgColour,BOOL bold,BOOL underline,BOOL italic,BOOL strikethrough,BOOL shadow)
{
if (wSts==TRUE)
{
HRESULT result;
WITH(wdFont,wdApp,L".Selection.Font")
{
dhPutValue(wdFont,L".Name = %s",fontName);
dhPutValue(wdFont,L".Size = %d",fontSize);
dhPutValue(wdFont,L".SmallCaps = %b",scaps);
dhPutValue(wdFont,L".Color = %d",fgColour);
dhPutValue(wdFont,L".Bold = %b",bold);
dhPutValue(wdFont,L".Underline = %b",underline);
dhPutValue(wdFont,L".Italic = %b",italic);
dhPutValue(wdFont,L".StrikeThrough = %b",strikethrough);
result=dhPutValue(wdFont,L".Shadow = %b",shadow);
}
END_WITH(wdFont);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WFONT_SetRangeFont(char *fontName,int fontSize,BOOL scaps,int fgColour,BOOL bold,BOOL underline,BOOL italic,BOOL strikethrough,BOOL shadow)
{
if (wSts==TRUE)
{
HRESULT result;
WITH(wdFont,wdDoc,L".Range.Font")
{
dhPutValue(wdFont,L".Name = %s",fontName);
dhPutValue(wdFont,L".Size = %d",fontSize);
dhPutValue(wdFont,L".SmallCaps = %b",scaps);
dhPutValue(wdFont,L".Color = %d",fgColour);
dhPutValue(wdFont,L".Bold = %b",bold);
dhPutValue(wdFont,L".Underline = %b",underline);
dhPutValue(wdFont,L".Italic = %b",italic);
dhPutValue(wdFont,L".StrikeThrough = %b",strikethrough);
result=dhPutValue(wdFont,L".Shadow = %b",shadow);
}
END_WITH(wdFont);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WPARAGRAPH_InsertAtTop(char *textString)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhCallMethod(wdDoc,L".Range.InsertParagraphBefore()");
result=dhCallMethod(wdDoc,L".Range.InsertBefore(%s)",textString);
}
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_InsertAt(int x,int y,char *textString)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhCallMethod(wdDoc,L".Range(%d,%d).InsertAfter(%s)",x,y,textString);
result=dhCallMethod(wdDoc,L".Range(%d,%d).InsertParagraphBefore()",x,y);
}
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_InsertAtBottom(char *textString)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhCallMethod(wdDoc,L".Range.InsertParagraphAfter()");
result=dhCallMethod(wdDoc,L".Range.InsertAfter(%s)",textString);
}
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_Insert(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhCallMethod(wdApp,L".Selection.InsertParagraph()");
result=dhCallMethod(wdApp,L".Selection.Collapse(%d)",0);
}
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_Add(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
dhCallMethod(wdApp,L".Selection.TypeParagraph()");
result=dhCallMethod(wdApp,L".Selection.Collapse(%d)",0);
}
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_Align(int lcr)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhPutValue(wdApp,L".Selection.ParagraphFormat.Alignment = %d",lcr);
return result;
}

BOOL __declspec(dllexport) WPARAGRAPH_AddShape(int shapeNumber,int x,int y,int width,int height,int wrapf,int wraps,int lColour,int fgColour,BOOL flipit)
{
if (wSts==TRUE)
{
HRESULT result;
DISPATCH_OBJ(wdRange);
DISPATCH_OBJ(wdShape);
if ((shapeNumber<1) || (shapeNumber>32))
shapeNumber=1;
dhGetValue(L"%o",&wdRange,wdApp,L".Selection.Range");
dhCallMethod(wdApp,L".Selection.InsertParagraph()");
dhCallMethod(wdApp,L".Selection.Collapse(%d)",0);
result=dhGetValue(L"%o",&wdShape,wdDoc,L".Shapes.AddShape(%d,%d,%d,%d,%d,%o)",shapeNumber,x,y,width,height,wdRange);
dhPutValue(wdShape,L".WrapFormat.Type = %d",wrapf);
dhPutValue(wdShape,L".WrapFormat.Side = %d",wraps);
dhPutValue(wdShape,L".Line.ForeColor.RGB = %d",RGB(GetRValue(lColour),GetGValue(lColour),GetBValue(lColour)));
dhPutValue(wdShape,L".Fill.ForeColor.RGB = %d",RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
dhCallMethod(wdShape,L".Flip = %d",flipit);
SAFE_RELEASE(wdShape);
SAFE_RELEASE(wdRange);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WPARAGRAPH_AddPicture(char *fname,BOOL link,BOOL save,int left,int top,int width,int height,int wrapf,int wraps)
{
if (wSts==TRUE)
{
HRESULT result;
DISPATCH_OBJ(wdRange);
DISPATCH_OBJ(picture);
dhGetValue(L"%o",&wdRange,wdApp,L".Selection.Range");
dhCallMethod(wdApp,L".Selection.InsertParagraph()");
dhCallMethod(wdApp,L".Selection.Collapse(%d)",0);
result=dhGetValue(L"%o",&picture,wdDoc,L".Shapes.AddPicture(%s,%b,%b,%d,%d,%d,%d,%o)",fname,link,save,left,top,width,height,wdRange);
dhPutValue(picture,L".WrapFormat.Type = %d",wrapf);
dhPutValue(picture,L".WrapFormat.Side = %d",wraps);
SAFE_RELEASE(picture);
SAFE_RELEASE(wdRange);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCURSOR_MoveCharacterLeft(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveLeft(%d,%d,%d)",1,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveCharacterRight(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveRight(%d,%d,%d)",1,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveWordLeft(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveLeft(%d,%d,%d)",2,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveWordRight(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveRight(%d,%d,%d)",2,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveLineUp(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveUp(%d,%d,%d)",5,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveLineDown(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveDown(%d,%d,%d)",5,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveSentenceLeft(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveLeft(%d,%d,%d)",3,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveSentenceRight(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveRight(%d,%d,%d)",3,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveSentenceUp(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveUp(%d,%d,%d)",5,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveSentenceDown(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveDown(%d,%d,%d)",5,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveParagraphUp(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveUp(%d,%d,%d)",4,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MoveParagraphDown(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveDown(%d,%d,%d)",4,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MovePageUp(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveUp(%d,%d,%d)",7,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_MovePageDown(int amount,BOOL extend)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.MoveDown(%d,%d,%d)",7,amount,extend);
return result;
}

BOOL __declspec(dllexport) WCURSOR_BackSpace(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.TypeBackspace");
return result;
}

BOOL __declspec(dllexport) WTEXT_SelectAll(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Select()");
return result;
}

BOOL __declspec(dllexport) WTEXT_SelectWord(int pgNumber,int wordNumber)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Paragraphs(%d).Range.Words(%d).Select()",pgNumber,wordNumber);
return result;
}

BOOL __declspec(dllexport) WTEXT_SelectSentence(int pgNumber,int sentNumber)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp, L".ActiveDocument.Paragraphs(%d).Range.Sentences(%d).Select()",pgNumber,sentNumber);
return result;
}

BOOL __declspec(dllexport) WTEXT_CutSelection(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.Cut()");
return result;
}

BOOL __declspec(dllexport) WTEXT_CopySelection(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.Copy()");
return result;
}

BOOL __declspec(dllexport) WTEXT_PasteSelection(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.Paste()");
return result;
}

BOOL __declspec(dllexport) WTEXT_DeleteSelection(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.Delete()");
return result;
}

BOOL __declspec(dllexport) WTEXT_CollapseSelection(BOOL collapse)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.Collapse(%d)",collapse);
return result;
}

BOOL __declspec(dllexport) WTEXT_CutSentence(int sentence)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Sentences(%d).Cut()",sentence);
return result;
}

BOOL __declspec(dllexport) WTEXT_CopyParagraph(int pg)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Paragraphs(%d).Range.Copy()",pg);
return result;
}

BOOL __declspec(dllexport) WTEXT_CutParagraph(int pg)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".ActiveDocument.Paragraphs(%d).Range.Cut()",pg);
return result;
}

BOOL __declspec(dllexport) WTEXT_WriteText(char *textString)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.TypeText(%s)",textString);
return result;
}

BOOL __declspec(dllexport) WTEXT_WriteBorderedText(char *textString,int ls,int lineColour,int texture,int bgColour,int fgColour,BOOL shadow,int align,int li,int ri)
{
if (wSts==TRUE)
{
HRESULT result;
int tbStart=0,tbEnd=0;
dhGetValue(L"%d",&tbStart,wdApp,L".Selection.Start");
dhCallMethod(wdApp,L".Selection.TypeText(%s)",textString);
dhGetValue(L"%d",&tbEnd,wdApp,L".Selection.Start");

dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Alignment = %d",tbStart,tbEnd,align);
dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.LeftIndent = %d",tbStart,tbEnd,li);
dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.RightIndent = %d",tbStart,tbEnd,ri);

dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Borders.Shadow = %b",tbStart,tbEnd,shadow);
dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Borders.OutsideLineStyle = %d",tbStart,tbEnd,ls);
dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Borders.OutsideColor = %d",tbStart,tbEnd,lineColour);

dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Shading.Texture = %d",tbStart,tbEnd,texture);
dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Shading.ForegroundPatternColor = %d",tbStart,tbEnd,fgColour);
result=dhPutValue(wdDoc,L".Range(%d,%d).ParagraphFormat.Shading.BackgroundPatternColor = %d",tbStart,tbEnd,bgColour);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_CreateCanvas(BYTE number,int left,int top,int width,int height)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
if (number==1)
result=dhGetValue(L"%o",&canvas1,wdDoc,L".Shapes.AddCanvas(%d,%d,%d,%d)",left,top,width,height);
else if (number==2)
result=dhGetValue(L"%o",&canvas2,wdDoc,L".Shapes.AddCanvas(%d,%d,%d,%d)",left,top,width,height);
else if (number==3)
result=dhGetValue(L"%o",&canvas3,wdDoc,L".Shapes.AddCanvas(%d,%d,%d,%d)",left,top,width,height);
else if (number==4)
result=dhGetValue(L"%o",&canvas4,wdDoc,L".Shapes.AddCanvas(%d,%d,%d,%d)",left,top,width,height);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_DrawTextBox(BYTE number,int Orientation,int left,int top,int width,int height,char *textString)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
DISPATCH_OBJ(tb);
if ((Orientation<1) || (Orientation>3))
Orientation=1;
if (number==1)
result=dhGetValue(L"%o",&tb,canvas1,L".CanvasItems.AddTextbox(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==2)
result=dhGetValue(L"%o",&tb,canvas2,L".CanvasItems.AddTextbox(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==3)
result=dhGetValue(L"%o",&tb,canvas3,L".CanvasItems.AddTextbox(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==4)
result=dhGetValue(L"%o",&tb,canvas4,L".CanvasItems.AddTextbox(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
dhPutValue(tb,L".TextFrame.TextRange = %s",textString);
SAFE_RELEASE(tb);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_DrawLine(BYTE number,int left,int top,int right,int bottom,int fgColour,BYTE blength,BYTE barrow,BYTE bwidth,BYTE elength,BYTE earrow,BYTE ewidth,int thickness,int style)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
DISPATCH_OBJ(line);
if ((barrow<1) || (barrow>6))
barrow=1;
if ((bwidth<1) || (bwidth>3))
bwidth=3;
if ((earrow<1) || (earrow>6))
earrow=1;
if ((ewidth<1) || (ewidth>3))
ewidth=3;
if (number==1)
result=dhGetValue(L"%o",&line,canvas1,L".CanvasItems.AddLine(%d,%d,%d,%d)",left,top,right,bottom);
else if (number==2)
result=dhGetValue(L"%o",&line,canvas2,L".CanvasItems.AddLine(%d,%d,%d,%d)",left,top,right,bottom);
else if (number==3)
result=dhGetValue(L"%o",&line,canvas3,L".CanvasItems.AddLine(%d,%d,%d,%d)",left,top,right,bottom);
else if (number==4)
result=dhGetValue(L"%o",&line,canvas4,L".CanvasItems.AddLine(%d,%d,%d,%d)",left,top,right,bottom);
WITH(pen,line,L".Line")
{
dhPutValue(pen,L".ForeColor.RGB = %d",RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
dhPutValue(pen,L".BeginArrowheadLength = %d",blength);
dhPutValue(pen,L".BeginArrowheadStyle = %d",barrow);
dhPutValue(pen,L".BeginArrowheadWidth = %d",bwidth);
dhPutValue(pen,L".EndArrowheadLength = %d",elength);
dhPutValue(pen,L".EndArrowheadStyle = %d",earrow);
dhPutValue(pen,L".EndArrowheadWidth = %d",ewidth);
dhPutValue(pen,L".DashStyle = %d",style);
dhPutValue(pen,L".Weight = %d",thickness);
}
END_WITH(pen);
SAFE_RELEASE(line);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_DrawShape(BYTE number,BYTE shapeNumber,int left,int top,int width,int height,int lColour,int fColour,BOOL flipit)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
if ((shapeNumber<1) || (shapeNumber>32))
shapeNumber=1;
DISPATCH_OBJ(shape);
if (number==1)
result=dhGetValue(L"%o",&shape,canvas1,L".CanvasItems.AddShape(%d,%d,%d,%d,%d)",shapeNumber,left,top,width,height);
else if (number==2)
result=dhGetValue(L"%o",&shape,canvas2,L".CanvasItems.AddShape(%d,%d,%d,%d,%d)",shapeNumber,left,top,width,height);
else if (number==3)
result=dhGetValue(L"%o",&shape,canvas3,L".CanvasItems.AddShape(%d,%d,%d,%d,%d)",shapeNumber,left,top,width,height);
else if (number==4)
result=dhGetValue(L"%o",&shape,canvas4,L".CanvasItems.AddShape(%d,%d,%d,%d,%d)",shapeNumber,left,top,width,height);
result=dhPutValue(shape,L".Line.ForeColor.RGB = %d",RGB(GetRValue(lColour),GetGValue(lColour),GetBValue(lColour)));
result=dhPutValue(shape,L".Fill.ForeColor.RGB = %d",RGB(GetRValue(fColour),GetGValue(fColour),GetBValue(fColour)));
result=dhCallMethod(shape,L".Flip = %d",flipit);
SAFE_RELEASE(shape);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_DrawLabel(BYTE number,BYTE Orientation,int left,int top,int width,int height,char *textString,int fgColour,int bgColour,BOOL useGradient,BYTE direction,BYTE gradient,char *fontName,int fontSize,BOOL bold,BOOL italic,BOOL underline,BOOL shadow,BOOL strike,BOOL scaps)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
if ((direction<1) || (direction>6))
direction=1;
DISPATCH_OBJ(label);
if (number==1)
result=dhGetValue(L"%o",&label,canvas1,L".CanvasItems.AddLabel(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==2)
result=dhGetValue(L"%o",&label,canvas2,L".CanvasItems.AddLabel(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==3)
result=dhGetValue(L"%o",&label,canvas3,L".CanvasItems.AddLabel(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
else if (number==4)
result=dhGetValue(L"%o",&label,canvas4,L".CanvasItems.AddLabel(%d,%d,%d,%d,%d)",Orientation,left,top,width,height);
WITH(pen,label,L".Fill")
{
dhPutValue(pen,L".ForeColor.RGB = %d",RGB(GetRValue(fgColour),GetGValue(fgColour),GetBValue(fgColour)));
dhPutValue(pen,L".BackColor.RGB = %d",RGB(GetRValue(bgColour),GetGValue(bgColour),GetBValue(bgColour)));
dhPutValue(pen,L".Visible = %b",TRUE);
if (useGradient)
dhCallMethod(pen,L".TwoColorGradient(%d,%d)",direction,gradient);
}
END_WITH(pen);
WITH(pen,label,L".TextFrame.TextRange")
{
dhPutValue(pen,L".Text = %s",textString);
dhPutValue(pen,L".Bold = %b",bold);
dhPutValue(pen,L".Italic = %b",italic);
dhPutValue(pen,L".Underline = %b",underline);
dhPutValue(pen,L".Font.Name = %s",fontName);
dhPutValue(pen,L".Font.Size = %d",fontSize);
dhPutValue(pen,L".Font.Shadow = %b",shadow);
dhPutValue(pen,L".Font.Strikethrough = %b",strike);
dhPutValue(pen,L".Font.SmallCaps = %b",scaps);
}
END_WITH(pen);
SAFE_RELEASE(label);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WCANVAS_WordArt(int number,int shapeNumber,char *textString,char *fontName,int fontSize,BOOL bold,BOOL italic,char *left,char *top,char *rotation)
{
if (wSts==TRUE)
{
if ((number<1) || (number>4))
return FALSE;
HRESULT result;
DISPATCH_OBJ(te);
if (number==1)
result=dhGetValue(L"%o",&te,canvas1,L".CanvasItems.AddTextEffect(%d,%s,%s,%d,%b,%b,%e,%e)",shapeNumber,textString,fontName,fontSize,bold,italic,atof(left),atof(top));
else if (number==2)
result=dhGetValue(L"%o",&te,canvas2,L".CanvasItems.AddTextEffect(%d,%s,%s,%d,%b,%b,%e,%e)",shapeNumber,textString,fontName,fontSize,bold,italic,atof(left),atof(top));
else if (number==3)
result=dhGetValue(L"%o",&te,canvas3,L".CanvasItems.AddTextEffect(%d,%s,%s,%d,%b,%b,%e,%e)",shapeNumber,textString,fontName,fontSize,bold,italic,atof(left),atof(top));
else if (number==4)
result=dhGetValue(L"%o",&te,canvas4,L".CanvasItems.AddTextEffect(%d,%s,%s,%d,%b,%b,%e,%e)",shapeNumber,textString,fontName,fontSize,bold,italic,atof(left),atof(top));
if (rotation!=0)
dhPutValue(te,L".Rotation(%e)",atof(rotation));
SAFE_RELEASE(te);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WMACRO_Run(char *macroName)
{
if (wSts==TRUE)
{
HRESULT result;
result=dhCallMethod(wdApp,L".Run(%s)",macroName);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WINSERT_SystemDateTime(void)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdDoc,L".Range.InsertAfter(%t)",time(NULL));
return result;
}

BOOL __declspec(dllexport) WINSERT_DateTime(char *dateFormat,BOOL asField,BOOL twoDigits)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.InsertDateTime(%s,%b,%b)",dateFormat,asField,twoDigits);
return result;
}

BOOL __declspec(dllexport) WINSERT_Symbol(int symbol,char *fontName,BOOL useUnicode,int bias)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.InsertSymbol(%d,%s,%b,%d)",symbol,fontName,useUnicode,bias);
return result;
}

BOOL __declspec(dllexport) WINSERT_HyperLink(char *linkName,char *screenTip,char *textString)
{
if (wSts==TRUE)
{
HRESULT result;
DISPATCH_OBJ(wdRange);
dhGetValue(L"%o",&wdRange,wdApp,L".Selection.Range");
result=dhCallMethod(wdDoc,L".Hyperlinks.Add(%o,%s,%m,%s,%s)",wdRange,linkName,screenTip,textString);
SAFE_RELEASE(wdRange);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WINSERT_AutoText(char *textString)
{
if (wSts==TRUE)
{
HRESULT result;
DISPATCH_OBJ(wdRange);
dhGetValue(L"%o",&wdRange,wdApp,L".Selection.Range");
result=dhCallMethod(wdApp,L".NormalTemplate.AutoTextEntries(%s).Insert(%o,%b)",textString,wdRange,TRUE);
SAFE_RELEASE(wdRange);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WINSERT_Break(int breakType)
{
HRESULT result=FALSE;
if (wSts==TRUE)
result=dhCallMethod(wdApp,L".Selection.InsertBreak(%d)",breakType);
return result;
}

BOOL __declspec(dllexport) WINSERT_Picture(BYTE number,char *fname,BOOL link,BOOL save,int left,int top,int width,int height)
{
if (wSts==TRUE)
{
HRESULT result;
if ((number<1) || (number>4))
return FALSE;
DISPATCH_OBJ(picture);
if (number==1)
result=dhGetValue(L"%o",&picture,canvas1,L".CanvasItems.AddPicture(%s,%b,%b,%d,%d,%d,%d)",fname,link,save,left,top,width,height);
else if (number==2)
result=dhGetValue(L"%o",&picture,canvas2,L".CanvasItems.AddPicture(%s,%b,%b,%d,%d,%d,%d)",fname,link,save,left,top,width,height);
else if (number==3)
result=dhGetValue(L"%o",&picture,canvas3,L".CanvasItems.AddPicture(%s,%b,%b,%d,%d,%d,%d)",fname,link,save,left,top,width,height);
else if (number==4)
result=dhGetValue(L"%o",&picture,canvas4,L".CanvasItems.AddPicture(%s,%b,%b,%d,%d,%d,%d)",fname,link,save,left,top,width,height);
SAFE_RELEASE(picture);
return result;
}
return FALSE;
}

BOOL __declspec(dllexport) WINSERT_File(char *fname,char *textString,BOOL prompt)
{
if (wSts==TRUE)
{
HRESULT result;
WITH(sel,wdApp,L".Selection")
{
result=dhCallMethod(sel,L".InsertFile(%s,%s,%b,%b,%b)",fname,textString,prompt,FALSE,FALSE);
}
END_WITH(sel);
return result;
}
return TRUE;
}

BOOL __declspec(dllexport) WSETTING_SetOnOff(BYTE command,BOOL onoff,int number)
{
if (wSts==TRUE)
{
HRESULT result;
if (command==1)
result=dhPutValue(wdApp,L".Options.PrintDraft = %b",onoff);
else if (command==2)
result=dhPutValue(wdApp,L".Options.UpdateFieldsAtPrint = %b",onoff);
else if (command==3)
result=dhPutValue(wdApp,L".Options.UpdateLinksAtPrint = %b",onoff);
else if (command==4)
result=dhPutValue(wdApp,L".Options.MapPaperSize = %b",onoff);
else if (command==5)
result=dhPutValue(wdApp,L".Options.PrintBackground = %b",onoff);
else if (command==6)
result=dhPutValue(wdApp,L".ActiveDocument.PrintPostScriptOverText = %b",onoff);
else if (command==7)
result=dhPutValue(wdApp,L".Options.PrintReverse = %b",onoff);
else if (command==8)
result=dhPutValue(wdApp,L".Options.PrintProperties = %b",onoff);
else if (command==9)
result=dhPutValue(wdApp,L".Options.PrintFieldCodes = %b",onoff);
else if (command==10)
result=dhPutValue(wdApp,L".Options.PrintHiddenText = %b",onoff);
else if (command==11)
result=dhPutValue(wdApp,L".Options.PrintDrawingObjects = %b",onoff);
else if (command==12)
result=dhPutValue(wdApp,L".ActiveDocument.PrintFormsData = %b",onoff);
else if (command==13)
result=dhPutValue(wdApp,L".Options.PrintOddPagesInAscendingOrder = %b",onoff);
else if (command==14)
result=dhPutValue(wdApp,L".Options.PrintEvenPagesInAscendingOrder = %b",onoff);
else if (command==15)
result=dhPutValue(wdApp,L".Options.DefaultTray = %T","Use printer settings");
else if (command==16)
result=dhPutValue(wdApp,L".Options.DefaultTray = %T","Sheet");

else if (command==20)
result=dhPutValue(wdApp,L".Options.CreateBackup = %b",onoff);
else if (command==21)
result=dhPutValue(wdApp,L".Options.AllowFastSave = %b",onoff);
else if (command==22)
result=dhPutValue(wdApp,L".Options.BackgroundSave = %b",onoff);
else if (command==23)
result=dhPutValue(wdApp,L".ActiveDocument.EmbedTrueTypeFonts = %b",onoff);
else if (command==24)
result=dhPutValue(wdApp,L".ActiveDocument.SaveSubsetFonts = %b",onoff);
else if (command==25)
result=dhPutValue(wdApp,L".ActiveDocument.DoNotEmbedSystemFonts = %b",onoff);
else if (command==26)
result=dhPutValue(wdApp,L".Options.LocalNetworkFile = %b",onoff);
else if (command==27)
result=dhPutValue(wdApp,L".Options.SaveInterval = %d",number);
else if (command==28)
result=dhPutValue(wdApp,L".ActiveDocument.EmbedSmartTags = %b",onoff);
else if (command==29)
result=dhPutValue(wdApp,L".ActiveDocument.SmartTagsAsXMLProps = %b",onoff);
else if (command==30)
result=dhPutValue(wdApp,L".Options.SavePropertiesPrompt = %b",onoff);
else if (command==31)
result=dhPutValue(wdApp,L".Options.SaveNormalPrompt = %b",onoff);
else if (command==32)
result=dhPutValue(wdApp,L".ActiveDocument.SaveFormsData = %b",onoff);
else if (command==33)
result=dhPutValue(wdApp,L".ActiveDocument.EmbedLinguisticData = %b",onoff);
else if (command==34)
{
dhPutValue(wdApp,L".Options.DisableFeaturesbyDefault = %b",TRUE);
dhPutValue(wdApp,L".Options.DisableFeaturesIntroducedAfterbyDefault = %T","wd70");
dhPutValue(wdApp,L".ActiveDocument.DisableFeatures = %b",TRUE);
result=dhPutValue(wdApp,L".ActiveDocument.DisableFeaturesIntroducedAfter = %T","wd70");
}
else if (command==35)
{
dhPutValue(wdApp,L".Options.DisableFeaturesbyDefault = %b",TRUE);
dhPutValue(wdApp,L".Options.DisableFeaturesIntroducedAfterbyDefault = %T","wd80");
dhPutValue(wdApp,L".ActiveDocument.DisableFeatures = %b",TRUE);
result=dhPutValue(wdApp,L".ActiveDocument.DisableFeaturesIntroducedAfter = %T","wd80");
}

else if (command==40)
result=dhPutValue(wdApp,L".Options.CheckSpellingAsYouType = %b",onoff);
else if (command==41)
{
dhPutValue(wdApp,L".Options.CheckSpellingAsYouType = %b",TRUE);
result=dhPutValue(wdApp,L".ActiveDocument.ShowSpellingErrors = %b",FALSE);
}
else if (command==42)
{
dhPutValue(wdApp,L".Options.CheckSpellingAsYouType = %b",TRUE);
result=dhPutValue(wdApp,L".ActiveDocument.ShowSpellingErrors = %b",TRUE);
}
else if (command==43)
result=dhPutValue(wdApp,L".Options.SuggestSpellingCorrections = %b",onoff);
else if (command==44)
result=dhPutValue(wdApp,L".Options.SuggestFromMainDictionaryOnly = %b",onoff);
else if (command==45)
result=dhPutValue(wdApp,L".Options.IgnoreUppercase = %b",onoff);
else if (command==46)
result=dhPutValue(wdApp,L".Options.IgnoreMixedDigits = %b",onoff);
else if (command==47)
result=dhPutValue(wdApp,L".Options.IgnoreInternetAndFileAddresses = %b",onoff);

return result;
}
return FALSE;
}

UINT __declspec(dllexport) WAGENT_SetUp(char *title,int button,int bt,char *item1,char *item2,char *item3,char *item4,char *item5,int x,int y)
{
UINT choice=0;
if (wSts==TRUE)
{
HRESULT result;
DISPATCH_OBJ(wdBalloon);
result=dhGetValue(L"%o",&wdBalloon,wdApp,L".Assistant.NewBalloon");
if (SUCCEEDED(result))
{
if ((button<1) || (button>5))
button=1;
if ((bt<0) || (bt>2))
bt=0;
dhPutValue(wdBalloon,L".Text = %s",title);
if (strcmp(item1,"")!=0)
dhPutValue(wdBalloon,L".Labels(%d).Text = %s",1,item1);
if (strcmp(item2,"")!=0)
dhPutValue(wdBalloon,L".Labels(%d).Text = %s",2,item2);
if (strcmp(item3,"")!=0)
dhPutValue(wdBalloon,L".Labels(%d).Text = %s",3,item3);
if (strcmp(item4,"")!=0)
dhPutValue(wdBalloon,L".Labels(%d).Text = %s",4,item4);
if (strcmp(item5,"")!=0)
dhPutValue(wdBalloon,L".Labels(%d).Text = %s",5,item5);
dhPutValue(wdBalloon,L".BalloonType = %d",bt);
dhCallMethod(wdApp,L".Assistant.Move(%d,%d)",x,y);
dhPutValue(wdApp,L".Assistant.On = %b",TRUE);
dhPutValue(wdApp,L".Assistant.Visible = %b",TRUE);
dhPutValue(wdBalloon,L".Button = %d",button);
dhPutValue(wdBalloon,L".Mode = %d",0);
dhGetValue(L"%d",&choice,wdBalloon,L".Show");
}
SAFE_RELEASE(wdBalloon);
}
return choice;
}

BOOL __declspec(dllexport) WAGENT_Change(BOOL enable,char *fname,int anim,BOOL assist,BOOL guess,BOOL tips,BOOL moveout,BOOL tipofday,int x,int y,BOOL visible)
{
HRESULT result=FALSE;
if (wSts==TRUE)
{
WITH(wdAss,wdApp,L".Assistant")
{
dhPutValue(wdAss,L".On = %b",enable);
dhPutValue(wdAss,L".FileName = %s",fname);
dhPutValue(wdAss,L".Animation = %d",anim);
dhPutValue(wdAss,L".AssistWithHelp = %b",assist);
dhPutValue(wdAss,L".GuessHelp = %b",guess);
dhPutValue(wdAss,L".FeatureTips = %b",tips);
dhPutValue(wdAss,L".MoveWhenInTheWay = %b",moveout);
dhPutValue(wdAss,L".TipOfTheDay = %b",tipofday);
dhPutValue(wdAss,L".Move(%d,%d)",x,y);
dhPutValue(wdAss,L".Visible = %b",visible);
}
END_WITH(wdAss);
}
return result;
}

stringData * __declspec(dllexport) COMALWORD_GetVersion(BYTE verstg)
{
if (verstg==1)
strcpy(sd.rtnStg,"http://www.yoingco.com/");
else if (verstg==2)
strcpy(sd.rtnStg,"john@yoingco.com");
else
strcpy(sd.rtnStg,"ComalWord.dll V1.04 - (c) John White, 2006. All Rights Reserved.");
return &sd;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:

break;
case DLL_PROCESS_DETACH:

break;
case DLL_THREAD_ATTACH:

break;
case DLL_THREAD_DETACH:

break;
}
return TRUE;
}
