#include <disphelper.c>

#define ACCESS_READ  1
#define ACCESS_WRITE 2

typedef struct BIOSInfo
{
unsigned int smMajorVersion;
unsigned int smMinorVersion;
unsigned int primaryBIOS;
unsigned int softwareElementState;
unsigned int targetOS;
char caption[256];
char description[256];
char manufacturer[256];
char name[256];
char serialNumber[256];
char status[10];
char version[64];
char smVersion[256];
} BIOSData;

BIOSData bd;

struct biosPointers
{
int smMajorVersion;
int smMinorVersion;
int primaryBIOS;
int softwareElementState;
int targetOS;
int caption;
int description;
int manufacturer;
int name;
int serialNumber;
int status;
int version;
int smVersion;
};

typedef struct CPUInfo
{
unsigned int currentClockSpeed;
unsigned int maxClockSpeed;
unsigned int addressWidth;
unsigned int architecture;
unsigned int availability;
unsigned int cpuStatus;
unsigned int dataWidth;
unsigned int extClock;
unsigned int family;
unsigned int level;
unsigned int loadPercentage;
unsigned int processorType;
unsigned int revision;
unsigned int statusInfo;
unsigned int upgradeMethod;
char caption[64];
char deviceID[256];
char manufacturer[256];
char name[256];
char otherFamilyDescription[64];
char role[256];
char socketDesignation[256];
char status[10];
char stepping[256];
char version[256];
} CPUData;

CPUData cd;

struct cpuPointers
{
int currentClockSpeed;
int maxClockSpeed;
int addressWidth;
int architecture;
int availability;
int cpuStatus;
int dataWidth;
int extClock;
int family;
int level;
int loadPercentage;
int processorType;
int revision;
int statusInfo;
int upgradeMethod;
int caption;
int deviceID;
int manufacturer;
int name;
int otherFamilyDescription;
int role;
int socketDesignation;
int status;
int stepping;
int version;
};

typedef struct BUSInfo
{
unsigned int availability;
unsigned int busNumber;
unsigned int busType;
unsigned int statusInfo;
char caption[256];
char description[256];
char deviceID[256];
char name[256];
char pnpDeviceID[256];
char status[256];
} BUSData;

BUSData busd[20];

struct busPointers
{
int availability;
int busNumber;
int busType;
int statusInfo;
int caption;
int description;
int deviceID;
int name;
int pnpDeviceID;
int status;
};

typedef struct DTInfo
{
unsigned int borderWidth;
unsigned int coolSwitch;
unsigned int cursorBlinkRate;
unsigned int dragFullWindows;
unsigned int gridGranularity;
unsigned int iconSpacing;
unsigned int iconTitleSize;
unsigned int iconTitleWrap;
unsigned int screenSaverActive;
unsigned int screenSaverSecure;
unsigned int screenSaverTimeout;
unsigned int wallpaperStretched;
unsigned int wallpaperTiled;
char caption[256];
char description[256];
char iconTitleFaceName[256];
char name[256];
char pattern[256];
char screenSaverExecutable[256];
char settingID[256];
char wallpaper[256];
} DTData;

DTData dtd[20];

struct dtPointers
{
int borderWidth;
int coolSwitch;
int cursorBlinkRate;
int dragFullWindows;
int gridGranularity;
int iconSpacing;
int iconTitleSize;
int iconTitleWrap;
int screenSaverActive;
int screenSaverSecure;
int screenSaverTimeout;
int wallpaperStretched;
int wallpaperTiled;
int caption;
int description;
int iconTitleFaceName;
int name;
int pattern;
int screenSaverExecutable;
int settingID;
int wallpaper;
};

typedef struct HFInfo
{
char description[256];
char fixComments[256];
char hotFixID[256];
char installedBy[256];
char installedOn[256];
char servicePackInEffect[256];
} HFData;

HFData hfd[300];

struct hfPointers
{
int description;
int fixComments;
int hotFixID;
int installedBy;
int installedOn;
int servicePackInEffect;
};

typedef struct ISInfo
{
unsigned int installState;
char caption[256];
char description[256];
char identifyingNumber[256];
char installDate[256];
char installLocation[256];
char name[256];
char packageCache[256];
char skuNumber[256];
char vendor[256];
char version[256];
} ISData;

ISData isd[50];

struct isPointers
{
int installState;
int caption;
int description;
int identifyingNumber;
int installDate;
int installLocation;
int name;
int packageCache;
int skuNumber;
int vendor;
int version;
};

typedef struct ssInfo
{
unsigned int acceptPause;
unsigned int acceptStop;
unsigned int desktopInteract;
unsigned int processID;
unsigned int started;
unsigned int waitHint;
char caption[256];
char description[256];
char displayName[256];
char name[256];
char pathName[256];
char serviceType[256];
char startMode[256];
char startName[256];
char state[256];
char status[256];
} SSData;

SSData ssd[150];

struct ssPointers
{
int acceptPause;
int acceptStop;
int desktopInteract;
int processID;
int started;
int waitHint;
int caption;
int description;
int displayName;
int name;
int pathName;
int serviceType;
int startMode;
int startName;
int state;
int status;
};

typedef struct NWAInfo
{
unsigned int adapterTypeID;
unsigned int autoSense;
unsigned int availability;
unsigned int index;
unsigned int installed;
unsigned int maxNumberControlled;
unsigned int netConnectionStaus;
unsigned int powerManagementSupported;
unsigned int statusInfo;
char adapterType[256];
char caption[256];
char description[256];
char deviceID[256];
char macAddress[256];
char manufacturer[256];
char netConnectionID[256];
char pnpDeviceID[256];
char productName[256];
char serviceName[256];
} NWAData;

NWAData nwad[20];

struct nwaPointers
{
int adapterTypeID;
int autoSense;
int availability;
int index;
int installed;
int maxNumberControlled;
int netConnectionStaus;
int powerManagementSupported;
int statusInfo;
int adapterType;
int caption;
int description;
int deviceID;
int macAddress;
int manufacturer;
int netConnectionID;
int pnpDeviceID;
int productName;
int serviceName;
};

typedef struct OSInfo
{
unsigned int currentTimeZone;
unsigned int numOfUsers;
unsigned int osLanguage;
unsigned int osType;
unsigned int primary;
unsigned int spMajorVersion;
unsigned int spMinorVersion;
char bootDevice[256];
char buildNumber[256];
char buildType[256];
char caption[256];
char codeSet[6];
char countryCode[256];
char description[256];
char locale[256];
char manufacturer[256];
char name[256];
char organization[256];
char registeredUser[256];
char serialNumber[256];
char status[256];
char systemDevice[256];
char systemDirectory[256];
char systemDrive[256];
char version[256];
char windowsDirectory[256];
} OSData;

OSData osd;

struct osPointers
{
int currentTimeZone;
int numOfUsers;
int osLanguage;
int osType;
int primary;
int spMajorVersion;
int spMinorVersion;
int bootDevice;
int buildNumber;
int buildType;
int caption;
int codeSet;
int countryCode;
int description;
int locale;
int manufacturer;
int name;
int organization;
int registeredUser;
int serialNumber;
int status;
int systemDevice;
int systemDirectory;
int systemDrive;
int version;
int windowsDirectory;
};

typedef struct UAInfo
{
unsigned int accountType;
unsigned int disabled;
unsigned int localAccount;
unsigned int lockout;
unsigned int passwordChangable;
unsigned int passwordExpires;
unsigned int passwordRequired;
unsigned int sidType;
char caption[256];
char description[256];
char domain[256];
char fullName[256];
char name[256];
char sid[256];
char status[256];
} UAData;

UAData uad[20];

struct uaPointers
{
int accountType;
int disabled;
int localAccount;
int lockout;
int passwordChangable;
int passwordExpires;
int passwordRequired;
int sidType;
int caption;
int description;
int domain;
int fullName;
int name;
int sid;
int status;
};

typedef struct VIDEOInfo
{
unsigned int adapterRAM;
unsigned int availability;
unsigned int colorTableEntries;
unsigned int currentBitsPerPixel;
unsigned int currentHorizontalResolution;
unsigned int currentNumberOfColumns;
unsigned int currentNumberOfRows;
unsigned int currentRefreshRate;
unsigned int currentScanMode;
unsigned int currentVerticalResolution;
unsigned int deviceSpecificPens;
unsigned int ditherType;
unsigned int icmIntent;
unsigned int icmMethod;
unsigned int maxMemorySupported;
unsigned int maxNumberControlled;
unsigned int maxRefreshRate;
unsigned int minRefreshRate;
unsigned int monochrome;
unsigned int numberOfColorPlanes;
unsigned int numberOfVideoPages;
unsigned int protocolSupported;
unsigned int reservedSystemPaletteEntries;
unsigned int specificationVersion;
unsigned int statusInfo;
unsigned int systemPaletteEntries;
unsigned int videoArchitecture;
unsigned int videoMemoryType;
unsigned int videoMode;
char adapterCompatibility[256];
char adapterDACType[256];
char compatibilityDescriptions[256];
char caption[256];
char description[256];
char deviceID[256];
char driverVersion[256];
char infFilename[256];
char infSection[256];
char installedDisplayDrivers[256];
char name[256];
char pnpDeviceID[256];
char status[256];
char videoModeDescription[256];
char videoProcessor[256];
} VIDEOData;

VIDEOData videod[20];

struct videoPointers
{
int adapterRAM;
int availability;
int colorTableEntries;
int currentBitsPerPixel;
int currentHorizontalResolution;
int currentNumberOfColumns;
int currentNumberOfRows;
int currentRefreshRate;
int currentScanMode;
int currentVerticalResolution;
int deviceSpecificPens;
int ditherType;
int icmIntent;
int icmMethod;
int maxMemorySupported;
int maxNumberControlled;
int maxRefreshRate;
int minRefreshRate;
int monochrome;
int numberOfColorPlanes;
int numberOfVideoPages;
int protocolSupported;
int reservedSystemPaletteEntries;
int specificationVersion;
int statusInfo;
int systemPaletteEntries;
int videoArchitecture;
int videoMemoryType;
int videoMode;
int adapterCompatibility;
int adapterDACType;
int compatibilityDescriptions;
int caption;
int description;
int deviceID;
int driverVersion;
int infFilename;
int infSection;
int installedDisplayDrivers;
int name;
int pnpDeviceID;
int status;
int videoModeDescription;
int videoProcessor;
};

extern int Is_Admin(void);
extern void Get_BIOSInfo(struct biosPointers *biosPtr);
extern void Get_CPUInfo(struct cpuPointers *cpuPtr);
extern int Get_BUSData(void);
extern void Get_BUSInfo(int,struct busPointers *busPtr);
extern int Get_DTData(void);
extern void Get_DTInfo(int,struct dtPointers *dtPtr);
extern int Get_HOTFIXESData(void);
extern void Get_HOTFIXESInfo(int,struct hfPointers *hfPtr);
extern int Get_ISData(void);
extern void Get_ISInfo(int,struct isPointers *isPtr);
extern int Get_SSData(void);
extern void Get_SSInfo(int,struct ssPointers *ssPtr);
extern int Get_NWAData(void);
extern void Get_NWAInfo(int,struct nwaPointers *nwaPtr);
extern int Get_UAData(void);
extern void Get_UAInfo(int,struct uaPointers *uaPtr);
extern int Get_VIDEOData(void);
extern void Get_VIDEOInfo(int,struct videoPointers *videoPtr);
extern void Get_OSInfo(struct osPointers *osPtr);

int rtn=0,hfcounter=0,nwacounter=0,uacounter=0,buscounter=0,dtcounter=0,iscounter=0,videocounter=0,sscounter=0;

int __declspec(dllexport) Is_Admin(void)
{
HANDLE hToken;
DWORD dwStatus;
DWORD dwAccessMask;
DWORD dwAccessDesired;
DWORD dwACLSize;
DWORD dwStructureSize = sizeof(PRIVILEGE_SET);
PACL pACL=NULL;
PSID psidAdmin=NULL;
BOOL bReturn=FALSE;
PRIVILEGE_SET ps;
GENERIC_MAPPING GenericMapping;
PSECURITY_DESCRIPTOR psdAdmin=NULL;
SID_IDENTIFIER_AUTHORITY SystemSidAuthority=SECURITY_NT_AUTHORITY;
if(!ImpersonateSelf(SecurityImpersonation))
goto LeaveIsAdmin;
if (!OpenThreadToken(GetCurrentThread(), TOKEN_QUERY, FALSE, &hToken))
{
if (GetLastError()!=ERROR_NO_TOKEN)
goto LeaveIsAdmin;
if (!OpenProcessToken(GetCurrentProcess(),TOKEN_QUERY,&hToken))
goto LeaveIsAdmin;
if (!OpenProcessToken(GetCurrentProcess(),TOKEN_QUERY,&hToken))
goto LeaveIsAdmin;
}
if (!AllocateAndInitializeSid(&SystemSidAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&psidAdmin))
goto LeaveIsAdmin;
psdAdmin=LocalAlloc(LPTR,SECURITY_DESCRIPTOR_MIN_LENGTH);
if (psdAdmin==NULL)
goto LeaveIsAdmin;
if (!InitializeSecurityDescriptor(psdAdmin,SECURITY_DESCRIPTOR_REVISION))
goto LeaveIsAdmin;
dwACLSize=sizeof(ACL)+sizeof(ACCESS_ALLOWED_ACE)+GetLengthSid(psidAdmin)-sizeof(DWORD);
pACL=(PACL)LocalAlloc(LPTR,dwACLSize);
if (pACL==NULL)
goto LeaveIsAdmin;
if (!InitializeAcl(pACL,dwACLSize,ACL_REVISION2))
goto LeaveIsAdmin;
dwAccessMask=ACCESS_READ|ACCESS_WRITE;
if (!AddAccessAllowedAce(pACL,ACL_REVISION2,dwAccessMask,psidAdmin))
goto LeaveIsAdmin;
if (!SetSecurityDescriptorDacl(psdAdmin,TRUE,pACL,FALSE))
goto LeaveIsAdmin;
if(!SetSecurityDescriptorGroup(psdAdmin,psidAdmin,FALSE))
goto LeaveIsAdmin;
if(!SetSecurityDescriptorOwner(psdAdmin,psidAdmin,FALSE))
goto LeaveIsAdmin;
if (!IsValidSecurityDescriptor(psdAdmin))
goto LeaveIsAdmin;
dwAccessDesired=ACCESS_READ;
GenericMapping.GenericRead=ACCESS_READ;
GenericMapping.GenericWrite=ACCESS_WRITE;
GenericMapping.GenericExecute=0;
GenericMapping.GenericAll=ACCESS_READ|ACCESS_WRITE;
if (!AccessCheck(psdAdmin,hToken,dwAccessDesired,&GenericMapping,&ps,&dwStructureSize,&dwStatus,&bReturn))
goto LeaveIsAdmin;
if(!RevertToSelf())
bReturn = FALSE;
LeaveIsAdmin:
if (pACL) LocalFree(pACL);
if (psdAdmin) LocalFree(psdAdmin);
if (psidAdmin) FreeSid(psidAdmin);
return bReturn;
}

void __declspec(dllexport) Get_BIOSInfo(struct biosPointers *biosPtr)
{
BOOL tf=FALSE;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Bios");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL;

dhGetValue(L"%u",&bd.softwareElementState,propertyObj,L".SoftwareElementState");
biosPtr->softwareElementState=bd.softwareElementState;
dhGetValue(L"%u",&bd.targetOS,propertyObj,L".TargetOperatingSystem");
biosPtr->targetOS=bd.targetOS;

dhGetValue(L"%b",&tf,propertyObj,L".PrimaryBIOS");
if (tf==FALSE)
bd.primaryBIOS=0;
else
bd.primaryBIOS=1;
biosPtr->primaryBIOS=bd.primaryBIOS;

dhGetValue(L"%b",&tf,propertyObj,L".SMBIOSPresent");
if (tf!=FALSE)
{
dhGetValue(L"%s",&stg8,propertyObj,L".SMBIOSBIOSVersion");
sprintf(bd.smVersion,"%s",stg8);
biosPtr->smVersion=(int)&bd.smVersion;
dhGetValue(L"%u",&bd.smMajorVersion,propertyObj,L".SMBIOSMajorVersion");
biosPtr->smMajorVersion=bd.smMajorVersion;
dhGetValue(L"%u",&bd.smMinorVersion,propertyObj,L".SMBIOSMinorVersion");
biosPtr->smMinorVersion=bd.smMinorVersion;
}
else
{
strcpy(bd.smVersion,"Not Supported");
biosPtr->smVersion=(int)&bd.smVersion;
bd.smMajorVersion=0;
biosPtr->smMajorVersion=bd.smMajorVersion;
bd.smMinorVersion=0;
biosPtr->smMinorVersion=bd.smMinorVersion;
}

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".Manufacturer");
dhGetValue(L"%s",&stg4,propertyObj,L".Name");
dhGetValue(L"%s",&stg5,propertyObj,L".SerialNumber");
dhGetValue(L"%s",&stg6,propertyObj,L".Status");
dhGetValue(L"%s",&stg7,propertyObj,L".Version");

sprintf(bd.caption,"%s",stg1);
biosPtr->caption=(int)&bd.caption;
sprintf(bd.description,"%s",stg2);
biosPtr->description=(int)&bd.description;
sprintf(bd.manufacturer,"%s",stg3);
biosPtr->manufacturer=(int)&bd.manufacturer;
sprintf(bd.name,"%s",stg4);
biosPtr->name=(int)&bd.name;
sprintf(bd.serialNumber,"%s",stg5);
biosPtr->serialNumber=(int)&bd.serialNumber;
sprintf(bd.status,"%s",stg6);
biosPtr->status=(int)&bd.status;
sprintf(bd.version,"%s",stg7);
biosPtr->version=(int)&bd.version;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
}

void __declspec(dllexport) Get_CPUInfo(struct cpuPointers *cpuPtr)
{
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Processor");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL;

dhGetValue(L"%u",&cd.currentClockSpeed,propertyObj,L".CurrentClockSpeed");
cpuPtr->currentClockSpeed=cd.currentClockSpeed;
dhGetValue(L"%u",&cd.maxClockSpeed,propertyObj,L".MaxClockSpeed");
cpuPtr->maxClockSpeed=cd.maxClockSpeed;
dhGetValue(L"%u",&cd.addressWidth,propertyObj,L".AddressWidth");
cpuPtr->addressWidth=cd.addressWidth;
dhGetValue(L"%u",&cd.architecture,propertyObj,L".Architecture");
cpuPtr->architecture=cd.architecture;
dhGetValue(L"%u",&cd.availability,propertyObj,L".Availability");
cpuPtr->availability=cd.availability;
dhGetValue(L"%u",&cd.cpuStatus,propertyObj,L".CpuStatus");
cpuPtr->cpuStatus=cd.cpuStatus;
dhGetValue(L"%u",&cd.dataWidth,propertyObj,L".DataWidth");
cpuPtr->dataWidth=cd.dataWidth;
dhGetValue(L"%u",&cd.extClock,propertyObj,L".ExtClock");
cpuPtr->extClock=cd.extClock;
dhGetValue(L"%u",&cd.family,propertyObj,L".Family");
cpuPtr->family=cd.family;
dhGetValue(L"%u",&cd.level,propertyObj,L".Level");
cpuPtr->level=cd.level;
dhGetValue(L"%u",&cd.loadPercentage,propertyObj,L".LoadPercentage");
cpuPtr->loadPercentage=cd.loadPercentage;
dhGetValue(L"%u",&cd.processorType,propertyObj,L".ProcessorType");
cpuPtr->processorType=cd.processorType;
dhGetValue(L"%u",&cd.revision,propertyObj,L".Revision");
cpuPtr->revision=cd.revision;
dhGetValue(L"%u",&cd.statusInfo,propertyObj,L".StatusInfo");
cpuPtr->statusInfo=cd.statusInfo;
dhGetValue(L"%u",&cd.upgradeMethod,propertyObj,L".UpgradeMethod");
cpuPtr->upgradeMethod=cd.upgradeMethod;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".DeviceID");
dhGetValue(L"%s",&stg3,propertyObj,L".Manufacturer");
dhGetValue(L"%s",&stg4,propertyObj,L".Name");
dhGetValue(L"%s",&stg5,propertyObj,L".OtherFamilyDescription");
dhGetValue(L"%s",&stg6,propertyObj,L".Role");
dhGetValue(L"%s",&stg7,propertyObj,L".SocketDesignation");
dhGetValue(L"%s",&stg8,propertyObj,L".Status");
dhGetValue(L"%s",&stg9,propertyObj,L".Stepping");
dhGetValue(L"%s",&stg10,propertyObj,L".Version");

sprintf(cd.caption,"%s",stg1);
cpuPtr->caption=(int)&cd.caption;
sprintf(cd.deviceID,"%s",stg2);
cpuPtr->deviceID=(int)&cd.deviceID;
sprintf(cd.manufacturer,"%s",stg3);
cpuPtr->manufacturer=(int)&cd.manufacturer;
sprintf(cd.name,"%s",stg4);
cpuPtr->name=(int)&cd.name;
if (cd.family!=1)
strcpy(cd.otherFamilyDescription,"Not Supported");
else
sprintf(cd.otherFamilyDescription,"%s",stg5);
cpuPtr->otherFamilyDescription=(int)&cd.otherFamilyDescription;
sprintf(cd.role,"%s",stg6);
cpuPtr->role=(int)&cd.role;
sprintf(cd.socketDesignation,"%s",stg7);
cpuPtr->socketDesignation=(int)&cd.socketDesignation;
sprintf(cd.status,"%s",stg8);
cpuPtr->status=(int)&cd.status;
sprintf(cd.stepping,"%s",stg9);
cpuPtr->stepping=(int)&cd.stepping;
sprintf(cd.version,"%s",stg10);
cpuPtr->version=(int)&cd.version;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
}

int __declspec(dllexport) Get_HOTFIXESData(void)
{
hfcounter=0;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_QuickFixEngineering");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Description");
dhGetValue(L"%s",&stg2,propertyObj,L".FixComments");
dhGetValue(L"%s",&stg3,propertyObj,L".HotFixID");
dhGetValue(L"%s",&stg4,propertyObj,L".InstalledBy");
dhGetValue(L"%s",&stg5,propertyObj,L".InstalledOn");
dhGetValue(L"%s",&stg6,propertyObj,L".ServicePackInEffect");

sprintf(hfd[hfcounter].description,"%s",stg1);
sprintf(hfd[hfcounter].fixComments,"%s",stg2);
sprintf(hfd[hfcounter].hotFixID,"%s",stg3);
sprintf(hfd[hfcounter].installedBy,"%s",stg4);
sprintf(hfd[hfcounter].installedOn,"%s",stg5);
sprintf(hfd[hfcounter].servicePackInEffect,"%s",stg6);

hfcounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return hfcounter;
}

void __declspec(dllexport) Get_HOTFIXESInfo(int index,struct hfPointers *hfPtr)
{
hfPtr->description=(int)&hfd[index].description;
hfPtr->fixComments=(int)&hfd[index].fixComments;
hfPtr->hotFixID=(int)&hfd[index].hotFixID;
hfPtr->installedBy=(int)&hfd[index].installedBy;
hfPtr->installedOn=(int)&hfd[index].installedOn;
hfPtr->servicePackInEffect=(int)&hfd[index].servicePackInEffect;
}

int __declspec(dllexport) Get_BUSData(void)
{
buscounter=0;
unsigned int num1=0,num2=0,num3=0,num4=0;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Bus");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".DeviceID");
dhGetValue(L"%s",&stg4,propertyObj,L".Name");
dhGetValue(L"%s",&stg5,propertyObj,L".PNPDeviceID");
dhGetValue(L"%s",&stg6,propertyObj,L".Status");

sprintf(busd[buscounter].caption,"%s",stg1);
sprintf(busd[buscounter].description,"%s",stg2);
sprintf(busd[buscounter].deviceID,"%s",stg3);
sprintf(busd[buscounter].name,"%s",stg4);
sprintf(busd[buscounter].pnpDeviceID,"%s",stg5);
sprintf(busd[buscounter].status,"%s",stg6);

dhGetValue(L"%u",&num1,propertyObj,L".Availability");
dhGetValue(L"%u",&num2,propertyObj,L".BusNum");
dhGetValue(L"%u",&num3,propertyObj,L".BusType");
dhGetValue(L"%u",&num4,propertyObj,L".StatusInfo");

busd[buscounter].availability=num1;
busd[buscounter].busNumber=num2;
busd[buscounter].busType=num3;
busd[buscounter].statusInfo=num4;

buscounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return buscounter;
}

void __declspec(dllexport) Get_BUSInfo(int index,struct busPointers *busPtr)
{
busPtr->availability=busd[index].availability;
busPtr->busNumber=busd[index].busNumber;
busPtr->busType=busd[index].busType;
busPtr->statusInfo=busd[index].statusInfo;
busPtr->caption=(int)&busd[index].caption;
busPtr->description=(int)&busd[index].description;
busPtr->deviceID=(int)&busd[index].deviceID;
busPtr->name=(int)&busd[index].name;
busPtr->pnpDeviceID=(int)&busd[index].pnpDeviceID;
busPtr->status=(int)&busd[index].status;
}

int __declspec(dllexport) Get_DTData(void)
{
dtcounter=0;
unsigned int num1=0,num2=0,num3=0,num4=0,num5=0,num6=0,num7=0,num8=0,num9=0,num10=0,num11=0,num12=0,num13=0;
BOOL tf=FALSE;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Desktop");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".IconTitleFaceName");
dhGetValue(L"%s",&stg4,propertyObj,L".Name");
dhGetValue(L"%s",&stg5,propertyObj,L".Pattern");
dhGetValue(L"%s",&stg6,propertyObj,L".ScreenSaverExecutable");
dhGetValue(L"%s",&stg7,propertyObj,L".SettingID");
dhGetValue(L"%s",&stg8,propertyObj,L".Wallpaper");

sprintf(dtd[dtcounter].caption,"%s",stg1);
sprintf(dtd[dtcounter].description,"%s",stg2);
sprintf(dtd[dtcounter].iconTitleFaceName,"%s",stg3);
sprintf(dtd[dtcounter].name,"%s",stg4);
sprintf(dtd[dtcounter].pattern,"%s",stg5);
sprintf(dtd[dtcounter].screenSaverExecutable,"%s",stg6);
sprintf(dtd[dtcounter].settingID,"%s",stg7);
sprintf(dtd[dtcounter].wallpaper,"%s",stg8);

dhGetValue(L"%u",&num1,propertyObj,L".BorderWidth");
dhGetValue(L"%b",&tf,propertyObj,L".CoolSwitch");
if (tf!=FALSE)
num2=1;
else
num2=0;
dhGetValue(L"%u",&num3,propertyObj,L".CursorBlinkRate");
dhGetValue(L"%b",&tf,propertyObj,L".DragFullWindows");
if (tf!=FALSE)
num4=1;
else
num4=0;
dhGetValue(L"%u",&num5,propertyObj,L".GridGranularity");
dhGetValue(L"%u",&num6,propertyObj,L".IconSpacing");
dhGetValue(L"%u",&num7,propertyObj,L".IconTitleSize");
dhGetValue(L"%b",&tf,propertyObj,L".IconTitleWrap");
if (tf!=FALSE)
num8=1;
else
num8=0;
dhGetValue(L"%b",&tf,propertyObj,L".ScreenSaverActive");
if (tf!=FALSE)
num9=1;
else
num9=0;
dhGetValue(L"%b",&tf,propertyObj,L".ScreenSaverSecure");
if (tf!=FALSE)
num10=1;
else
num10=0;
dhGetValue(L"%u",&num11,propertyObj,L".ScreenSaverTimeout");
dhGetValue(L"%b",&tf,propertyObj,L".WallpaperStretched");
if (tf!=FALSE)
num12=1;
else
num12=0;
dhGetValue(L"%b",&tf,propertyObj,L".WallpaperTiled");
if (tf!=FALSE)
num13=1;
else
num13=0;

dtd[dtcounter].borderWidth=num1;
dtd[dtcounter].coolSwitch=num2;
dtd[dtcounter].cursorBlinkRate=num3;
dtd[dtcounter].dragFullWindows=num4;
dtd[dtcounter].gridGranularity=num5;
dtd[dtcounter].iconSpacing=num6;
dtd[dtcounter].iconTitleSize=num7;
dtd[dtcounter].iconTitleWrap=num8;
dtd[dtcounter].screenSaverActive=num9;
dtd[dtcounter].screenSaverSecure=num10;
dtd[dtcounter].screenSaverTimeout=num11;
dtd[dtcounter].wallpaperStretched=num12;
dtd[dtcounter].wallpaperTiled=num13;

dtcounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return dtcounter;
}

void __declspec(dllexport) Get_DTInfo(int index,struct dtPointers *dtPtr)
{
dtPtr->borderWidth=dtd[index].borderWidth;
dtPtr->coolSwitch=dtd[index].coolSwitch;
dtPtr->cursorBlinkRate=dtd[index].cursorBlinkRate;
dtPtr->dragFullWindows=dtd[index].dragFullWindows;
dtPtr->gridGranularity=dtd[index].gridGranularity;
dtPtr->iconSpacing=dtd[index].iconSpacing;
dtPtr->iconTitleSize=dtd[index].iconTitleSize;
dtPtr->iconTitleWrap=dtd[index].iconTitleWrap;
dtPtr->screenSaverActive=dtd[index].screenSaverActive;
dtPtr->screenSaverSecure=dtd[index].screenSaverSecure;
dtPtr->screenSaverTimeout=dtd[index].screenSaverTimeout;
dtPtr->wallpaperStretched=dtd[index].wallpaperStretched;
dtPtr->wallpaperTiled=dtd[index].wallpaperTiled;
dtPtr->caption=(int)&dtd[index].caption;
dtPtr->description=(int)&dtd[index].description;
dtPtr->iconTitleFaceName=(int)&dtd[index].iconTitleFaceName;
dtPtr->name=(int)&dtd[index].name;
dtPtr->pattern=(int)&dtd[index].pattern;
dtPtr->screenSaverExecutable=(int)&dtd[index].screenSaverExecutable;
dtPtr->settingID=(int)&dtd[index].settingID;
dtPtr->wallpaper=(int)&dtd[index].wallpaper;
}

int __declspec(dllexport) Get_ISData(void)
{
iscounter=0;
unsigned int num1=0;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Product");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".IdentifyingNumber");
dhGetValue(L"%s",&stg4,propertyObj,L".InstallDate");
dhGetValue(L"%s",&stg5,propertyObj,L".InstallLocation");
dhGetValue(L"%s",&stg6,propertyObj,L".Name");
dhGetValue(L"%s",&stg7,propertyObj,L".PackageCache");
dhGetValue(L"%s",&stg8,propertyObj,L".SKUNumber");
dhGetValue(L"%s",&stg9,propertyObj,L".Vendor");
dhGetValue(L"%s",&stg10,propertyObj,L".Version");

sprintf(isd[iscounter].caption,"%s",stg1);
sprintf(isd[iscounter].description,"%s",stg2);
sprintf(isd[iscounter].identifyingNumber,"%s",stg3);
sprintf(isd[iscounter].installDate,"%s",stg4);
sprintf(isd[iscounter].installLocation,"%s",stg5);
sprintf(isd[iscounter].name,"%s",stg6);
sprintf(isd[iscounter].packageCache,"%s",stg7);
sprintf(isd[iscounter].skuNumber,"%s",stg8);
sprintf(isd[iscounter].vendor,"%s",stg9);
sprintf(isd[iscounter].version,"%s",stg10);

dhGetValue(L"%u",&num1,propertyObj,L".InstallState");

isd[iscounter].installState=num1;

iscounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return iscounter;
}

void __declspec(dllexport) Get_ISInfo(int index,struct isPointers *isPtr)
{
isPtr->installState=isd[index].installState;
isPtr->caption=(int)&isd[index].caption;
isPtr->description=(int)&isd[index].description;
isPtr->identifyingNumber=(int)&isd[index].identifyingNumber;
isPtr->installDate=(int)&isd[index].installDate;
isPtr->installLocation=(int)&isd[index].installLocation;
isPtr->name=(int)&isd[index].name;
isPtr->packageCache=(int)&isd[index].packageCache;
isPtr->skuNumber=(int)&isd[index].skuNumber;
isPtr->vendor=(int)&isd[index].vendor;
isPtr->version=(int)&isd[index].version;
}

int __declspec(dllexport) Get_SSData(void)
{
sscounter=0;
BOOL tf=FALSE;
unsigned int num1=0,num2=0,num3=0,num4=0,num5=0,num6=0;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_Service");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".DisplayName");
dhGetValue(L"%s",&stg4,propertyObj,L".Name");
dhGetValue(L"%s",&stg5,propertyObj,L".PathName");
dhGetValue(L"%s",&stg6,propertyObj,L".ServiceType");
dhGetValue(L"%s",&stg7,propertyObj,L".StartMode");
dhGetValue(L"%s",&stg8,propertyObj,L".StartName");
dhGetValue(L"%s",&stg9,propertyObj,L".State");
dhGetValue(L"%s",&stg10,propertyObj,L".Status");

sprintf(ssd[sscounter].caption,"%s",stg1);
sprintf(ssd[sscounter].description,"%s",stg2);
sprintf(ssd[sscounter].displayName,"%s",stg3);
sprintf(ssd[sscounter].name,"%s",stg4);
sprintf(ssd[sscounter].pathName,"%s",stg5);
sprintf(ssd[sscounter].serviceType,"%s",stg6);
sprintf(ssd[sscounter].startMode,"%s",stg7);
sprintf(ssd[sscounter].startName,"%s",stg8);
sprintf(ssd[sscounter].state,"%s",stg9);
sprintf(ssd[sscounter].status,"%s",stg10);

dhGetValue(L"%b",&tf,propertyObj,L".acceptPause");
if (tf!=FALSE)
num1=1;
else
num1=0;
dhGetValue(L"%b",&tf,propertyObj,L".acceptStop");
if (tf!=FALSE)
num2=1;
else
num2=0;
dhGetValue(L"%b",&tf,propertyObj,L".desktopInteract");
if (tf!=FALSE)
num3=1;
else
num3=0;
dhGetValue(L"%u",&num4,propertyObj,L".processID");
dhGetValue(L"%b",&tf,propertyObj,L".started");
if (tf!=FALSE)
num5=1;
else
num5=0;
dhGetValue(L"%u",&num6,propertyObj,L".waitHint");

ssd[sscounter].acceptPause=num1;
ssd[sscounter].acceptStop=num2;
ssd[sscounter].desktopInteract=num3;
ssd[sscounter].processID=num4;
ssd[sscounter].started=num5;
ssd[sscounter].waitHint=num6;

sscounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return iscounter;
}

void __declspec(dllexport) Get_SSInfo(int index,struct ssPointers *ssPtr)
{
ssPtr->acceptPause=ssd[index].acceptPause;
ssPtr->acceptStop=ssd[index].acceptStop;
ssPtr->desktopInteract=ssd[index].desktopInteract;
ssPtr->processID=ssd[index].processID;
ssPtr->started=ssd[index].started;
ssPtr->waitHint=ssd[index].waitHint;
ssPtr->caption=(int)&ssd[index].caption;
ssPtr->description=(int)&ssd[index].description;
ssPtr->displayName=(int)&ssd[index].displayName;
ssPtr->name=(int)&ssd[index].name;
ssPtr->pathName=(int)&ssd[index].pathName;
ssPtr->serviceType=(int)&ssd[index].serviceType;
ssPtr->startMode=(int)&ssd[index].startMode;
ssPtr->startName=(int)&ssd[index].startName;
ssPtr->state=(int)&ssd[index].state;
ssPtr->status=(int)&ssd[index].status;
}

int __declspec(dllexport) Get_NWAData(void)
{
nwacounter=0;
unsigned int num1=0,num2=0,num3=0,num4=0,num5=0,num6=0,num7=0,num8=0,num9=0;
BOOL tf=FALSE;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_NetworkAdapter");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".AdapterType");
dhGetValue(L"%s",&stg2,propertyObj,L".Caption");
dhGetValue(L"%s",&stg3,propertyObj,L".Description");
dhGetValue(L"%s",&stg4,propertyObj,L".DeviceID");
dhGetValue(L"%s",&stg5,propertyObj,L".MACAddress");
dhGetValue(L"%s",&stg6,propertyObj,L".Manufacturer");
dhGetValue(L"%s",&stg7,propertyObj,L".NetConnectionID");
dhGetValue(L"%s",&stg8,propertyObj,L".PnPDeviceID");
dhGetValue(L"%s",&stg9,propertyObj,L".ProductName");
dhGetValue(L"%s",&stg10,propertyObj,L".ServiceName");

sprintf(nwad[nwacounter].adapterType,"%s",stg1);
sprintf(nwad[nwacounter].caption,"%s",stg2);
sprintf(nwad[nwacounter].description,"%s",stg3);
sprintf(nwad[nwacounter].deviceID,"%s",stg4);
sprintf(nwad[nwacounter].macAddress,"%s",stg5);
sprintf(nwad[nwacounter].manufacturer,"%s",stg6);
sprintf(nwad[nwacounter].netConnectionID,"%s",stg7);
sprintf(nwad[nwacounter].pnpDeviceID,"%s",stg8);
sprintf(nwad[nwacounter].productName,"%s",stg9);
sprintf(nwad[nwacounter].serviceName,"%s",stg10);

dhGetValue(L"%u",&num1,propertyObj,L".AdapterTypeID");
dhGetValue(L"%b",&tf,propertyObj,L".AutoSense");
if (tf!=FALSE)
num2=1;
else
num2=0;
dhGetValue(L"%u",&num3,propertyObj,L".Availability");
dhGetValue(L"%u",&num4,propertyObj,L".Index");
dhGetValue(L"%b",&tf,propertyObj,L".Installed");
if (tf!=FALSE)
num5=1;
else
num5=0;
dhGetValue(L"%u",&num6,propertyObj,L".MaxNumberControlled");
dhGetValue(L"%u",&num7,propertyObj,L".NetConnectionStaus");
dhGetValue(L"%b",&tf,propertyObj,L".PowerManagementSupported");
if (tf!=FALSE)
num8=1;
else
num8=0;
dhGetValue(L"%u",&num9,propertyObj,L".StatusInfo");

nwad[nwacounter].adapterTypeID=num1;
nwad[nwacounter].autoSense=num2;
nwad[nwacounter].availability=num3;
nwad[nwacounter].index=num4;
nwad[nwacounter].installed=num5;
nwad[nwacounter].maxNumberControlled=num6;
nwad[nwacounter].netConnectionStaus=num7;
nwad[nwacounter].powerManagementSupported=num8;
nwad[nwacounter].statusInfo=num9;

nwacounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return nwacounter;
}

void __declspec(dllexport) Get_NWAInfo(int index,struct nwaPointers *nwaPtr)
{
nwaPtr->adapterTypeID=nwad[index].adapterTypeID;
nwaPtr->autoSense=nwad[index].autoSense;
nwaPtr->availability=nwad[index].availability;
nwaPtr->index=nwad[index].index;
nwaPtr->installed=nwad[index].installed;
nwaPtr->maxNumberControlled=nwad[index].maxNumberControlled;
nwaPtr->netConnectionStaus=nwad[index].netConnectionStaus;
nwaPtr->powerManagementSupported=nwad[index].powerManagementSupported;
nwaPtr->statusInfo=nwad[index].statusInfo;
nwaPtr->adapterType=(int)&nwad[index].adapterType;
nwaPtr->caption=(int)&nwad[index].caption;
nwaPtr->description=(int)&nwad[index].description;
nwaPtr->deviceID=(int)&nwad[index].deviceID;
nwaPtr->macAddress=(int)&nwad[index].macAddress;
nwaPtr->manufacturer=(int)&nwad[index].manufacturer;
nwaPtr->netConnectionID=(int)&nwad[index].netConnectionID;
nwaPtr->pnpDeviceID=(int)&nwad[index].pnpDeviceID;
nwaPtr->productName=(int)&nwad[index].productName;
nwaPtr->serviceName=(int)&nwad[index].serviceName;
}

int __declspec(dllexport) Get_UAData(void)
{
uacounter=0;
unsigned int num1=0,num2=0,num3=0,num4=0,num5=0,num6=0,num7=0,num8=0;
BOOL tf=FALSE;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_UserAccount");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".Caption");
dhGetValue(L"%s",&stg2,propertyObj,L".Description");
dhGetValue(L"%s",&stg3,propertyObj,L".Domain");
dhGetValue(L"%s",&stg4,propertyObj,L".FullName");
dhGetValue(L"%s",&stg5,propertyObj,L".Name");
dhGetValue(L"%s",&stg6,propertyObj,L".SID");
dhGetValue(L"%s",&stg7,propertyObj,L".Status");

sprintf(uad[uacounter].caption,"%s",stg1);
sprintf(uad[uacounter].description,"%s",stg2);
sprintf(uad[uacounter].domain,"%s",stg3);
sprintf(uad[uacounter].fullName,"%s",stg4);
sprintf(uad[uacounter].name,"%s",stg5);
sprintf(uad[uacounter].sid,"%s",stg6);
sprintf(uad[uacounter].status,"%s",stg7);

dhGetValue(L"%u",&num1,propertyObj,L".AccountType");
dhGetValue(L"%b",&tf,propertyObj,L".Disabled");
if (tf!=FALSE)
num2=1;
else
num2=0;
dhGetValue(L"%b",&tf,propertyObj,L".LocalAccount");
if (tf!=FALSE)
num3=1;
else
num3=0;
dhGetValue(L"%b",&tf,propertyObj,L".Lockout");
if (tf!=FALSE)
num4=1;
else
num4=0;
dhGetValue(L"%b",&tf,propertyObj,L".PasswordChangable");
if (tf!=FALSE)
num5=1;
else
num5=0;
dhGetValue(L"%b",&tf,propertyObj,L".PasswordExpires");
if (tf!=FALSE)
num6=1;
else
num6=0;
dhGetValue(L"%b",&tf,propertyObj,L".PasswordRequired");
if (tf!=FALSE)
num7=1;
else
num7=0;
dhGetValue(L"%u",&num8,propertyObj,L".SIDType");

uad[uacounter].accountType=num1;
uad[uacounter].disabled=num2;
uad[uacounter].localAccount=num3;
uad[uacounter].lockout=num4;
uad[uacounter].passwordChangable=num5;
uad[uacounter].passwordExpires=num6;
uad[uacounter].passwordRequired=num7;
uad[uacounter].sidType=num8;

uacounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return uacounter;
}

void __declspec(dllexport) Get_UAInfo(int index,struct uaPointers *uaPtr)
{
uaPtr->accountType=uad[index].accountType;
uaPtr->disabled=uad[index].disabled;
uaPtr->localAccount=uad[index].localAccount;
uaPtr->lockout=uad[index].lockout;
uaPtr->passwordChangable=uad[index].passwordChangable;
uaPtr->passwordExpires=uad[index].passwordExpires;
uaPtr->passwordRequired=uad[index].passwordRequired;
uaPtr->sidType=uad[index].sidType;
uaPtr->caption=(int)&uad[index].caption;
uaPtr->description=(int)&uad[index].description;
uaPtr->domain=(int)&uad[index].domain;
uaPtr->fullName=(int)&uad[index].fullName;
uaPtr->name=(int)&uad[index].name;
uaPtr->sid=(int)&uad[index].sid;
uaPtr->status=(int)&uad[index].status;
}

int __declspec(dllexport) Get_VIDEOData(void)
{
videocounter=0;
unsigned int num1=0,num2=0,num3=0,num4=0,num5=0,num6=0,num7=0,num8=0,num9=0,num10=0,num11=0,num12=0,num13=0,num14=0,num15=0,num16=0,num17=0,num18=0,num19=0,num20=0,num21=0,num22=0,num23=0,num24=0,num25=0,num26=0,num27=0,num28=0,num29;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_VideoController");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL,stg11=NULL,stg12=NULL,stg13=NULL,stg14=NULL,stg15=NULL;

dhGetValue(L"%s",&stg1,propertyObj,L".AdapterCompatibility");
dhGetValue(L"%s",&stg2,propertyObj,L".AdapterDACType");
dhGetValue(L"%s",&stg3,propertyObj,L".CompatibilityDescriptions");
dhGetValue(L"%s",&stg4,propertyObj,L".Caption");
dhGetValue(L"%s",&stg5,propertyObj,L".Description");
dhGetValue(L"%s",&stg6,propertyObj,L".DeviceID");
dhGetValue(L"%s",&stg7,propertyObj,L".DriverVersion");
dhGetValue(L"%s",&stg8,propertyObj,L".InfFilename");
dhGetValue(L"%s",&stg9,propertyObj,L".InfSection");
dhGetValue(L"%s",&stg10,propertyObj,L".InstalledDisplayDrivers");
dhGetValue(L"%s",&stg11,propertyObj,L".Name");
dhGetValue(L"%s",&stg12,propertyObj,L".PNPDeviceID");
dhGetValue(L"%s",&stg13,propertyObj,L".Status");
dhGetValue(L"%s",&stg14,propertyObj,L".VideoModeDescription");
dhGetValue(L"%s",&stg15,propertyObj,L".VideoProcessor");

sprintf(videod[videocounter].adapterCompatibility,"%s",stg1);
sprintf(videod[videocounter].adapterDACType,"%s",stg2);
sprintf(videod[videocounter].compatibilityDescriptions,"%s",stg3);
sprintf(videod[videocounter].caption,"%s",stg4);
sprintf(videod[videocounter].description,"%s",stg5);
sprintf(videod[videocounter].deviceID,"%s",stg6);
sprintf(videod[videocounter].driverVersion,"%s",stg7);
sprintf(videod[videocounter].infFilename,"%s",stg8);
sprintf(videod[videocounter].infSection,"%s",stg9);
sprintf(videod[videocounter].installedDisplayDrivers,"%s",stg10);
sprintf(videod[videocounter].name,"%s",stg11);
sprintf(videod[videocounter].pnpDeviceID,"%s",stg12);
sprintf(videod[videocounter].status,"%s",stg13);
sprintf(videod[videocounter].videoModeDescription,"%s",stg14);
sprintf(videod[videocounter].videoProcessor,"%s",stg15);

dhGetValue(L"%u",&num1,propertyObj,L".AdapterRAM");
dhGetValue(L"%u",&num2,propertyObj,L".Availability");
dhGetValue(L"%u",&num3,propertyObj,L".ColorTableEntries");
dhGetValue(L"%u",&num4,propertyObj,L".CurrentBitsPerPixel");
dhGetValue(L"%u",&num5,propertyObj,L".CurrentHorizontalResolution");
dhGetValue(L"%u",&num6,propertyObj,L".CurrentNumberOfColumns");
dhGetValue(L"%u",&num7,propertyObj,L".CurrentNumberOfRows");
dhGetValue(L"%u",&num8,propertyObj,L".CurrentRefreshRate");
dhGetValue(L"%u",&num9,propertyObj,L".CurrentScanMode");
dhGetValue(L"%u",&num10,propertyObj,L".CurrentVerticalResolution");
dhGetValue(L"%u",&num11,propertyObj,L".DeviceSpecificPens");
dhGetValue(L"%u",&num12,propertyObj,L".DitherType");
dhGetValue(L"%u",&num13,propertyObj,L".ICMIntent");
dhGetValue(L"%u",&num14,propertyObj,L".ICMMethod");
dhGetValue(L"%u",&num15,propertyObj,L".MaxMemorySupported");
dhGetValue(L"%u",&num16,propertyObj,L".MaxNumberControlled");
dhGetValue(L"%u",&num17,propertyObj,L".MaxRefreshRate");
dhGetValue(L"%u",&num18,propertyObj,L".MinRefreshRate");
dhGetValue(L"%u",&num19,propertyObj,L".Monochrome");
dhGetValue(L"%u",&num20,propertyObj,L".NumberOfColorPlanes");
dhGetValue(L"%u",&num21,propertyObj,L".NumberOfVideoPages");
dhGetValue(L"%u",&num22,propertyObj,L".ProtocolSupported");
dhGetValue(L"%u",&num23,propertyObj,L".ReservedSystemPaletteEntries");
dhGetValue(L"%u",&num24,propertyObj,L".SpecificationVersion");
dhGetValue(L"%u",&num25,propertyObj,L".StatusInfo");
dhGetValue(L"%u",&num26,propertyObj,L".SystemPaletteEntries");
dhGetValue(L"%u",&num27,propertyObj,L".VideoArchitecture");
dhGetValue(L"%u",&num28,propertyObj,L".VideoMemoryType");
dhGetValue(L"%u",&num29,propertyObj,L".VideoMode");

videod[videocounter].adapterRAM=num1;
videod[videocounter].availability=num2;
videod[videocounter].colorTableEntries=num3;
videod[videocounter].currentBitsPerPixel=num4;
videod[videocounter].currentHorizontalResolution=num5;
videod[videocounter].currentNumberOfColumns=num6;
videod[videocounter].currentNumberOfRows=num7;
videod[videocounter].currentRefreshRate=num8;
videod[videocounter].currentScanMode=num9;
videod[videocounter].currentVerticalResolution=num10;
videod[videocounter].deviceSpecificPens=num11;
videod[videocounter].ditherType=num12;
videod[videocounter].icmIntent=num13;
videod[videocounter].icmMethod=num14;
videod[videocounter].maxMemorySupported=num15;
videod[videocounter].maxNumberControlled=num16;
videod[videocounter].maxRefreshRate=num17;
videod[videocounter].minRefreshRate=num18;
videod[videocounter].monochrome=num19;
videod[videocounter].numberOfColorPlanes=num20;
videod[videocounter].numberOfVideoPages=num21;
videod[videocounter].protocolSupported=num22;
videod[videocounter].reservedSystemPaletteEntries=num23;
videod[videocounter].specificationVersion=num24;
videod[videocounter].statusInfo=num25;
videod[videocounter].systemPaletteEntries=num26;
videod[videocounter].videoArchitecture=num27;
videod[videocounter].videoMemoryType=num28;
videod[videocounter].videoMode=num29;

videocounter+=1;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
dhFreeString(stg11);
dhFreeString(stg12);
dhFreeString(stg13);
dhFreeString(stg14);
dhFreeString(stg15);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
return videocounter;
}

void __declspec(dllexport) Get_VIDEOInfo(int index,struct videoPointers *videoPtr)
{
videoPtr->adapterRAM=videod[index].adapterRAM;
videoPtr->availability=videod[index].availability;
videoPtr->colorTableEntries=videod[index].colorTableEntries;
videoPtr->currentBitsPerPixel=videod[index].currentBitsPerPixel;
videoPtr->currentHorizontalResolution=videod[index].currentHorizontalResolution;
videoPtr->currentNumberOfColumns=videod[index].currentNumberOfColumns;
videoPtr->currentNumberOfRows=videod[index].currentNumberOfRows;
videoPtr->currentRefreshRate=videod[index].currentRefreshRate;
videoPtr->currentScanMode=videod[index].currentScanMode;
videoPtr->currentVerticalResolution=videod[index].currentVerticalResolution;
videoPtr->deviceSpecificPens=videod[index].deviceSpecificPens;
videoPtr->ditherType=videod[index].ditherType;
videoPtr->icmIntent=videod[index].icmIntent;
videoPtr->icmMethod=videod[index].icmMethod;
videoPtr->maxMemorySupported=videod[index].maxMemorySupported;
videoPtr->maxNumberControlled=videod[index].maxNumberControlled;
videoPtr->maxRefreshRate=videod[index].maxRefreshRate;
videoPtr->minRefreshRate=videod[index].minRefreshRate;
videoPtr->monochrome=videod[index].monochrome;
videoPtr->numberOfColorPlanes=videod[index].numberOfColorPlanes;
videoPtr->numberOfVideoPages=videod[index].numberOfVideoPages;
videoPtr->protocolSupported=videod[index].protocolSupported;
videoPtr->reservedSystemPaletteEntries=videod[index].reservedSystemPaletteEntries;
videoPtr->specificationVersion=videod[index].specificationVersion;
videoPtr->statusInfo=videod[index].statusInfo;
videoPtr->systemPaletteEntries=videod[index].systemPaletteEntries;
videoPtr->videoArchitecture=videod[index].videoArchitecture;
videoPtr->videoMemoryType=videod[index].videoMemoryType;
videoPtr->videoMode=videod[index].videoMode;
videoPtr->adapterCompatibility=(int)&videod[index].adapterCompatibility;
videoPtr->adapterDACType=(int)&videod[index].adapterDACType;
videoPtr->compatibilityDescriptions=(int)&videod[index].compatibilityDescriptions;
videoPtr->caption=(int)&videod[index].caption;
videoPtr->description=(int)&videod[index].description;
videoPtr->deviceID=(int)&videod[index].deviceID;
videoPtr->driverVersion=(int)&videod[index].driverVersion;
videoPtr->infFilename=(int)&videod[index].infFilename;
videoPtr->infSection=(int)&videod[index].infSection;
videoPtr->installedDisplayDrivers=(int)&videod[index].installedDisplayDrivers;
videoPtr->name=(int)&videod[index].name;
videoPtr->pnpDeviceID=(int)&videod[index].pnpDeviceID;
videoPtr->status=(int)&videod[index].status;
videoPtr->videoModeDescription=(int)&videod[index].videoModeDescription;
videoPtr->videoProcessor=(int)&videod[index].videoProcessor;
}

void __declspec(dllexport) Get_OSInfo(struct osPointers *osPtr)
{
BOOL tf=FALSE;
dhInitialize(TRUE);
dhToggleExceptions(FALSE);
DISPATCH_OBJ(wmiSvc);
DISPATCH_OBJ(classObj);
dhGetObject(L"winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\cimv2",NULL,&wmiSvc);
dhGetValue(L"%o",&classObj,wmiSvc,L".ExecQuery(%S)",L"SELECT * FROM Win32_OperatingSystem");
FOR_EACH(propertyObj,classObj,NULL)
{
LPSTR stg1=NULL,stg2=NULL,stg3=NULL,stg4=NULL,stg5=NULL,stg6=NULL,stg7=NULL,stg8=NULL,stg9=NULL,stg10=NULL,stg11=NULL,stg12=NULL,stg13=NULL,stg14=NULL,stg15=NULL,stg16=NULL,stg17=NULL,stg18=NULL,stg19=NULL,stg20=NULL;

dhGetValue(L"%u",&osd.currentTimeZone,propertyObj,L".CurrentTimeZone");
osPtr->currentTimeZone=osd.currentTimeZone;
dhGetValue(L"%u",&osd.numOfUsers,propertyObj,L".NumberOfUsers");
osPtr->numOfUsers=osd.numOfUsers;
dhGetValue(L"%u",&osd.osLanguage,propertyObj,L".OSLanguage");
osPtr->osLanguage=osd.osLanguage;
dhGetValue(L"%u",&osd.osType,propertyObj,L".OSType");
osPtr->osType=osd.osType;
dhGetValue(L"%b",&tf,propertyObj,L".Primary");
if (tf==FALSE)
osd.primary=0;
else
osd.primary=1;
osPtr->primary=osd.primary;
dhGetValue(L"%u",&osd.spMajorVersion,propertyObj,L".ServicePackMajorVersion");
osPtr->spMajorVersion=osd.spMajorVersion;
dhGetValue(L"%u",&osd.spMinorVersion,propertyObj,L".ServicePackMinorVersion");
osPtr->spMinorVersion=osd.spMinorVersion;

dhGetValue(L"%s",&stg1,propertyObj,L".BootDevice");
dhGetValue(L"%s",&stg2,propertyObj,L".BuildNumber");
dhGetValue(L"%s",&stg3,propertyObj,L".BuildType");
dhGetValue(L"%s",&stg4,propertyObj,L".Caption");
dhGetValue(L"%s",&stg5,propertyObj,L".CodeSet");
dhGetValue(L"%s",&stg6,propertyObj,L".CountryCode");
dhGetValue(L"%s",&stg7,propertyObj,L".Description");
dhGetValue(L"%s",&stg8,propertyObj,L".Locale");
dhGetValue(L"%s",&stg9,propertyObj,L".Manufacturer");
dhGetValue(L"%s",&stg10,propertyObj,L".Name");
dhGetValue(L"%s",&stg11,propertyObj,L".Organization");
dhGetValue(L"%s",&stg12,propertyObj,L".RegisteredUser");
dhGetValue(L"%s",&stg13,propertyObj,L".SerialNumber");
dhGetValue(L"%s",&stg14,propertyObj,L".Status");
dhGetValue(L"%s",&stg15,propertyObj,L".SystemDevice");
dhGetValue(L"%s",&stg16,propertyObj,L".SystemDirectory");
dhGetValue(L"%s",&stg17,propertyObj,L".SystemDrive");
dhGetValue(L"%s",&stg18,propertyObj,L".Version");
dhGetValue(L"%s",&stg19,propertyObj,L".WindowsDirectory");

strcpy(osd.bootDevice,stg1);
osPtr->bootDevice=(int)&osd.bootDevice;
strcpy(osd.buildNumber,stg2);
osPtr->buildNumber=(int)&osd.buildNumber;
strcpy(osd.buildType,stg3);
osPtr->buildType=(int)&osd.buildType;
strcpy(osd.caption,stg4);
osPtr->caption=(int)&osd.caption;
strcpy(osd.codeSet,stg5);
osPtr->codeSet=(int)&osd.codeSet;
strcpy(osd.countryCode,stg6);
osPtr->countryCode=(int)&osd.countryCode;
strcpy(osd.description,stg7);
osPtr->description=(int)&osd.description;
strcpy(osd.locale,stg8);
osPtr->locale=(int)&osd.locale;
strcpy(osd.manufacturer,stg9);
osPtr->manufacturer=(int)&osd.manufacturer;
strcpy(osd.name,stg10);
osPtr->name=(int)&osd.name;
strcpy(osd.organization,stg11);
osPtr->organization=(int)&osd.organization;
strcpy(osd.registeredUser,stg12);
osPtr->registeredUser=(int)&osd.registeredUser;
strcpy(osd.serialNumber,stg13);
osPtr->serialNumber=(int)&osd.serialNumber;
strcpy(osd.status,stg14);
osPtr->status=(int)&osd.status;
strcpy(osd.systemDevice,stg15);
osPtr->systemDevice=(int)&osd.systemDevice;
strcpy(osd.systemDirectory,stg16);
osPtr->systemDirectory=(int)&osd.systemDirectory;
strcpy(osd.systemDrive,stg17);
osPtr->systemDrive=(int)&osd.systemDrive;
strcpy(osd.version,stg18);
osPtr->version=(int)&osd.version;
strcpy(osd.windowsDirectory,stg19);
osPtr->windowsDirectory=(int)&osd.windowsDirectory;

dhFreeString(stg1);
dhFreeString(stg2);
dhFreeString(stg3);
dhFreeString(stg4);
dhFreeString(stg5);
dhFreeString(stg6);
dhFreeString(stg7);
dhFreeString(stg8);
dhFreeString(stg9);
dhFreeString(stg10);
dhFreeString(stg11);
dhFreeString(stg12);
dhFreeString(stg13);
dhFreeString(stg14);
dhFreeString(stg15);
dhFreeString(stg16);
dhFreeString(stg17);
dhFreeString(stg18);
dhFreeString(stg19);
dhFreeString(stg20);
} NEXT(propertyObj);
SAFE_RELEASE(classObj);
SAFE_RELEASE(wmiSvc);
dhUninitialize(TRUE);
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:

break;
case DLL_PROCESS_DETACH:

break;
case DLL_THREAD_ATTACH:

break;
case DLL_THREAD_DETACH:

break;
}
return TRUE;
}
