// Link with: vfw32.lib avicap32.lib

#include <commctrl.h>
#include <vfw.h>

typedef struct WCInfo
{
DWORD biSize;
LONG biWidth;
LONG biHeight;
WORD biPlanes;
WORD biBitCount;
DWORD biCompression;
DWORD biSizeImage;
LONG biXPelsPerMeter;
LONG biYPelsPerMeter;
DWORD biClrUsed;
DWORD biClrImportant;
WORD wFormatTag;
WORD nChannels;
DWORD nSamplesPerSec;
DWORD nAvgBytesPerSec;
WORD nBlockAlign;
WORD wBitsPerSample;
WORD cbSize;
} WCData;

WCData wcd;

typedef struct wcIdentity
{
char name[100];
char description[100];
BYTE count;
} wcID;

wcID wci[10];

typedef struct stringInfo
{
char description[100];
} stringData;

stringData sd;

WNDPROC cbFunction;
HWND cbWindow,wcHandle,pwHandle;
LONG oldProc;

CAPDRIVERCAPS CapDrvCaps;
CAPTUREPARMS cparms;
CAPSTATUS CapSts;
BITMAPINFO bmi;
WAVEFORMATEX wfe;
HDC wnd0dc;
BYTE errorStatus=0,statusStatus=0,frameStatus=0,frameCount=0,videoStatus=0,waveStatus=0;

int rtn=0;

LRESULT CALLBACK errorCB(HWND hwcWnd,int errorID,LPSTR errorText)
{
CallWindowProc(cbFunction,pwHandle,1101,(WPARAM)(int)errorID,(LPARAM)(char *)errorText);
return (LRESULT) TRUE;
}

LRESULT CALLBACK statusCB(HWND hwcWnd,int statusID,LPSTR statusText)
{
CallWindowProc(cbFunction,pwHandle,1102,(WPARAM)(int)statusID,(LPARAM)(char *)statusText);
return (LRESULT) TRUE;
}

LRESULT CALLBACK frameCB(HWND hwcWnd,LPVIDEOHDR lpVHdr)
{
if (hwcWnd)
{
capGetVideoFormat(hwcWnd,&bmi,sizeof(BITMAPINFO));
capGetAudioFormat(hwcWnd,&wfe,sizeof(WAVEFORMATEX));

wnd0dc=GetDC(pwHandle);
if (wnd0dc)
{
if (lpVHdr->lpData)
{
wcd.biSize=bmi.bmiHeader.biSize;
wcd.biWidth=bmi.bmiHeader.biWidth;
wcd.biHeight=bmi.bmiHeader.biHeight;
wcd.biPlanes=bmi.bmiHeader.biPlanes;
wcd.biBitCount=bmi.bmiHeader.biBitCount;
wcd.biCompression=bmi.bmiHeader.biCompression;
wcd.biSizeImage=bmi.bmiHeader.biSizeImage;
wcd.biXPelsPerMeter=bmi.bmiHeader.biXPelsPerMeter;
wcd.biYPelsPerMeter=bmi.bmiHeader.biYPelsPerMeter;
wcd.biClrUsed=bmi.bmiHeader.biClrUsed;
wcd.biClrImportant=bmi.bmiHeader.biClrImportant;
wcd.wFormatTag=wfe.wFormatTag;
wcd.nChannels=wfe.nChannels;
wcd.nSamplesPerSec=wfe.nSamplesPerSec;
wcd.nAvgBytesPerSec=wfe.nAvgBytesPerSec;
wcd.nBlockAlign=wfe.nBlockAlign;
wcd.wBitsPerSample=wfe.wBitsPerSample;
wcd.cbSize=wfe.cbSize;
CallWindowProc(cbFunction,pwHandle,1100,(WPARAM)(LPVOID)lpVHdr->lpData,(LPARAM)(LPBITMAPINFO)&bmi);
}
ReleaseDC(hwcWnd,wnd0dc);
}

}
return (LRESULT) TRUE;
}

LRESULT CALLBACK newProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
switch (uMsg)
{
case WM_CLOSE:
CallWindowProc(cbFunction,hWnd,uMsg,wParam,lParam);
return 0;
case WM_DESTROY:
CallWindowProc(cbFunction,hWnd,uMsg,wParam,lParam);
return 0;
default:
return CallWindowProc((WNDPROC)oldProc,hWnd,uMsg,wParam,lParam);
}
}

void __declspec(dllexport) GetWCData(struct WCInfo *wciPtr)
{
wciPtr->biSize=wcd.biSize;
wciPtr->biWidth=wcd.biWidth;
wciPtr->biHeight=wcd.biHeight;
wciPtr->biPlanes=wcd.biPlanes;
wciPtr->biBitCount=wcd.biBitCount;
wciPtr->biCompression=wcd.biCompression;
wciPtr->biSizeImage=wcd.biSizeImage;
wciPtr->biXPelsPerMeter=wcd.biXPelsPerMeter;
wciPtr->biYPelsPerMeter=wcd.biYPelsPerMeter;
wciPtr->biClrUsed=wcd.biClrUsed;
wciPtr->biClrImportant=wcd.biClrImportant;
wciPtr->wFormatTag=wcd.wFormatTag;
wciPtr->nChannels=wcd.nChannels;
wciPtr->nSamplesPerSec=wcd.nSamplesPerSec;
wciPtr->nAvgBytesPerSec=wcd.nAvgBytesPerSec;
wciPtr->nBlockAlign=wcd.nBlockAlign;
wciPtr->wBitsPerSample=wcd.wBitsPerSample;
wciPtr->cbSize=wcd.cbSize;
}

HWND __declspec(dllexport) CreateWCWindow(char *title,int x,int y,int w,int h,HWND parentWnd,int id)
{
wcHandle=capCreateCaptureWindow(title,WS_CHILD|WS_VISIBLE,x,y,w,h,parentWnd,id);
if (wcHandle!=NULL)
{
pwHandle=parentWnd;
return wcHandle;
}
return 0;
}

int __declspec(dllexport) ConnectDriver(int deviceNumber)
{
if (wcHandle!=NULL)
return capDriverConnect(wcHandle,deviceNumber);
return 0;
}

int __declspec(dllexport) DisconnectDriver(void)
{
if (wcHandle!=NULL)
return capDriverDisconnect(wcHandle);
return 0;
}

int __declspec(dllexport) GetHWCapabilities(void)
{
if (wcHandle!=NULL)
return capDriverGetCaps(wcHandle,&CapDrvCaps,sizeof(CAPDRIVERCAPS));
return 0;
}

void __declspec(dllexport) GetIDs(void)
{
BYTE wcIndex=0,counter=0;
char name[100],description[100];
for (wcIndex=0;wcIndex<10;wcIndex++)
{
if (capGetDriverDescription(wcIndex,name,100,description,100))
{
strcpy(wci[counter].name,name);
strcpy(wci[counter].description,description);
counter+=1;
}
}
wci[0].count=counter;
if (counter<10)
{
strcpy(wci[counter].name,"");
strcpy(wci[counter].description,"");
}
}

int __declspec(dllexport) GetIDCount(void)
{
int amount=wci[0].count;
return amount;
}

stringData * __declspec(dllexport) GetIDName(BYTE number)
{
strcpy(sd.description,wci[number].name);
return &sd;
}

stringData * __declspec(dllexport) GetIDDescription(BYTE number)
{
strcpy(sd.description,wci[number].description);
return &sd;
}

int __declspec(dllexport) GetCurrentSettings(void)
{
if (wcHandle!=NULL)
return capCaptureGetSetup(wcHandle,&cparms,sizeof(CAPTUREPARMS));
return 0;
}

BOOL __declspec(dllexport) DidItInitialize(void)
{
if (wcHandle!=NULL)
return CapDrvCaps.fCaptureInitialized;
return FALSE;
}

BOOL __declspec(dllexport) CheckForOverlay(void)
{
if (wcHandle!=NULL)
return CapDrvCaps.fHasOverlay;
return FALSE;
}

BOOL __declspec(dllexport) SetFrameCallback(BOOL offOn)
{
if (wcHandle!=NULL)
{
if (offOn==FALSE && frameStatus!=0)
frameStatus=capSetCallbackOnFrame(wcHandle,NULL);
else if (offOn==TRUE && frameStatus==0)
frameStatus=capSetCallbackOnFrame(wcHandle,frameCB);
return frameStatus;
}
return FALSE;
}

BOOL __declspec(dllexport) SetErrorCallback(BOOL offOn)
{
if (wcHandle!=NULL)
{
if (offOn==FALSE && errorStatus!=0)
errorStatus=capSetCallbackOnError(wcHandle,NULL);
else if (offOn==TRUE && errorStatus==0)
errorStatus=capSetCallbackOnError(wcHandle,errorCB);
return errorStatus;
}
return FALSE;
}

BOOL __declspec(dllexport) SetStatusCallback(BOOL offOn)
{
if (wcHandle!=NULL)
{
if (offOn==FALSE && statusStatus!=0)
statusStatus=capSetCallbackOnStatus(wcHandle,NULL);
else if (offOn==TRUE && statusStatus==0)
statusStatus=capSetCallbackOnStatus(wcHandle,statusCB);
return statusStatus;
}
return FALSE;
}

int __declspec(dllexport) GetCWCapabilities(void)
{
if (wcHandle!=NULL)
return capGetStatus(wcHandle,&CapSts,sizeof(CAPSTATUS));
return 0;
}

int __declspec(dllexport) SetPreviewRate(int msRate)
{
if (wcHandle!=NULL)
return capPreviewRate(wcHandle,msRate);
return 0;
}

int __declspec(dllexport) SetPreview(BOOL offOn)
{
if (wcHandle!=NULL)
return capPreview(wcHandle,offOn);
return 0;
}

int __declspec(dllexport) ScalePreview(BOOL offOn)
{
if (wcHandle!=NULL)
return capPreviewScale(wcHandle,offOn);
return 0;
}

int __declspec(dllexport) SetOverlay(BOOL offOn)
{
if (wcHandle!=NULL)
return capOverlay(wcHandle,offOn);
return 0;
}

int __declspec(dllexport) SetOKMessage(BOOL offOn)
{
if (wcHandle!=NULL)
{
cparms.fMakeUserHitOKToCapture=offOn;
return capCaptureSetSetup(wcHandle,&cparms,sizeof(CAPTUREPARMS));
}
return 0;
}

int __declspec(dllexport) SetYield(BOOL offOn)
{
if (wcHandle!=NULL)
{
cparms.fYield=offOn;
return capCaptureSetSetup(wcHandle,&cparms,sizeof(CAPTUREPARMS));
}
return 0;
}

int __declspec(dllexport) SetRecordTime(BOOL offOn,int recordTime)
{
if (wcHandle!=NULL)
{
cparms.wTimeLimit=recordTime;
cparms.fLimitEnabled=offOn;
return capCaptureSetSetup(wcHandle,&cparms,sizeof(CAPTUREPARMS));
}
return 0;
}

int __declspec(dllexport) SetFileSize(int fSize)
{
if (wcHandle!=NULL)
return capFileAlloc(wcHandle,fSize);
return 0;
}

int __declspec(dllexport) SetFileName(char *fname)
{
if (wcHandle!=NULL)
return capFileSetCaptureFile(wcHandle,fname);
return 0;
}

int __declspec(dllexport) SaveFileAs(char *fname)
{
if (wcHandle!=NULL)
return capFileSaveAs(wcHandle,fname);
return 0;
}

int __declspec(dllexport) StartRecording(BOOL withFile)
{
if (wcHandle!=NULL)
{
if (withFile==TRUE)
return capCaptureSequence(wcHandle);
return capCaptureSequenceNoFile(wcHandle);
}
return 0;
}

int __declspec(dllexport) StopRecording(void)
{
if (wcHandle!=NULL)
return capCaptureStop(wcHandle);
return 0;
}

int __declspec(dllexport) AbortRecording(void)
{
if (wcHandle!=NULL)
return capCaptureAbort(wcHandle);
return 0;
}

int __declspec(dllexport) GrabFrame(BOOL freeze)
{
if (wcHandle!=NULL)
{
if (freeze==TRUE)
return capGrabFrame(wcHandle);
return capGrabFrameNoStop(wcHandle);
}
return 0;
}

int __declspec(dllexport) SaveFrameAsDIB(char *fname)
{
if (wcHandle!=NULL)
return capFileSaveDIB(wcHandle,fname);
return 0;
}

int __declspec(dllexport) SavePALAsFile(char *fname)
{
if (wcHandle!=NULL)
return capPaletteSave(wcHandle,fname);
return 0;
}

int __declspec(dllexport) CreateNewPalette(BOOL offOn)
{
if (wcHandle!=NULL)
return capPaletteManual(wcHandle,offOn,256);
return 0;
}

int __declspec(dllexport) AutoCreateNewPalette(int frames)
{
if (wcHandle!=NULL)
return capPaletteAuto(wcHandle,frames,256);
return 0;
}

int __declspec(dllexport) LoadPALFile(char *fname)
{
if (wcHandle!=NULL)
return capPaletteOpen(wcHandle,fname);
return 0;
}

int __declspec(dllexport) PasteCBPAL(void)
{
if (wcHandle!=NULL)
return capPalettePaste(wcHandle);
return 0;
}

int __declspec(dllexport) FrameToClipboard(void)
{
if (wcHandle!=NULL)
return capEditCopy(wcHandle);
return 0;
}

int __declspec(dllexport) SingleFrameOpen(void)
{
if (wcHandle!=NULL)
return capCaptureSingleFrameOpen(wcHandle);
return 0;
}

int __declspec(dllexport) SingleFrameAppend(void)
{
if (wcHandle!=NULL)
return capCaptureSingleFrame(wcHandle);
return 0;
}

int __declspec(dllexport) SingleFrameClose(void)
{
if (wcHandle!=NULL)
return capCaptureSingleFrameClose(wcHandle);
return 0;
}

int __declspec(dllexport) InsertChunk(FOURCC id,LPVOID chunkData,LONG cdSize)
{
if (wcHandle!=NULL)
{
CAPINFOCHUNK cic;
cic.fccInfoID=id;
cic.lpData=chunkData;
cic.cbData=cdSize;
return capFileSetInfoChunk(wcHandle,&cic);
}
return 0;
}

int __declspec(dllexport) VideoCompressionDialog(void)
{
if (wcHandle!=NULL)
return capDlgVideoCompression(wcHandle);
return 0;
}

int __declspec(dllexport) VideoDisplayDialog(void)
{
if (wcHandle!=NULL)
{
if (CapDrvCaps.fHasDlgVideoDisplay)
return capDlgVideoDisplay(wcHandle);
}
return 0;
}

int __declspec(dllexport) VideoFormatDialog(void)
{
if (wcHandle!=NULL)
{
if (CapDrvCaps.fHasDlgVideoFormat)
rtn=capDlgVideoFormat(wcHandle);
}
return 0;
}

int __declspec(dllexport) VideoSourceDialog(void)
{
if (wcHandle!=NULL)
{
if (CapDrvCaps.fHasDlgVideoSource)
rtn=capDlgVideoSource(wcHandle);
}
return 0;
}

LONG __declspec(dllexport) StopCatching(void)
{
if (IsWindow(cbWindow))
return SetWindowLong(cbWindow,GWL_WNDPROC,(LONG)oldProc);
return 0;
}

BOOL __declspec(dllexport) CatchMessages(HWND cbWnd,WNDPROC cbAdr)
{
if (IsWindow(cbWnd))
{
if (cbAdr)
{
cbWindow=cbWnd;
cbFunction=cbAdr;
SetLastError(0);
oldProc=SetWindowLong(cbWnd,GWL_WNDPROC,(LONG)newProc);
if (oldProc!=0)
return TRUE;
}
}
return FALSE;
}

BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst,DWORD fdwReason,LPVOID lpvReserved)
{
switch (fdwReason)
{
case DLL_PROCESS_ATTACH:
case DLL_THREAD_ATTACH:
case DLL_THREAD_DETACH:
case DLL_PROCESS_DETACH:
//StopCatching();
break;
}
return TRUE;
}
